function calibration(params)

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !!!!  Kazushige MATSUDA
  !!!!  "Progressive Taxation vs College Subsidies with College Dropout"
  !!!!
  !!!!
  !!!!  Routine to solve for equilibrium to calibrate
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  use nrtype
  use globals
  use interface, only : modelsolution, param, modelmoments, valuev, util
  use nr, only : polint, locate

  implicit none

  REAL(DP), DIMENSION(:), INTENT(IN) :: params
  REAL(DP) :: calibration
  integer :: fo,iii,ITT,aa2

  if (nodropout==1) then

    bopt0 =0.0d0
    bopt1 =0.0d0
    lambda0 = params(1)
    lambda1=params(2)
    kappa =paramsbench(5)
    mmu =paramsbench(6)
    bbetarate =paramsbench(7)
    vv =paramsbench(8)
    d =paramsbench(9)
    iota =paramsbench(10)
    mupbar =paramsbench(11)
    ssigmae =paramsbench(12)
    elast=params(3)
    stddc =0.0001d0
    elast2=elast
    a1 = params(4)
    a2 =paramsbench(17)

    afqtcoeff(1) = paramsbench(18)
    afqtcoeff(2) = paramsbench(19)
    afqtcoeff(3) = paramsbench(20)

  else

    if (heterostddc==1) then
      bopt0 = 0.0d0
      bopt1 = 0.0d0
      lambda0 = params(1)
      lambda1=params(2)
      kappa = params(3)
      mmu = params(4)
      bbetarate = params(5)
      vv = max(min(params(6),1.0d0-m),0.00d0)
      d = params(7)
      iota = params(8)
      mupbar = params(9)
      ssigmae = params(10)
      elast=params(11)
      stddc=params(12)
      elast2=params(13)
      a1 = params(14)
      a2=params(15)
      stddc1=params(16)
      afqtcoeff(1) = params(17)
      afqtcoeff(2) = params(18)
      afqtcoeff(3) = params(19)
    else

      if(i_common_loading==1)then

        bopt0 = params(1)
        bopt1 = params(2)
        lambda0 = params(3)
        lambda1=params(4)
        kappa = params(5)
        mmu = params(6)
        bbetarate = params(7)
        vv = max(min(params(8),1.0d0-m),0.00d0)
        d = params(9)
        iota = params(10)
        mupbar = params(11)
        ssigmae = params(12)
        elast=params(13)
        stddc=params(14)
        elast2=params(13)
        a1 = params(15)
        a2=params(16)
        afqtcoeff(1) = params(17)
        afqtcoeff(2) = params(18)
        afqtcoeff(3) = params(19)

      else
      bopt0 = params(1)
      bopt1 = params(2)
      lambda0 = params(3)
      lambda1=params(4)
      kappa = params(5)
      mmu = params(6)
      bbetarate = params(7)
      vv = max(min(params(8),1.0d0-m),0.00d0)
      d = params(9)
      iota = params(10)
      mupbar = params(11)
      ssigmae = params(12)
      elast=params(13)
      stddc=params(14)
      elast2=params(15)
      a1 = params(16)
      a2=params(17)
      afqtcoeff(1) = params(18)
      afqtcoeff(2) = params(19)
      afqtcoeff(3) = params(20)

    endif

    endif

  endif

  bbeta=1.0d0/(1.0d0+bbetarate)

  if (bbeta>1.0d0) write(*,*) 'bbeta>1'
  if (debug==1) write(*,*) 'params',params

  call param

  do qq=1,qnum
    ttheta(ja,:,qq)=gbase(qq)/ybase
    ttheta(ja+1,:,qq)=gbase(qq)/ybase
  enddo

  K_LL= 1.50077632125939
  LL_N=0.304149525386994
  H_LL1=1.07139196476410
  taul=  0.371032053386774
  ybar = 0.274095921569425

  dddddd=100.0d0
  V00(:,:,:) = 0.0d0
  V(:,:,:,:,:)=0.0d0
  Vr(:,:,:,:)=0.0d0

  calibflag=1
  wel=0

  write(*,*) 'iteration  ', 'distance  '

  do itt=1,40

    call modelsolution
    write(*,*) ITT, dddddd
    if (dddddd<tol) then
      exit
    endif

  enddo

  write(*, *) 'new prices', K_LL, H_LL1, LL_N, taul, ybar

  call modelmoments

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Graduation difference from optimism
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


  do ke=1,kenum
    do eetai=1,2
      do qq=1,qnum
        do hh=1,hnum2
          do aa=1,anum2
            ppws(aa,hh,qq,ja,2,eetai,ke) = (I12pinterp(aa,hh,qq,eetai,ke)*pppp0(aa,hh,qq,eetai,ke))
            ppws(aa,hh,qq,ja,3,eetai,ke) = (1.0d0-I12pinterp(aa,hh,qq,eetai,ke))*pppp0(aa,hh,qq,eetai,ke)
          enddo
        enddo
      enddo
    enddo
  enddo


  ppw(:,:,ja,2,:)=sum(sum(ppws(:,:,:,ja,2,:,:),5),3)
  ppw(:,:,ja,3,:)=sum(sum(ppws(:,:,:,ja,3,:,:),5),3)

  ! jj=ja
  ! s=1

  do thetah=1,hnum2
    do ke=1,kenum
      do eetai=1,2
        do qq=1,qnum
          do hh=1,hnum2
            do aa=1,anum2
              ppws0(aa,hh,qq,ja+1,eetai,ke,thetah) = pepmatopt(thetah,hh)*sum(IIws(:,aa,thetah,qq,2,eetai,ke)*ppws(:,thetah,qq,ja,2,eetai,ke),1)
            enddo
          enddo
        enddo
      enddo
    enddo
  enddo

  ! jj=ja
  ! s=1

  do ke=1,kenum
    do eetai=1,2
      do qq=1,qnum
        do hh=1,hnum2
          do aa=1,anum2
            ppws(aa,hh,qq,ja+1,1,eetai,ke) = &
            pis(2,eetai)*sum(Ipinterp(aa,hh,qq,ja+1,eetai,ke,:)*(ppws0(aa,hh,qq,ja+1,1,ke,:)+ppws0(aa,hh,qq,ja+1,2,ke,:)))
          enddo
        enddo
      enddo
    enddo
  enddo

  do ke=1,kenum
    do eetai=1,2
      do qq=1,qnum
        do hh=1,hnum2
          do aa=1,anum2
            ppws(aa,hh,qq,ja+1,2,eetai,ke) = &
            pis(2,eetai)*sum((1.0d0-Ipinterp(aa,:,qq,ja+1,eetai,ke,hh))*(ppws0(aa,:,qq,ja+1,1,ke,hh)+ppws0(aa,:,qq,ja+1,2,ke,hh)))
          enddo
        enddo
      enddo
    enddo
  enddo

  ppw(:,:,ja+1,1,:)=sum(sum(ppws(:,:,:,ja+1,1,:,:),5),3)
  ppw(:,:,ja+1,2,:)=sum(sum(ppws(:,:,:,ja+1,2,:,:),5),3)

  P1elasopt = sum(ppw(:,:,ja+1,1,:))
  P2elasopt = sum(ppw(:,:,ja+1,2,:))
  P3elasopt = sum(ppw(:,:,ja,3,:))

  write(*,*) 'expeced graduation rate/real graduation rate',(P1elasopt/(P1elasopt+P2elasopt))/(P1/(P1+P2))

  grants00(:,:,:)=grants(:,:,:)

  do qq=1,qnum
    grants(ja,:,qq)=(gbase(qq)+tup)/ybase*ybar
    grants(ja+1,:,qq)=(gbase(qq)+tup)/ybase*ybar
  enddo

  write(*,*) 'grants', grants(ja,1,:)

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Validation 1: pratial equilibrum effect of an 1,000 increase in subsidies
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


  s=1
  jj=ja+1
  do eetai=1,2
    ke=1
    call valuev
  enddo

  s=2
  jj=ja
  do eetai=1,2
    do ke=1,kenum
      call valuev
    enddo
  enddo

  jj=ja+1
  s=1
  do eetai=1,2
    ke=1
    do qq=1,qnum
      do hh=1,hnum
        do aa2=1,anum2
          call polint(agrid(jj,:,s),asmat(:,hh,qq,jj,eetai,ke),agrid2(jj,aa2,s),asmatinterp0(aa2,hh,qq,jj,eetai,ke),dy)
          call polint(agrid(jj,:,s),csmat(:,hh,qq,jj,eetai,ke),agrid2(jj,aa2,s),csmatinterp0(aa2,hh,qq,jj,eetai,ke),dy)
          call polint(agrid(jj,:,s),lsmat(:,hh,qq,jj,eetai,ke),agrid2(jj,aa2,s),lsmatinterp0(aa2,hh,qq,jj,eetai,ke),dy)
        enddo
      enddo


      do hh=1,hnum2
        do aa2=1,anum2
          call polint(hgrid(:),asmatinterp0(aa2,:,qq,jj,eetai,ke),hgrid2(hh),asmatinterp(aa2,hh,qq,jj,eetai,ke),dy)
          call polint(hgrid(:),csmatinterp0(aa2,:,qq,jj,eetai,ke),hgrid2(hh),csmatinterp(aa2,hh,qq,jj,eetai,ke),dy)
          call polint(hgrid(:),lsmatinterp0(aa2,:,qq,jj,eetai,ke),hgrid2(hh),lsmatinterp(aa2,hh,qq,jj,eetai,ke),dy)

          call polint(agrid2(jj+1,:,s),Vinterp(:,hh,jj+1,s,1),asmatinterp(aa2,hh,qq,jj,eetai,ke),Vprime(1),dy)
          call polint(agrid2(jj+1,:,s),Vinterp(:,hh,jj+1,s,2),asmatinterp(aa2,hh,qq,jj,eetai,ke),Vprime(2),dy)

          Vsinterp(aa2,hh,qq,jj,eetai,ke)= util(csmatinterp(aa2,hh,qq,jj,eetai,ke),lsmatinterp(aa2,hh,qq,jj,eetai,ke))+ bbeta*sum(pis(s,:)*Vprime(:))


          do ke2=1,kenum

            Veduc2=Vsinterp(aa2,hh,qq,jj,eetai,1)+lambdaopt(jj,hh,ke2)

            asmatinterp(aa2,hh,qq,jj,eetai,ke2)=asmatinterp(aa2,hh,qq,jj,eetai,1)
            csmatinterp(aa2,hh,qq,jj,eetai,ke2)=csmatinterp(aa2,hh,qq,jj,eetai,1)
            lsmatinterp(aa2,hh,qq,jj,eetai,ke2)=lsmatinterp(aa2,hh,qq,jj,eetai,1)
            Vsinterp(aa2,hh,qq,jj,eetai,ke2)=Vsinterp(aa2,hh,qq,jj,eetai,1)
            hmatsinterp(aa2,hh,qq,jj,eetai,ke2)=hmatsinterp(aa2,hh,qq,jj,eetai,1)
            hssmatinterp(aa2,hh,qq,jj,eetai,ke2)=hssmatinterp(aa2,hh,qq,jj,eetai,1)
            ysmatinterp(aa2,hh,qq,jj,eetai,ke2)=ysmatinterp(aa2,hh,qq,jj,eetai,1)
            borrowindsinterp(aa2,hh,qq,jj,eetai,ke2)=borrowindsinterp(aa2,hh,qq,jj,eetai,1)
            IIws(aa2,:,hh,qq,s,eetai,ke2)=IIws(aa2,:,hh,qq,s,eetai,1)

            do thetah=1,hnum2

              if (agrid2(jj,aa2,s) < 0.0d0) then
                call polint(agrid2(jj,:,s),Vinterp(:,thetah,jj,2,eetai),agrid2(jj,aa2,s)*factor,Vwork,dy)
              else
                Vwork=Vinterp(aa2,thetah,jj,2,eetai)
              endif

              if (Vwork>Veduc2) then
                Ipinterp(aa2,hh,qq,jj,eetai,ke2,thetah) = 0.0d0
                Vpinterp(aa2,hh,qq,jj,eetai,ke2,thetah) = Vwork
              else
                Ipinterp(aa2,hh,qq,jj,eetai,ke2,thetah) = 1.0d0
                Vpinterp(aa2,hh,qq,jj,eetai,ke2,thetah) = Veduc2
              endif

            enddo
          enddo

        enddo
      enddo
    enddo

    do ke=1,kenum
      do qq=1,qnum
        do thetah=1,hnum2
          do aa=1,anum2
            EVpinterp(aa,thetah,qq,jj,eetai,ke)=sum(pepmatopt(thetah,:)*Vpinterp(aa,:,qq,jj,eetai,ke,thetah))
          enddo
        enddo
      enddo
    enddo
  enddo

  jj=ja
  s=2

  do eetai=1,2
    do ke=1,kenum
      do qq=1,qnum
        do hh=1,hnum
         do aa2=1,anum2
          call polint(agrid(jj,:,s),asmat(:,hh,qq,jj,eetai,ke),agrid2(jj,aa2,s),asmatinterp0(aa2,hh,qq,jj,eetai,ke),dy)
          call polint(agrid(jj,:,s),csmat(:,hh,qq,jj,eetai,ke),agrid2(jj,aa2,s),csmatinterp0(aa2,hh,qq,jj,eetai,ke),dy)
          call polint(agrid(jj,:,s),lsmat(:,hh,qq,jj,eetai,ke),agrid2(jj,aa2,s),lsmatinterp0(aa2,hh,qq,jj,eetai,ke),dy)
        enddo
      enddo

      do hh=1,hnum2
        do aa2=1,anum2
          call polint(hgrid(:),asmatinterp0(aa2,:,qq,jj,eetai,ke),hgrid2(hh),asmatinterp(aa2,hh,qq,jj,eetai,ke),dy)
          call polint(hgrid(:),csmatinterp0(aa2,:,qq,jj,eetai,ke),hgrid2(hh),csmatinterp(aa2,hh,qq,jj,eetai,ke),dy)
          call polint(hgrid(:),lsmatinterp0(aa2,:,qq,jj,eetai,ke),hgrid2(hh),lsmatinterp(aa2,hh,qq,jj,eetai,ke),dy)

          call polint(agrid2(jj+1,:,s),EVpinterp(:,hh,qq,jj+1,1,ke),asmatinterp(aa2,hh,qq,jj,eetai,ke),Vsprime(1),dy)
          call polint(agrid2(jj+1,:,s),EVpinterp(:,hh,qq,jj+1,2,ke),asmatinterp(aa2,hh,qq,jj,eetai,ke),Vsprime(2),dy)

          Vsinterp(aa2,hh,qq,jj,eetai,ke) = util(csmatinterp(aa2,hh,qq,jj,eetai,ke),lsmatinterp(aa2,hh,qq,jj,eetai,ke)) &
          +bbeta*sum(pis(s,:)*Vsprime(:))

          IIws(aa2,:,hh,qq,s,eetai,ke) = 0.0d0

          if (asmatinterp(aa2,hh,qq,jj,eetai,ke)-agrid2(jj+1,1,s)<=0.0d0) then
            IIws(aa2,1,hh,qq,s,eetai,ke) = 1.0d0

          elseif (asmatinterp(aa2,hh,qq,jj,eetai,ke)-agrid2(jj+1,anum2,s)>=0.0d0) then
            IIws(aa2,anum2,hh,qq,s,eetai,ke) = 1.0d0
          else

            aleft=max(locate(agrid2(jj+1,:,s),asmatinterp(aa2,hh,qq,jj,eetai,ke)), 1)
            aright=aleft+1

            if (aright>anum2) then
              write(*,*),'aright over',jj,s,eetai,aleft,aright,anum2
            endif
            IIws(aa2,aleft,hh,qq,s,eetai,ke) = (agrid2(jj+1,aright,s)-asmatinterp(aa2,hh,qq,jj,eetai,ke))/(agrid2(jj+1,aright,s)-agrid2(jj+1,aleft,s))
            IIws(aa2,aright,hh,qq,s,eetai,ke) = (asmatinterp(aa2,hh,qq,jj,eetai,ke)-agrid2(jj+1,aleft,s))/(agrid2(jj+1,aright,s)-agrid2(jj+1,aleft,s))
          endif
        enddo
      enddo
    enddo
  enddo

  do ke=1,kenum
    do qq=1,qnum
      do hh=1,hnum2
        do aa2=1,anum2

          Veduc1=Vsinterp(aa2,hh,qq,jj,eetai,ke)+lambdaopt(jj,hh,ke)

          if (Vinterp(aa2,hh,ja,3,eetai)>Veduc1) then
            I12pinterp(aa2,hh,qq,eetai,ke)=0.0d0
            V00interp(aa2,hh,qq,eetai,ke)=Vinterp(aa2,hh,ja,3,eetai)
          else
            I12pinterp(aa2,hh,qq,eetai,ke)=1.0d0
            V00interp(aa2,hh,qq,eetai,ke)=Veduc1
          endif

        enddo
      enddo
    enddo
  enddo

enddo

P1P2elas=sum(I12pinterp(:,:,:,:,:)*pppp0(:,:,:,:,:))

do ke=1,kenum
  do eetai=1,2
    do qq=1,qnum
      do hh=1,hnum2
        do aa=1,anum2
          ppws(aa,hh,qq,ja,2,eetai,ke) = (I12pinterp(aa,hh,qq,eetai,ke)*pppp0(aa,hh,qq,eetai,ke))
          ppws(aa,hh,qq,ja,3,eetai,ke) = (1.0d0-I12pinterp(aa,hh,qq,eetai,ke))*pppp0(aa,hh,qq,eetai,ke)
        enddo
      enddo
    enddo
  enddo
enddo


ppw(:,:,ja,2,:)=sum(sum(ppws(:,:,:,ja,2,:,:),5),3)
ppw(:,:,ja,3,:)=sum(sum(ppws(:,:,:,ja,3,:,:),5),3)

! jj=ja
! s=1

do thetah=1,hnum2
  do ke=1,kenum
    do eetai=1,2
      do qq=1,qnum
        do hh=1,hnum2
          do aa=1,anum2
            ppws0(aa,hh,qq,ja+1,eetai,ke,thetah) = pepmat(thetah,hh)*sum(IIws(:,aa,thetah,qq,2,eetai,ke)*ppws(:,thetah,qq,ja,2,eetai,ke),1)
          enddo
        enddo
      enddo
    enddo
  enddo
enddo

jj=ja
s=1

do ke=1,kenum
  do eetai=1,2
    do qq=1,qnum
      do hh=1,hnum2
        do aa=1,anum2
          ppws(aa,hh,qq,ja+1,1,eetai,ke) = &
          pis(2,eetai)*sum(Ipinterp(aa,hh,qq,ja+1,eetai,ke,:)*(ppws0(aa,hh,qq,ja+1,1,ke,:)+ppws0(aa,hh,qq,ja+1,2,ke,:)))
        enddo
      enddo
    enddo
  enddo
enddo

do ke=1,kenum
  do eetai=1,2
    do qq=1,qnum
      do hh=1,hnum2
        do aa=1,anum2
          ppws(aa,hh,qq,ja+1,2,eetai,ke) = &
          pis(2,eetai)*sum((1.0d0-Ipinterp(aa,:,qq,ja+1,eetai,ke,hh))*(ppws0(aa,:,qq,ja+1,1,ke,hh)+ppws0(aa,:,qq,ja+1,2,ke,hh)))
        enddo
      enddo
    enddo
  enddo
enddo

ppw(:,:,ja+1,1,:)=sum(sum(ppws(:,:,:,ja+1,1,:,:),5),3)
ppw(:,:,ja+1,2,:)=sum(sum(ppws(:,:,:,ja+1,2,:,:),5),3)

P1elas = sum(ppw(:,:,ja+1,1,:))
P2elas = sum(ppw(:,:,ja+1,2,:))
P3elas = sum(ppw(:,:,ja,3,:))

write(*,*) 'enrolldiff', P1+P2, P1P2elas, P1P2elas-P1-P2
write(*,*) 'grad diff', P1/(P1+P2), P1elas/P1P2elas, P1elas/P1P2elas-P1/(P1+P2)
write(*,*) 'CG diff', P1, P1elas, P1elas-P1
write(*,*) 'CD diff', P2, P2elas, P2elas-P2

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Moments
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


if (nodropout==1) then

  momsnd(1) = qfracm(1)
  momsnd(2) = qfracm(2)
  momsnd(3) = qfracm(3)
  momsnd(4) = qfracm(4)
  momsnd(5) = qfracincome02(1)
  momsnd(6) = qfracincome02(2)
  momsnd(7) = qfracincome02(3)
  momsnd(8) = qfracincome02(4)
  momsnd(9) = mskillp1-1.0d0

else

  moms(1) = pfracm(1)
  moms(2) = pfracm(2)
  moms(3) = pfracm(3)
  moms(4) = pfracm(4)
  moms(5) = w(1)*kappa/(ybar)
  moms(6) = sum(L)/sum(Nvec(ja:jr-1))
  moms(7) = K/Y
  moms(8) = sum(Bt)/Nvec(jb)/ybar*dble(dj)
  moms(9) = vpostincome/vpreincome
  moms(10) = borrowagg
  moms(11) = meanpp0
  moms(12) = sqrt(varpp0)
  moms(13) = (P1elasopt/(P1elasopt+P2elasopt))/(P1/(P1+P2))-1.0d0
  moms(14) = qfracm(1)/pfracm(1)
  moms(15) = qfracm(2)/pfracm(2)
  moms(16) = qfracm(3)/pfracm(3)
  moms(17) = qfracm(4)/pfracm(4)
  moms(18) = pfracincome02(1)
  moms(19) = pfracincome02(2)
  moms(20) = pfracincome02(3)
  moms(21) = pfracincome02(4)
  moms(22) = (qfracincome02(1))/pfracincome02(1)
  moms(23) = (qfracincome02(2))/pfracincome02(2)
  moms(24) = (qfracincome02(3))/pfracincome02(3)
  moms(25) = (qfracincome02(4))/pfracincome02(4)
  moms(26) = mskillp1-1.0d0
  moms(27) = mskillp2-1.0d0

  moms(28) = wageabil_3(1,4) - wageabil_3(1,1)
  moms(29) = wageabil_3(2,4) - wageabil_3(2,1)
  moms(30) = wageabil_3(3,4) - wageabil_3(3,1)

endif

write(*,*) 'enroll',pfracm
write(*,*) 'grad',qfracm/pfracm

if (nodropout==1) then

  ! difffuncnd=(momsnd-datnd)/datnd
  ! difffuncnd(1:4)=momsnd(1:4)-datnd(1:4)
  ! difffuncnd(13:16)=momsnd(13:16)-datnd(13:16)

  difffuncnd=(momsnd-datnd)/datnd
  difffuncnd(1:4)=momsnd(1:4)-datnd(1:4)
  difffuncnd(5:8)=momsnd(5:8)-datnd(5:8)

  calibration = sqrt(sum(difffuncnd**2))/dble(size(momsnd))*100.0d0

write(*, *) 'test_mom', momsnd
write(*, *) 'test_dat', datnd

else

  difffunc=(moms-dat)/dat
  difffunc(1:4)=moms(1:4)-dat(1:4)
  difffunc(14:25)=moms(14:25)-dat(14:25)
  difffunc(10) = moms(10) - dat(10)

  calibration = sqrt(sum(difffunc**2))/dble(size(moms))*100.0d0


endif

if (heterostddc==1) then
  calibration = sqrt(sum(difffunc(1:12)**2)+sum(difffunc(14:size(difffunc))**2))/dble(size(moms)-1)*100.0d0
endif

if (dddddd > 0.1d0) then
  calibration=1000000000.0d0
endif


write(*,*) 'skillp', mskillp1-1.0d0, mskillp2-1.0d0

end function calibration
