function calibration79(params)

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !!!!  Kazushige MATSUDA
  !!!!  "College Dropout, Year-Varying Grants, and the Skill Premium"
  !!!!
  !!!!
  !!!!  Routine to solve the schooling problem for each cohort and ability type, and to compute a few aggregate variables
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  use nrtype
  use globals
  use interface, only : modelsolution, param, modelmoments, valuev
  use nr, only : polint, locate

  implicit none

  REAL(DP), DIMENSION(:), INTENT(IN) :: params
  REAL(DP) :: calibration79
  real(DP) :: moms79(3),difffunc2(3)
  real(DP), parameter :: skillp179=1.46162d0-1.0d0, skillp279=1.120861d0-1.0d0, eandg79=5394d0, tuition79 = eandg79*1.998d0/1.115d0/eandg
  real(DP), parameter, dimension(qnum) :: gbase79=(/eandg79-tbase+2820.0d0,eandg79-tbase+668.0d0,eandg79-tbase+143.0d0/)!(Abbott et al)

  integer:: fo,iii,ITT,aa2

  a1=params(1)
  a2=params(2)
  kappa = params(3)

  bbeta=1.0d0/(1.0d0+bbetarate)

  write(*,*) 'params',params

  call param

  K_LL= 1.47608115462017 !0.98000001107569479
  LL_N=0.682017667696927 !2.2765215282346136
  H_LL1=0.188438050035232  !7.8792700081593392E-002 !7.3409089449000403E-002
  taul=0.40744092310853 !0.15837059017852301

  grants(ja,:,1)=grants0(ja,1,1)*grantsratio
  grants(ja,:,2)=grants0(ja,1,2)*grantsratio
  grants(ja,:,3)=grants0(ja,1,3)*grantsratio
  grants(ja+1,:,1)=grants0(ja,1,1)*grantsratio
  grants(ja+1,:,2)=grants0(ja,1,2)*grantsratio
  grants(ja+1,:,3)=grants0(ja,1,3)*grantsratio

  K_LL=1.47810360768628
  H_LL1=1.00192946476160
  LL_N=0.294934717411433
  taul=0.372868613127611


  dddddd=100.0d0
  V00(:,:,:) = 0.0d0
  V(:,:,:,:,:)=0.0d0
  Vr(:,:,:,:)=0.0d0

  calibflag=0
  wel=0
  write(*,*) 'iteration', 'distance'

  do itt=1,15
    call modelsolution
    write(*,*) ITT, dddddd
    if (dddddd<tol2) then
      exit
    endif
  enddo

  do jj=ja,jr-1
    popw(:,:,jj,:,:) = Nvec(jj)*ppw(:,:,jj,:,:)
  enddo
  do jj=jr,jend
    popr(:,:,jj,:)=Nvec(jj)*ppr(:,:,jj,:)
  enddo

  mskillp1 = (sum(wwpw(:,:,ja+2:jr-1,1,:))/sum(popw(:,:,ja+2:jr-1,1,:)))/(sum(wwpw(:,:,ja+2:jr-1,3,:))/sum(popw(:,:,ja+2:jr-1,3,:)))
  mskillp2 = (sum(wwpw(:,:,ja+2:jr-1,2,:))/sum(popw(:,:,ja+2:jr-1,2,:)))/(sum(wwpw(:,:,ja+2:jr-1,3,:))/sum(popw(:,:,ja+2:jr-1,3,:)))

  moms79(1) = mskillp1-1.0d0
  moms79(2) = mskillp2-1.0d0
  moms79(3) = w(1)*kappa/tuitioneq

  difffunc2(1)=(moms79(1)-skillp179)/skillp179
  difffunc2(2)=(moms79(2)-skillp279)/skillp279
  difffunc2(3)=(moms79(3)-tuition79)/tuition79

  calibration79=sqrt(sum(difffunc2**2))/dble(size(moms79))*100.0d0

  if (dddddd > 0.03d0) then
    calibration79=1000000000
  endif

  write(*,*) 'skillp, tuition', mskillp1-1.0d0, mskillp2-1.0d0, w(1)*kappa/tuitioneq
  write(*,*) 'diff1', difffunc2(:)

end function calibration79
