subroutine fminsearch(fname,x0,fmin,tolf)

  use nrtype
  use nr, only : amoeba
  USE nrutil, ONLY : iminloc
  use interface, only : calibration, calibration79, welfare

  implicit none

  interface
    FUNCTION fname(x)
		USE nrtype
		IMPLICIT NONE
		REAL(DP), DIMENSION(:), INTENT(IN) :: x
		REAL(DP) :: fname
		END FUNCTION fname
  end interface

  real(DP), intent(in) :: tolf
  real(DP), DIMENSION(:), intent(inout) :: x0(:)
  real(DP), intent(out) :: fmin

  real(DP), parameter :: usual_delta=0.1d0, zero_term_delta = 0.2d0
  real(DP), allocatable :: vmin(:,:),fv(:)
  integer :: iii,iter,ilo,n

  n=size(x0)
  allocate (vmin(n+1,n),fv(n+1))

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Center
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  vmin(1,:) = x0
  fv(1)=fname(x0)
  write(*,*) 'fcv=',fv(1)

  print*,'----------------------------------'
  write(*,*) 'center', fv(1)
  print*,'----------------------------------'

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Initial simplex
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  do iii = 1,n

    write(*,*) 'iii=', iii

    vmin(iii+1,:) = x0(:)

    if (x0(iii)== 0.0d0) then
      vmin(iii+1,iii) = zero_term_delta
    else
      vmin(iii+1,iii) = x0(iii)*(1.0d0+usual_delta)
      ! vmin(iii+1,:) = x0(iii)+usual_delta
    endif

    fv(iii+1)=fname(vmin(iii+1,:))
    write(*,*) 'fcv=',fv(iii+1)
  enddo

  print*,'----------------------------------'
  write(*,*) 'initial simplex', minval(fv)
  print*,'----------------------------------'

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Nelder-Mead
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  call amoeba(vmin,fv,tolf,fname,iter)

  ilo=iminloc(fv(:))
  x0(:)=vmin(ilo,:)
  fmin=fv(ilo)

end subroutine fminsearch
