module globals

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!  Kazushige MATSUDA
!!!!  "Progressive Taxation vs College Subsidies with College Dropout"
!!!!
!!!!
!!!!  Global Variables
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

use nrtype

implicit none

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Technical
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

integer, parameter :: maxit=50
real(DP), parameter :: tol = 0.0001d0, tol2=0.001d0,capmax=10.0d0
real(DP), parameter :: m = 0.0000000001d0,MM = 1.0e+10_8
real(DP), parameter :: revise=0.2d0,revise3=0.1d0,revise10=1.0d0, revise2=0.05d0!

integer, save:: hh2,calibflag,wel,hc2,qq3,weltest, eetai,hh,jj,s,hc,xx,aa,qq,ke,ke2,qq2,debug,&
paternalistic,heterostddc,thetah,thetac, nodropout, ppwfixed, CEVallind, omitj2, taxelas, delas, peind, i_common_loading
integer, parameter :: dj=2
integer, parameter :: nparam=20,nmoms=30,nmomsnd=9
integer, parameter :: abarnum=30, hnum = 5, qnum=3, qpnum=4, xnum=30, hnum2=21, snum=3, qnum2=4,kenum=30,anum2=80,anum=30
integer, parameter :: atheta=4

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Dollar values
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! real(DP), parameter :: ybarbase=28793.0d0, ybase=55925.31d0, q1base=30000.0d0, q2base=80000.0d0, btbase=37300.0d0
real(DP), parameter :: ybarbase=28793.0d0, ybase=46259.39d0, q1base=30000.0d0, q2base=80000.0d0, btbase=37300.0d0

real(DP), parameter :: bbase=23000.0d0 !staford loan max
! real(DP), parameter, dimension(snum) :: blbase=(/ 37831.73d0,  24833.28d0, 20753.7d0 /) !SCE unsecured debt limit
! real(DP), parameter, dimension(snum) :: blbase=(/ 34000.0d0,  24000.0d0, 24000.0d0 /) !SCE unsecured debt limit
! real(DP), parameter, dimension(snum) :: blbase=(/ 33765.0d0,  20290.0d0, 18236.0d0 /) !SCE unsecured debt limit
real(DP), parameter, dimension(snum) :: blbase=(/ 34000.0d0,  20000.0d0, 17000.0d0 /) !SCE unsecured debt limit



real(DP), parameter :: tbase=6710.0d0, tup=1000.0d0, eandg=17489.0d0, grantsratio = 1077d0/3153d0*1.998d0/1.115d0!2500d0/4817d0 1077d0/3153d0
real(DP), parameter, dimension(qnum) :: gbase=(/eandg-tbase+2820.0d0,eandg-tbase+668.0d0,eandg-tbase+143.0d0/)!(Abbott et al)
! real(DP), parameter, dimension(qnum) :: gbase=(/eandg-tbase+1201.0d0,eandg-tbase+1201.0d0,eandg-tbase+1201.0d0/)!(revision)

real(DP), parameter :: meanh=5.035006d0, stddh= .2137612d0 ! ln AFQT

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Parameters outside model
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! Lifecycle
integer, parameter :: jaage = 18,jfage = 30,jrage = 66,jage = 100
integer, parameter :: jbage=jaage+jfage
integer, parameter :: ja = 1
integer, parameter :: jd = (jaage+2-jaage)/dj+1
integer, parameter :: jc = (jaage+4-jaage)/dj+1
integer, parameter :: jf = (jfage-jaage)/dj+1
integer, parameter :: jb = (jbage-jaage)/dj+1
integer, parameter :: jr = (jrage-jaage)/dj+1
integer, parameter :: jend = (jage-jaage)/dj+1
integer, parameter, dimension(snum) :: jy = (/jc,jd,ja/)

real(DP), parameter :: cchi = 0.0d0, f = 1.0d0 ! fertility rate!f**(1.0d0/dble(jf+1))-1.0d0
real(DP), parameter :: gy = 1834.3d0/10284.8d0 - 0.00778d0 !goverment consumption/GDP
real(DP), parameter :: tauc = 0.07d0, tauk = 0.27d0, tauld=0.20d0! McDaniel (2007)
real(DP), parameter :: aalpha = 0.333d0 ! capital share
real(DP), parameter :: ddelta = 1.0d0-(1.0d0-0.07d0)**dj !capital depreciation
real(DP), parameter :: iotas=0.047d0 !student loan interest wedge
real(DP), parameter :: s1=0.9d0, s2=0.32d0, s3=0.15d0, b1=0.22d0, b2=1.33d0, b3=1.81d0 ! Pension paramters
real(DP), parameter :: cchi2=.4544413d0 !Intergenerational ability transmission

real(DP), parameter :: zzeta = 0.3d0! adult equivalence
real(DP), parameter :: ssigma = 4.0d0! intertemporal elasticity of substitution
real(DP), parameter :: rho =  (1.64d0-1d0)/1.64d0!.2908d0! paramter of elasticity of substitution
real(DP), parameter :: stime = 0.25d0! study time
real(DP), parameter :: cchiw= 0.0d0!.15d0! share of skilled labor by college dropouts
real(DP), parameter :: hbase=0.35d0, hbar=0.333d0! working hours norm for family income

! wage process
real(DP), parameter, dimension(snum) :: expcoeff1=(/ .0955783d0, .0684129d0, .0530181d0 /) ! PSID
real(DP), parameter, dimension(snum) :: expcoeff2=(/ -.0009521d0,  -.0006872d0, -.0005314d0  /)
! real(DP), parameter, dimension(snum) :: afqtcoeff=(/   1.309829d0,  .7365031d0, .6112115d0  /)
real(DP), dimension(snum) :: afqtcoeff

real(DP), parameter, dimension(snum) :: sigmaalpha=(/sqrt(0.0274d0),sqrt(0.0163d0),sqrt(0.0381d0)/)
! real(DP), parameter, dimension(snum) :: rhoo=(/0.9479d0, 0.9545d0, 0.9390d0/)    ! persistence (annual)
! real(DP), parameter, dimension(snum) :: sigmaeta=(/sqrt(0.0248d0), sqrt(0.0208d0), sqrt(0.0166d0)/)    ! persistence (annual)
real(DP), parameter, dimension(snum) :: rhoo=(/0.9439d0, 0.9620d0, 0.9390d0/)    ! persistence (annual)
real(DP), parameter, dimension(snum) :: sigmaeta=(/sqrt(0.0260d0), sqrt(0.0204d0), sqrt(0.0164d0)/)    ! persistence (annual)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Grids
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

real(DP), save:: agrid(jend,anum,snum),agrid2(jend,anum2,snum),agridjf(anum,snum)
real(DP), save:: Iamax(jend,snum)=100.0d0,Iamin(jend,snum),amin, amax,Aj(snum,jend)=0.0d0
real(DP), save:: hgrid(hnum),hgrid2(hnum2),hgrid3(hnum2),hgrid4(hnum)
real(DP), save:: ghgrid(snum,hnum),ghgridinterp(snum,hnum2),kegrid0(kenum)
integer, save:: hhm(hnum)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Enrollment and completion rates from data
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

real(DP), parameter:: pfracagg = .7486185d0
real(DP), parameter:: qfracagg = pfracagg* .4379077d0

real(DP), parameter, dimension(4) :: pfrac = (/ .5280024d0,  .7035108d0,   .8436332d0,  .9283065d0/)
real(DP), parameter, dimension(4) :: gradprob = (/  .1928736d0,  .3179564d0,   .4882858d0,   .6278932d0/)
real(DP), parameter, dimension(4) :: qfrac = (/pfrac(1)*gradprob(1),pfrac(2)*gradprob(2),pfrac(3)*gradprob(3),pfrac(4)*gradprob(4)/)

real(DP), parameter, dimension(4) :: pfracinc = (/.640578d0,  .7010318d0,  .7942661d0,.8588151d0/)
real(DP), parameter, dimension(4) :: gradprobinc = (/.2779693d0, .385621d0, .4564672d0, .5830345d0/)
real(DP), parameter, dimension(4) :: qfracinc = (/pfracinc(1)*gradprobinc(1),pfracinc(2)*gradprobinc(2),&
pfracinc(3)*gradprobinc(3),pfracinc(4)*gradprobinc(4)/)

real(DP), save :: hgridmat(hnum2,hnum2),sumpp0mat(hnum2,hnum2),P1P2elas,P1elas,P2elas,P3elas,P1elasopt,P2elasopt,P3elasopt,Veduc1,Veduc2

real(DP), save :: marginalgrad,marginalenroll,P1before(hnum2),P2before(hnum2),sigmas,q1,q2,q1prime,q1primeeq,q2prime,&
q2primeeq,funcvvec(nmoms),aggdis,dsumaggdis,betav,diseq,disopt,YNeq,Eeq

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Calibrated parameters
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! Remaining parameters
real(DP), save :: bopt0, bopt1, lambda0, lambda1, kappa, mmu, bbetarate, vv, d, iota, mupbar, ssigmae, elast, elast2,&
bbeta, a1, a2, stddc, stddc1

real(DP), save:: bopt(hnum2),ind_fb(jend),bbase1,bbase2,trans0,stdsigmac(hnum2)
real(DP), save:: aap(snum,jr-1), lambda(jend,hnum2, kenum), lambdaopt(jend,hnum2, kenum)
real(DP), save:: pepmat(hnum2,hnum2),pepmatopt(hnum2,hnum2),psiem(hnum2,snum,hnum2),pike(kenum),mup(snum,hnum2)
real(DP), save:: pii(snum,2,2),pis(snum,2),eeta(snum,2)
real(DP), save:: varphi(jend),Nvec(jend),NN

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Prices
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

real(DP), save:: H_LL1,LL, LL_N, K_LL, K, r, RR, RRtilde,rminus,rs,tuition,RRdebt,RRdebts,factor,taul, tauleq,ybar, &
Y, Z, sumC, Zeq,tuitioneq
real(DP), save, dimension(snum):: w,H
real(DP), save:: ww(hnum),wwinterp(hnum2)
real(DP), save:: grants(jend,hnum2,qnum),grantsopt(jend,hnum2,qnum),grants0(jend,hnum2,qnum),grants00(jend,hnum2,qnum),&
ttheta(jend,hnum2,qnum),thetap(jend)
real(DP), save:: ytrinterp(snum,hnum2), pia(snum,hnum),piainterp(snum,hnum2), p(snum,hnum),pinterp(snum,hnum2)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Policy and value functions
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

real(DP), save:: cmat(anum,hnum,jend,snum,2)=0.0d0,cmatinterp(anum2,hnum2,jend,snum,2)=0.0d0,cmatinterp0(anum2,hnum,jend,snum,2)=0.0d0, &
V(anum,hnum,jend,snum,2)=0.0d0,Vx(anum,hnum,jend,snum,2)=0.0d0,Vinterp(anum2,hnum2,jend,snum,2)=0.0d0,Vinterp0(anum2,hnum,jend,snum,2)=0.0d0,&
amat(anum,hnum,jend,snum,2)=0.0d0,amatinterp(anum2,hnum2,jend,snum,2)=0.0d0,amatinterp0(anum2,hnum,jend,snum,2)=0.0d0,&
hmatinterp(anum2,hnum2,jend,snum,2)=0.0d0,hsmatinterp(anum2,hnum2,jend,snum,2)=0.0d0,ymatinterp(anum2,hnum2,jend,snum,2)=0.0d0,&
lmat(anum,hnum,jend,snum,2)=0.0d0,lmatinterp(anum2,hnum2,jend,snum,2)=0.0d0,lmatinterp0(anum2,hnum,jend,snum,2)=0.0d0,&
IIw(anum2,anum2,hnum2,jend,snum,2)=0.0d0,borrowindinterp(anum2,hnum2,jend,snum,2)=0.0d0,wmatinterp(anum2,hnum2,jend,snum,2)=0.0d0
! In college
real(DP), save:: csmat(anum,hnum,qnum,jend,2,kenum)=0.0d0,csmatinterp(anum2,hnum2,qnum,jend,2,kenum)=0.0d0,&
csmatinterp0(anum2,hnum,qnum,jend,2,kenum)=0.0d0,&
asmat(anum,hnum,qnum,jend,2,kenum)=0.0d0,asmatinterp(anum2,hnum2,qnum,jend,2,kenum)=0.0d0,asmatinterp0(anum2,hnum,qnum,jend,2,kenum)=0.0d0,&
hmatsinterp(anum2,hnum2,qnum,jend,2,kenum)=0.0d0, hssmatinterp(anum2,hnum2,qnum,jend,2,kenum)=0.0d0,ysmatinterp(anum2,hnum2,qnum,jend,2,kenum)=0.0d0,&
lsmat(anum,hnum,qnum,jend,2,kenum)=0.0d0,lsmatinterp(anum2,hnum2,qnum,jend,2,kenum)=0.0d0,lsmatinterp0(anum2,hnum,qnum,jend,2,kenum)=0.0d0,&
Vs(anum,hnum,qnum,jend,2,kenum)=0.0d0,Vsx(anum,hnum,qnum,jend,2,kenum)=0.0d0,Vsinterp(anum2,hnum2,qnum,jend,2,kenum)=0.0d0,Vsinterpopt(anum2,hnum2,qnum,jend,2,kenum)=0.0d0,&
Vp(anum,hnum,qnum,jend,2,kenum,hnum)=0.0d0,EVp(anum,hnum,qnum,jend,2,kenum)=0.0d0,&
Vpinterp(anum2,hnum2,qnum,jend,2,kenum,hnum2)=0.0d0,EVpinterp(anum2,hnum2,qnum,jend,2,kenum)=0.0d0,EVpinterpopt(anum2,hnum2,qnum,jend,2,kenum)=0.0d0,&
IIws(anum2,anum2,hnum2,qnum,snum,2,kenum)=0.0d0,borrowinds(anum,hnum,qnum,jend,2)=0.0d0,borrowindsinterp(anum2,hnum2,qnum,jend,2,kenum)=0.0d0
! After retirement
real(DP), save:: crmat(anum,hnum,jend,snum)=0.0d0, crmatinterp(anum2,hnum2,jend,snum)=0.0d0,crmatinterp0(anum2,hnum,jend,snum)=0.0d0, &
armat(anum,hnum,jend,snum)=0.0d0,armatinterp0(anum2,hnum,jend,snum)=0.0d0,armatinterp(anum2,hnum2,jend,snum)=0.0d0,&
Vr(anum,hnum,jend,snum)=0.0d0,Vrx(anum,hnum,jend,snum)=0.0d0,Vrinterp(anum2,hnum2,jend,snum)=0.0d0,IIr(anum2,anum2,hnum2,jend,snum)=0.0d0
! jb
real(DP), save::cmatjf(anum,hnum,hnum,snum,2)=0.0d0,cmatjfinterp(anum2,hnum2,hnum2,snum,2)=0.0d0,&
cmatjfinterp0(anum2,hnum,hnum,snum,2)=0.0d0,cmatjfinterp1(anum2,hnum2,hnum,snum,2)=0.0d0,hmatjfinterp(anum2,hnum2,hnum2,snum,2)=0.0d0,&
amatjf(anum,hnum,hnum,snum,2)=0.0d0,amatjfinterp(anum2,hnum2,hnum2,snum,2)=0.0d0,&
amatjfinterp0(anum2,hnum,hnum,snum,2)=0.0d0,amatjfinterp1(anum2,hnum2,hnum,snum,2)=0.0d0, &
bmatjf(anum,hnum,hnum,snum,2)=0.0d0,bmatjfinterp(anum2,hnum2,hnum2,snum,2)=0.0d0,&
bmatjfinterp0(anum2,hnum,hnum,snum,2)=0.0d0,bmatjfinterp1(anum2,hnum2,hnum,snum,2)=0.0d0,bmatinterp(anum2,hnum2,jend,snum,2)=0.0d0,&
lmatjf(anum,hnum,hnum,snum,2)=0.0d0,lmatjfinterp(anum2,hnum2,hnum2,snum,2)=0.0d0,&
lmatjfinterp0(anum2,hnum,hnum,snum,2)=0.0d0,lmatjfinterp1(anum2,hnum2,hnum,snum,2)=0.0d0,&
hsmatjfinterp(anum2,hnum2,hnum2,snum,2)=0.0d0,ymatjfinterp(anum2,hnum2,hnum2,snum,2)=0.0d0,&
IIwjf(anum2,anum2,hnum2,hnum2,snum,2)=0.0d0,Ibwjf(anum2,anum2,hnum2,hnum2,snum,2)=0.0d0,borrowindjfinterp(anum2,hnum2,hnum2,snum,2)=0.0d0
real(DP) :: Vaux(anum,hnum,hnum)=0.0d0,Vauxx(anum,hnum,hnum)=0.0d0,Vauxinterp(anum2,hnum2,hnum2)=0.0d0,&
Vauxxinterph(anum2,hnum,hnum2)=0.0d0,Vauxinterph(anum2,hnum,hnum2)=0.0d0
! Initial period
real(DP), save:: V00(anum,hnum,qnum)=0.0d0,V00news(anum,hnum,qnum,2,kenum)=0.0d0,&
V00interp(anum2,hnum2,qnum,2,kenum)=0.0d0,V00interpnew(anum2,hnum2,qnum,2)=0.0d0,V00aux3(anum2,hnum2,qnum,2,kenum)=0.0d0,&
V00aux3interp(anum2,hnum,qnum,2,kenum)=0.0d0,V00newaux3(anum,hnum,qnum,2,kenum)=0.0d0,V00interpsopt(anum2,hnum2,qnum,2,kenum)=0.0d0
! Enrollment and graduation decisions
real(DP), save::I12p(anum,hnum,qnum,2,kenum)=0.0d0,I12pinterp(anum2,hnum2,qnum,2,kenum)=0.0d0,Ipinterpeq(anum2,hnum2,qnum,jend,2,kenum)=0.0d0,&
Ip(anum,hnum,qnum,jend,2,kenum,hnum)=0.0d0,Ipinterp(anum2,hnum2,qnum,jend,2,kenum,hnum2)=0.0d0,I12pinterpeq(anum2,hnum2,qnum,2,kenum)=0.0d0

integer, save:: aleft, aright

real(DP), save:: Vprime(2),Vprimer,V00prime,Vsprime(2),Voutput,Vwork,Vrprime,mp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Measures
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

real(DP), save :: pp0(anum2,hnum2,qnum)=0.0d0, pp0new(anum2,hnum2,qnum),ppw(anum2,hnum2,jend,snum,2)=0.0d0,ppweq(anum2,hnum2,jend,snum,2)=0.0d0,&
ppws(anum2,hnum2,qnum,jend,snum,2,kenum)=0.0d0,ppwseq(anum2,hnum2,qnum,jend,snum,2,kenum)=0.0d0,ppr(anum2,hnum2,jend,snum)=0.0d0,ppreq(anum2,hnum2,jend,snum)=0.0d0,&
ppws0(anum2,hnum2,qnum,jend,2,kenum,hnum2)=0.0d0,&
ppwjf(anum2,hnum2,hnum2,snum,2),ppbjf(anum2,hnum2,hnum2,snum,2,qnum),pppp0(anum2,hnum2,qnum,2,kenum),pppp0eq(anum2,hnum2,qnum,2,kenum),&
popw(anum2,hnum2,jend,snum,2)=0.0d0,popweq(anum2,hnum2,jend,snum,2)=0.0d0,popr(anum2,hnum2,jend,snum)=0.0d0,popreq(anum2,hnum2,jend,snum)=0.0d0,sumppw(anum2,hnum2,qnum,2,kenum),&
sumppw22(anum2,hnum2,hnum2,qnum,2,kenum), ppw22(anum2,hnum2,hnum2,jend,snum,2)=0.0d0, ppwjf22(anum2,hnum2,hnum2,hnum2,snum,2)
real(DP), save :: wageabil(snum,hnum2), masabil(snum,hnum2), wageabil_3(snum,4), wageabil_3_2(snum,2)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Aggregates
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

real(DP), save ::  pfrac0(4),qfrac0(4),pfrac1(4),qfrac1(4),pfrac2(4),qfrac2(4),pfracincome02(qnum2),qfracincome02(qnum2),&
pfracm(4),qfracm(4),pfracincome02eq(qnum2),qfracincome02eq(qnum2),ppws0eq(anum2,hnum2,qnum,jend,snum,2,kenum), pfracm44(4,4),qfracm44(4,4),&
qfracm44eq(4,3),qfracm44opt(4,3),qfracm44_3(4,3)

real(DP), save :: hpw(anum2,hnum2,jend,snum,2)=0.0d0,wwpw(anum2,hnum2,jend,snum,2)=0.0d0,hspw(anum2,hnum2,jend,snum,2)=0.0d0,&
cpw(anum2,hnum2,jend,snum,2)=0.0d0,apw(anum2,hnum2,jend,snum,2)=0.0d0,lpw(anum2,hnum2,jend,snum,2)=0.0d0,ypw(anum2,hnum2,jend,snum,2)=0.0d0,&
ytpw(anum2,hnum2,jend,snum,2)=0.0d0,bpwjf(anum2,hnum2,snum,2)=0.0d0,cpr(anum2,hnum2,jend,snum)=0.0d0,apr(anum2,hnum2,jend,snum)=0.0d0,&
lpr(anum2,hnum2,jend,snum)=0.0d0,borrowpw(anum2,hnum2,jend,snum,2)=0.0d0, borrowam(anum2,hnum2,jend,snum,2)=0.0d0

real(DP), save:: ppw2_abil(4,snum),ppw2_fi(qnum2,snum)
real(DP), save:: meanafqtm(snum),varafqtm(snum),meanhs(snum),meanpp0,varpp0,meanpp1,varpp1,covhh,corrhh,meanbias_enrollees,&
meanthetac_enrollees,stdthetac_enrollees
real(DP),save :: P1,P2,P3,agleis,C(snum),L(snum), mskillp1, mskillp2, Bt(snum),wealth(snum),sumom(snum,jend),PE,E,Efix,E0,borrowagg,GDP
real(DP),save :: fval(5), fval2(4),grantprop,grantpropnew
real(DP),save :: p25_mincome, p50_mincome, p75_mincome
integer, save :: i25, i50, i75, i25eq, i50eq, i75eq, i25mincome, i50mincome, i75mincome
real(DP), save::ybar2,moms(nmoms), momsnd(nmomsnd), difffunc(nmoms),difffuncnd(nmomsnd),dat(nmoms), datnd(nmomsnd),SWFpa2(4,qnum),SWF2,SWFpa2sq(4,qnum),SWFpa2opt(4,qnum),CEVpa2(4,qnum)
real(DP), save:: meanc, meana, stdc, stda, meancw, meanaw, meanhhw, meanww, stdcw, stdaw, stdhhw, stdww
real(DP), save:: meancw_age(jend, snum), meanaw_age(jend, snum), meanww_age(jend, snum), stdcw_age(jend, snum), stdaw_age(jend, snum), stdww_age(jend, snum)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! modelmoments.f90
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

real(DP), save ::  preincome(anum2,hnum2,jend,snum,2)=0.0d0,postincome(anum2,hnum2,jend,snum,2)=0.0d0,&
preincomes(anum2,hnum2,qnum,jend,2,kenum)=0.0d0,postincomes(anum2,hnum2,qnum,jend,2,kenum)=0.0d0,meanpreincome(jend,snum)=0.0d0,&
meanpostincome(jend,snum)=0.0d0,varpreincome(jend,snum)=0.0d0,varpostincome(jend,snum)=0.0d0,mpreincome,mpostincome,vpreincome,vpostincome,Vsprimeh(hnum2)
real(DP), save:: sumpp0(hnum2),dsumpp0(hnum2)
real(DP), save:: ppws21(anum2,hnum2,qnum,snum,2,kenum,qnum2)=0.0d0,ppws22(anum2,hnum2,hnum2,qnum,2,kenum,qnum2)=0.0d0,&
pp02(anum2,hnum2,qnum,qnum2)=0.0d0,ppw2(4,snum,qnum2)=0.0d0,ppw2_3(4,snum,qnum)=0.0d0,ppws02(anum2,hnum2,hnum2,qnum,2,kenum,qnum2)=0.0d0,pfrac43(4,3),qfrac43(4,3),&
pfrac43eq(4,3),qfrac43eq(4,3),pfrac43opt(4,3),qfrac43opt(4,3),qfracthetac43(4,3),qfracthetac43eq(4,3),qfracthetac43opt(4,3)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! modeloutput.f90
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

real(DP), save:: Vleisr(anum2,hnum2,jend,snum)=0.0d0, Vleis(anum2,hnum2,jend,snum,2)=0.0d0,&
Vleise(anum2,hnum2,qnum,jend,2,kenum)=0.0d0,V00leis(anum2,hnum2,qnum)=0.0d0,V00leisnew(anum2,hnum2,qnum)=0.0d0,V00leisnews(anum2,hnum2,qnum,2,kenum)=0.0d0,&
Vleispe(anum2,hnum2,qnum,jend,2,kenum,hnum2)=0.0d0,EVleispe(anum2,hnum2,qnum,jend,2,kenum),c00(anum2,hnum2,qnum,2,kenum), CCbar
real(DP), save:: V00eq,V00opt,Vlev,Vleveq,Vlevopt,punc, punceq, puncopt, pine, pineeq, pineopt, Ceq, Copt, Leq, Lopt, omlev, omunc,omine,omU,ominemec
real(DP), save:: enrolleq,gradeq,Vleis2(anum2,hnum2,qnum,jend,2,kenum)=0.0d0
real(DP), save :: income(snum,hnum2,2),ppincome(snum,hnum2,2)
real(DP), save :: incomevec(size(income)),pincomevec(size(ppincome)),pincomesort(size(ppincome)),dpincomesort(size(ppincome)),&
dis(anum2,hnum2,qnum,2,kenum), aggdis2eq,aggdis2opt,aggdis4(4,qnum),aggdis4opt(4,qnum),aggdis4eq(4,qnum)
real(DP), save:: fmin, mul, dy, moments(5),moments2(5),dddddd
real(DP), save :: V00aux3all, disall, V00leisall, V00ceisall

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! main.f90
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

real(DP), save::consjaeq,transferjaeq,tuitionjaeq,grantsjaeq,lumpsumjaeq,savingsjaeq,laborincomejaeq,mpjaeq,leisurejaeq, paramsbench(nparam)
real(DP), save::consjaopt,transferjaopt,tuitionjaopt,grantsjaopt,lumpsumjaopt,savingsjaopt,laborincomejaopt,mpjaopt,leisurejaopt
real(DP), save :: Vlsumall, Vcsumall, aggdis2eqall, V00optall, aggdis2optall, CEVall, V00eqall, SWF2all

contains

	function gini(consumption, dist)

		! use toolbox

		implicit none

		! integer, intent(in) :: n
		! real*8, intent(in) :: consumption(n), dist(n)
		! real*8 :: gini
		! real*8 :: c_nsort(n), d_nsort(n), c_sort(n), d_sort(n), cumulative(n+1), temp(n)
		! integer :: order(n), i, j

		real*8, intent(in) :: consumption(:), dist(:)
		real*8 :: gini
		real*8, allocatable :: c_nsort(:), d_nsort(:), c_sort(:), d_sort(:), cumulative(:), temp(:)
		integer, allocatable :: order(:)
		integer :: n, i, j


		if (size(consumption) == size(dist))then
			n = size(dist)
			! else throw error message
		else
			write(*,*) 'an assertion failed in gini'
		end if
		! Calculates Gini coefficient for a given consumption distribution


		allocate(c_nsort(n), d_nsort(n), c_sort(n), d_sort(n), cumulative(n+1), temp(n), order(n))

		! Sorting
		c_nsort(:)=consumption(:)
		d_nsort(:)=dist(:)

		c_sort(:) = c_nsort(:)
		d_sort(:) = d_nsort(:)

		call sort2(c_sort, d_sort)

		! call sort(c_sort, order)

		! do i = 1, n
		! 	d_sort(i) = d_nsort(order(i))
		! enddo
		! write(*,*) 'test6'

		! [c_sort, order]=sort(c_nsort)
		! d_sort=d_nsort(order)

		!%% Gini
		! n=size(c_sort)
		cumulative(:)=0d0
		do j=1, n
			cumulative(j+1)=cumulative(j)+c_sort(j)*d_sort(j)
		enddo

		!% cumulative(2:n+1)=cumulative(1:n)+c_sort(1:n).*d_sort(1:n);

		temp(:)=0d0
		do j=1, n
			temp(j)=(cumulative(j+1)+cumulative(j))*d_sort(j)
		enddo
		gini=1d0-sum(temp)/max(cumulative(n+1), 1d-4)

	end function

end module globals
