module interface

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  
  !!!!  Kazushige MATSUDA
  !!!!  "College Dropout, Year-Varying Grants, and the Skill Premium"
  !!!!  
  !!!!
  !!!!  Routine to solve the schooling problem for each cohort and ability type, and to compute a few aggregate variables
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  interface

  function normcdf(x,mu,sd)
    use nrtype
    real(DP), INTENT(IN) :: x, mu, sd
    real(DP) :: normcdf
  end function normcdf

  function linspace(vmin,vmax,vnum) result(vgrid)
    use nrtype
    real(DP), intent(in) :: vmin, vmax
    integer, intent(in) :: vnum
    real(DP) vgrid(vnum)
  end function linspace

  subroutine modelsolution
  end subroutine modelsolution

  subroutine modelmoments
  end subroutine modelmoments

  function calibration(params)
    use nrtype
    REAL(DP), DIMENSION(:), INTENT(IN) :: params
    real(DP) :: calibration
  end function calibration

  function calibration79(params)
    use nrtype
    REAL(DP), DIMENSION(:), INTENT(IN) :: params
    real(DP) :: calibration79
  end function calibration79

  function welfare(xs)
    use nrtype
    REAL(DP), DIMENSION(:), INTENT(IN) :: xs
    real(DP) :: welfare
  end function welfare

  subroutine fminsearch(fname,x0,fmin,tolf)
    use nrtype
    
    interface
    FUNCTION fname(x)
		  USE nrtype
		  IMPLICIT NONE
		  REAL(DP), DIMENSION(:), INTENT(IN) :: x
		  REAL(DP) :: fname
		  END FUNCTION fname
    end interface
    real(DP), intent(in) :: tolf
    real(DP), DIMENSION(:), intent(inout) :: x0(:)
    real(DP), intent(out) :: fmin
  end subroutine fminsearch

  subroutine param
  end subroutine param

  subroutine valuev
  end subroutine valuev

  subroutine modeloutput(ndim,params,tthetal0,tthetal1)
    use nrtype
    use globals
    integer, intent(in) :: ndim
    real(DP),intent(in) :: params(ndim)
    real(DP),intent(in) :: tthetal0(hnum2,qnum), tthetal1(hnum2,qnum)
  end subroutine modeloutput

  function util(cv,lv)
    use nrtype
    real(dp), intent(in) :: cv, lv
    real(dp) :: util
  end function util

  end interface

end module interface
