program main

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !!!!  Kazushige MATSUDA
  !!!!  "Progressive Taxation vs College Subsidies with College Dropout"
  !!!!
  !!!!
  !!!!
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  use globals
  use nrtype
  use interface, only : param,modeloutput,welfare,calibration,fminsearch,linspace,calibration79

  implicit none

  integer :: iii,fo=16
  real(DP) :: SWFopt,CEV,SWFpaopt2(4), params79(3), params_alt(19)
  real(DP) :: params(nparam),params2(16),fmincalib,fmin5(1),xinit5(1),outputtable(8),outputtableopt(8),xinit9(4),xinit8(3),xinit10(3),xinit13(2), xinit20(5)

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Options
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  debug=0 ! 1 if you want to debug (see more statistics for each iteration)
  paternalistic=1 ! social planner evaluates agents values with optimism
  heterostddc=0! no optimism and standard deviation of epsilon_c is hetero w.r.t. high school ability
  bbase1=6125.0d0 ! borrowing limit for the first period
  bbase2=bbase ! borrowing limit for the second period
  trans0 = 0.0d0 ! transfers to receive when you get economically independent
  nodropout=0 ! No dropout options for agents
  ppwfixed=0 ! using initial weights for calculating welfare
  CEVallind=1 ! maximizing welfare for the whole population (not only for newborns)
  omitj2=0 ! omitting j=2 people when evaluating welfare for the whole population (CEVallind=1)
  i_common_loading = 0 ! common loading factors for psychic cost

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Data moments
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  dat(1) = pfrac(1)
  dat(2) = pfrac(2)
  dat(3) = pfrac(3)
  dat(4) = pfrac(4)
  dat(5) = eandg/ybase
  dat(6) = 0.333d0
  dat(7) = 2.65d0/dble(dj)
  dat(8) = btbase/ybase
  dat(9) = 0.61d0
  dat(10) = 0.068d0
  dat(11) = meanh
  dat(12) = stddh
  dat(13) = 1.4333d0-1.0d0
  dat(14) = qfrac(1)/pfrac(1)
  dat(15) = qfrac(2)/pfrac(2)
  dat(16) = qfrac(3)/pfrac(3)
  dat(17) = qfrac(4)/pfrac(4)
  dat(18) = pfracinc(1)
  dat(19) = pfracinc(2)
  dat(20) = pfracinc(3)
  dat(21) = pfracinc(4)
  dat(22) = (qfracinc(1))/pfracinc(1)
  dat(23) = (qfracinc(2))/pfracinc(2)
  dat(24) = (qfracinc(3))/pfracinc(3)
  dat(25) = (qfracinc(4))/pfracinc(4)
  dat(26) = .90179d0!.885526d0
  dat(27) = .198507d0!.197072d0

  dat(28) = 0.4474943!0.4105199d0!0.2006623
  dat(29)=0.295699!0.17667d0!0.113185
  dat(30)=0.289562!0.201692d0!0.145427

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Calibration
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


  weltest=0
  taxelas=0
  peind=0

  params(1) = 0.183801062173498
  params(2) =-0.441200720686365
  params(3) =30.4297413680128
  params(4) = -275.004352050853
  params(5) =0.320958196676453
  params(6) =0.416792219089547
  params(7) =6.072417744945946E-002
  params(8) =9.557009216841435E-002
  params(9) =0.122111552271146
  params(10) =0.195145413783635
  params(11) =-3.071732407757428E-002
  params(12) =0.173269392411136
  params(13) =55.9435988687376
  params(14) =0.295410119179623
  params(15) =59.6101920968545
  params(16) =0.442668784069413
  params(17) =1.01282569421396
  params(18) =1.81955754959930
  params(19) =0.553589710857137
  params(20) =0.545196180309421
  paramsbench=params

  ! The case with no dropout options
  if (nodropout==1) then

    params(1) =-12.4471077636904
    params(2) =-150.866335725899
    params(3) =88.9029878834798
    params(4) =0.496894992836600

    datnd(1) = qfrac(1)
    datnd(2) = qfrac(2)
    datnd(3) = qfrac(3)
    datnd(4) = qfrac(4)
    datnd(5) = qfracinc(1)
    datnd(6) = qfracinc(2)
    datnd(7) = qfracinc(3)
    datnd(8) = qfracinc(4)
    datnd(9) = dat(26)

    ! call fminsearch(calibration,params(1:4),fmincalib,0.001d0)
    ! stop

  else

    ! The case without optimism
    if (heterostddc==1) then


      params(1) =5.90850352649730
      params(2) =-262.514020454539
      params(3) = 0.397223552234909
      params(4) = 0.428193636927409
      params(5) =4.883001929577956E-002
      params(6) =8.118201131582072E-002
      params(7) =9.864078681071256E-002
      params(8) =0.251013565684545
      params(9) =-2.995867624206996E-002
      params(10) =0.111600760118579
      params(11) =73.4920436929855
      params(12) =0.570284911783610
      params(13) =44.6720812933789
      params(14) =0.428129737721884
      params(15) =0.964180257658812
      params(16) =0.474799796834128
      params(17) =1.27329953832567
      params(18) =0.610705686419462
      params(19) =0.643252745088532

      ! open(fo, file='minxdata.d')
      ! read(fo,*) params(1:16)
      ! close(fo)

      !!!!!!!!!!!!!!!!!!!!!!!!!!! CALIBRATION
      ! call fminsearch(calibration,params(1:19),fmincalib,0.001d0)
      ! stop
      !!!!!!!!!!!!!!!!!!!!!!!!!!!! CALIBRATION

      !benchmark case
    else

      if(i_common_loading==1)then

        params(1) = 0.182826219808751
        params(2) =-0.445863162549599
        params(3) =30.1948268015583
        params(4) = -276.788934588253
        params(5) =0.320377044200475
        params(6) =0.414453013672800
        params(7) =6.043644261059143E-002
        params(8) =9.580394309269256E-002
        params(9) =0.120554212787924
        params(10) =0.193040774408217
        params(11) =-3.153128057616066E-002
        params(12) =0.173482695980462
        params(13) =58.6834839877567
        params(14) =0.297474516949021
        params(15) =59.6101920968545
        params(16) =0.440796296247664
        params(17) =1.01406168405510
        params(18) =1.82332867216150
        params(19) =0.553271367895388
        params(20) =0.551668466052284

        params_alt(1:14) = params(1:14)
        params_alt(15:19) = params(16:20)

        !!!!!!!!!!!!!!!!!!!!!!!!!!!! CALIBRATION
        ! call fminsearch(calibration,params_alt,fmincalib,0.001d0)
        ! stop
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!! CALIBRATION

      else

        ! benchmark parameters

        params=paramsbench


        ! open(fo, file='minxdata.d')
        ! read(fo,*) params
        ! close(fo)

        !!!!!!!!!!!!!!!!!!!!!!!!!!!! CALIBRATION
        ! call fminsearch(calibration,params,fmincalib,0.001d0)
        ! stop
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!! CALIBRATION

      endif

    endif

  endif

  ! college subsidies normalized
  do qq=1,qnum
    ttheta(ja,:,qq)=gbase(qq)/ybase
    ttheta(ja+1,:,qq)=gbase(qq)/ybase
  enddo

  calibflag=1
  wel=0

  call modeloutput(nparam,params,ttheta(ja,:,:),ttheta(ja+1,:,:))

  YNeq=ybar
  Eeq=E0

  ! write(*,*) 'E0 per capita',E0/sum(Nvec(ja:jend))/YNeq*ybase

  Ceq=sum(C)
  Leq=agleis
  diseq=dsumaggdis
  punceq=punc
  pineeq=pine
  Vleveq=Vlev

  qfracm44eq=qfracm44_3

  q1primeeq=q1prime
  q2primeeq=q2prime
  enrolleq=P1+P2
  gradeq=P1/(P1+P2)
  tauleq=taul
  Zeq=Z
  tuitioneq=tuition

  SWFpa2sq=SWFpa2

  i25eq=i25
  i50eq=i50
  i75eq=i75

  grants0=grants00
  aggdis4eq=aggdis4
  V00eq=sum(pppp0(:,:,:,:,:)*V00aux3(:,:,:,:,:))
  V00eqall=V00aux3all

  aggdis2eq=sum(pppp0(:,:,:,:,:)*dis(:,:,:,:,:))
  aggdis2eqall=disall

  pfrac43eq=pfrac43
  qfrac43eq=qfrac43
  qfracthetac43eq=qfracthetac43

  ! populations of the benchmark case
  pppp0eq=pppp0
  ppwseq=ppws
  ppweq=ppw
  ppreq=ppr

  write(*,*) 'prices', r, w, taul



  write(*,*) 'grantsja', grants00(ja,1,:)/YNeq*ybase
  write(*,*) 'grantsja+1', grants00(ja+1,1,:)/YNeq*ybase
  write(*,*) 'enrollgrad', P1+P2,P1
  write(*,*) 'skill prem', mskillp1, mskillp2

  ! the test how people change behavior after optimal colleges (benchmark)
  hh=13 ! median ability
  qq=1 ! poor family
  eetai=1
  ke=15 ! median taste

  if (sum(ppws(:,hh,qq,ja,2,eetai,ke))<m) then
    write(*,*) 'the population of targets of experiment is zero'
  else
    consjaeq=sum(ppws(:,hh,qq,ja,2,eetai,ke)*csmatinterp(:,hh,qq,ja,eetai,ke))/sum(ppws(:,hh,qq,ja,2,eetai,ke))
    transferjaeq=sum(ppws(:,hh,qq,ja,2,eetai,ke)*agrid2(ja,:,2))/sum(ppws(:,hh,qq,ja,2,eetai,ke))
    tuitionjaeq=-tuition
    grantsjaeq=grants(ja,hh,qq)
    lumpsumjaeq=Z
    savingsjaeq=-sum(ppws(:,hh,qq,ja,2,eetai,ke)*asmatinterp(:,hh,qq,ja,eetai,ke))/sum(ppws(:,hh,qq,ja,2,eetai,ke))
    laborincomejaeq=sum(ppws(:,hh,qq,ja,2,eetai,ke)*(1.0d0-taul)*w(3)*eeta(3,eetai)*aap(3,ja)*ghgridinterp(3,hh)*(1.0d0-stime-lsmatinterp(:,hh,qq,ja,eetai,ke)))/sum(ppws(:,hh,qq,ja,2,eetai,ke))
    mpjaeq=(1.0d0-taul)*w(3)*eeta(3,eetai)*aap(3,ja)*ghgridinterp(3,hh)*(1.0d0-stime)
    leisurejaeq=sum(ppws(:,hh,qq,ja,2,eetai,ke)*lsmatinterp(:,hh,qq,ja,eetai,ke))/sum(ppws(:,hh,qq,ja,2,eetai,ke))
  endif


  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Output
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


  open(fo, file='output/output-ageprod.d')
  do jj=ja+2,jr-1
    write(fo,'(i10, f10.2, f10.2, f10.2)') 2*jj,log(aap(1,jj))-log(aap(1,ja+2)),log(aap(2,jj))-log(aap(2,ja+2)),log(aap(3,jj))-log(aap(3,ja+2))
  enddo
  close(fo)

  open(fo, file='output/output-gamma.d')
  do iii=1,hnum2
    write(fo,'(f10.2, f10.2, f10.2, f10.2)') hgrid2(iii)-meanh, afqtcoeff(1)*(hgrid2(iii)-meanh),afqtcoeff(2)*(hgrid2(iii)-meanh),afqtcoeff(3)*(hgrid2(iii)-meanh)
  enddo

  close(fo)

  open(fo, file='output/output-erate.d')
  do iii=1,hnum2
    write(fo,'(f10.2, f10.2)') hgrid2(iii)-meanh, sum(ppw(:,iii,ja,2,:))/sum(ppw(:,iii,ja,2:3,:))
  enddo
  close(fo)

  open(fo, file='output/output-crate.d')
  do iii=1,hnum2
    write(fo,'(f10.2, f10.2)') hgrid3(iii)-meanh, sum(ppw(:,iii,ja+1,1,:))/sum(ppw(:,iii,ja+1,1:2,:))
  enddo
  close(fo)

  open(fo, file='output/output-sumpp0.d')
  do iii=1,hnum2
    write(fo,'(f10.2, f10.2)') hgrid2(iii)-meanh, sumpp0(iii)
  enddo
  close(fo)

  pfrac0(:)=pfracm(:)
  qfrac0(:)=qfracm(:)
  pfracincome02eq=pfracincome02
  qfracincome02eq=qfracincome02

  if (heterostddc==1) then

    open(fo, file='output/output-enroll_hetero.d')
    do iii=1,4
      write(fo,*) iii,pfrac(iii),pfrac0(iii)
    enddo
    close(fo)

    open(fo, file='output/output-grad_hetero.d')
    do iii=1,4
      write(fo,*) iii,(qfrac(iii))/pfrac(iii),(qfrac0(iii))/pfrac0(iii)
    enddo
    close(fo)

    open(fo, file='output/output-enroll-income_hetero.d')
    iii=1
    write(fo,*) 'q=1' ,pfracinc(iii),pfracincome02eq(iii)
    iii=2
    write(fo,*) 'q=2',pfracinc(iii),pfracincome02eq(iii)
    iii=3
    write(fo,*) 'q=3',pfracinc(iii),pfracincome02eq(iii)
    iii=4
    write(fo,*) 'q=4',pfracinc(iii),pfracincome02eq(iii)
    close(fo)

    open(fo, file='output/output-grad-income_hetero.d')
    iii=1
    write(fo,*) 'q=1',(qfracinc(iii))/pfracinc(iii),(qfracincome02eq(iii))/pfracincome02eq(iii)
    iii=2
    write(fo,*) 'q=2',(qfracinc(iii))/pfracinc(iii),(qfracincome02eq(iii))/pfracincome02eq(iii)
    iii=3
    write(fo,*) 'q=3',(qfracinc(iii))/pfracinc(iii),(qfracincome02eq(iii))/pfracincome02eq(iii)
    iii=4
    write(fo,*) 'q=4',(qfracinc(iii))/pfracinc(iii),(qfracincome02eq(iii))/pfracincome02eq(iii)
    close(fo)

  else

    open(fo, file='output/output-enroll.d')
    do iii=1,4
      write(fo,*) iii,pfrac(iii),pfrac0(iii)
    enddo
    close(fo)

    open(fo, file='output/output-grad.d')
    do iii=1,4
      write(fo,*) iii,(qfrac(iii))/pfrac(iii),(qfrac0(iii))/pfrac0(iii)
    enddo
    close(fo)

    open(fo, file='output/output-enroll-income.d')
    iii=1
    write(fo,*) 'q=1' ,pfracinc(iii),pfracincome02eq(iii)
    iii=2
    write(fo,*) 'q=2',pfracinc(iii),pfracincome02eq(iii)
    iii=3
    write(fo,*) 'q=3',pfracinc(iii),pfracincome02eq(iii)
    iii=4
    write(fo,*) 'q=4',pfracinc(iii),pfracincome02eq(iii)
    close(fo)

    open(fo, file='output/output-grad-income.d')
    iii=1
    write(fo,*) 'q=1',(qfracinc(iii))/pfracinc(iii),(qfracincome02eq(iii))/pfracincome02eq(iii)
    iii=2
    write(fo,*) 'q=2',(qfracinc(iii))/pfracinc(iii),(qfracincome02eq(iii))/pfracincome02eq(iii)
    iii=3
    write(fo,*) 'q=3',(qfracinc(iii))/pfracinc(iii),(qfracincome02eq(iii))/pfracincome02eq(iii)
    iii=4
    write(fo,*) 'q=4',(qfracinc(iii))/pfracinc(iii),(qfracincome02eq(iii))/pfracincome02eq(iii)
    close(fo)

  endif


  open(fo, file='output/output-modelfit.d')
  write(fo,*) sum(pfrac0)/4.0d0,P1+P2
  write(fo,*) sum(qfrac0)/sum(pfrac0), P2/(P1+P2)
  close(fo)

  outputtable(1)=Y/NN
  outputtable(2)= K/NN
  outputtable(3)=sum(C)/NN
  outputtable(4)= w(1)
  outputtable(5)=w(2)
  outputtable(6)=w(3)
  outputtable(7)=H(1)/P1
  outputtable(8)=H(3)/(1d0-P1)


  open(fo, file='output/output-table.d')
  do iii=1,size(outputtable)
    write(fo,*) outputtable(iii)
  enddo
  close(fo)

  open(fo, file='output/output-mean-cons-lifecycle.d')
  do jj=1,jend
    write(fo,'(i10, 3f10.4)') jaage + (jj-1)*2, meancw_age(jj, :)
  enddo
  close(fo)

  open(fo, file='output/output-mean-asset-lifecycle.d')
  do jj=1,jend
    write(fo,'(i10, 3f10.4)') jaage + (jj-1)*2, meanaw_age(jj, :)
  enddo
  close(fo)

  open(fo, file='output/output-mean-wage-lifecycle.d')
  do jj=1,jend
    write(fo,'(i10, 3f10.4)') jaage + (jj-1)*2, meanww_age(jj, :)
  enddo
  close(fo)

  open(fo, file='output/output-std-cons-lifecycle.d')
  do jj=1,jend
    write(fo,'(i10, 3f10.4)') jaage + (jj-1)*2, stdcw_age(jj, :)
  enddo
  close(fo)

  open(fo, file='output/output-std-asset-lifecycle.d')
  do jj=1,jend
    write(fo,'(i10, 3f10.4)') jaage + (jj-1)*2, stdaw_age(jj, :)
  enddo
  close(fo)

  open(fo, file='output/output-std-wage-lifecycle.d')
  do jj=1,jend
    write(fo,'(i10, 3f10.4)') jaage + (jj-1)*2, stdww_age(jj, :)
  enddo
  close(fo)



  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !!!!
  !!!!  To get the results for the following cases, comment in only one block and comment out the others
  !!!!
  !!!!
  !!!
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


  ! grantsopt(ja,:,1)=grants0(ja,1,1)
  ! grantsopt(ja,:,2)=grants0(ja,1,2)
  ! grantsopt(ja,:,3)=grants0(ja,1,3)
  ! grantsopt(ja+1,:,1)=exp(xinit5(1))*grants0(ja,1,1)
  ! grantsopt(ja+1,:,2)=exp(xinit5(1))*grants0(ja,1,2)
  ! grantsopt(ja+1,:,3)=exp(xinit5(1))*grants0(ja,1,3)
  !
  !
  !
  ! print*,'----------------------------------'
  ! write(*,*) 'optimal college subsidies'
  ! print*,'----------------------------------'
  ! calibflag=0
  ! wel=1
  ! weltest=15
  ! taxelas=0
  !
  !
  ! bbase1=6125.0d0 ! borrowing limit for the first period
  ! bbase2=bbase ! borrowing limit for the second period
  !
  ! Efix=1.0d0*Eeq
  !
  ! if (ppwfixed==1) then
  !   if (nodropout==1) then
  !     xinit5(1)=1.71059596538544
  !   else
  !     xinit5(1)=1.14039731025696
  !   endif
  ! else
  !   if (nodropout==1) then
  !     xinit5(1)=    2.39939470291138
  !
  !   else
  !     xinit5(1)=      2.04663892090320
  !    ! 2.18734539449215 for common subsidies
  !
  !
  !   endif
  ! endif
  !
  ! call fminsearch(welfare,xinit5,fmin5(1),0.00001d0)
  ! stop
  !
  ! grantsopt(ja,:,1)=grants0(ja,1,1)
  ! grantsopt(ja,:,2)=grants0(ja,1,2)
  ! grantsopt(ja,:,3)=grants0(ja,1,3)
  ! grantsopt(ja+1,:,1)=grants0(ja,1,1)
  ! grantsopt(ja+1,:,2)=grants0(ja,1,2)
  ! grantsopt(ja+1,:,3)=grants0(ja,1,3)
  ! Efix=exp(xinit5(1))*Eeq

  ! print*,'----------------------------------'
  ! write(*,*) 'optimal progressive tax'
  ! print*,'----------------------------------'
  ! calibflag=0
  ! wel=1
  ! weltest=11
  ! taxelas=0
  !
  ! Efix=1.0d0*Eeq
  !
  ! bbase1=6125.0d0 ! borrowing limit for the first period
  ! bbase2=bbase ! borrowing limit for the second period
  !
  ! if (ppwfixed==1) then
  !   if (nodropout==1) then
  !    xinit5(1)=0.157445971667767
  !  else
  !    xinit5(1)= 0.158638741821051
  !  endif
  ! else
  !   if (nodropout==1) then
  !    xinit5(1)=    0.115043404698372
  !  else
  !    xinit5(1)=    0.113183274306357
  !  endif
  ! endif
  !
  ! ! call fminsearch(welfare,xinit5,fmin5(1),0.00001d0)
  ! ! stop
  !
  ! grantsopt(ja,:,1)=grants0(ja,1,1)
  ! grantsopt(ja,:,2)=grants0(ja,1,2)
  ! grantsopt(ja,:,3)=grants0(ja,1,3)
  ! grantsopt(ja+1,:,1)=grants0(ja,1,1)
  ! grantsopt(ja+1,:,2)=grants0(ja,1,2)
  ! grantsopt(ja+1,:,3)=grants0(ja,1,3)
  ! if (nodropout==1) then
  !  d=xinit5(1)
  ! else
  !  params(9)=xinit5(1)
  ! endif

  print*,'----------------------------------'
  write(*,*) 'optimal college subsidies and progressive tax'
  print*,'----------------------------------'
  calibflag=0
  wel=1
  weltest=13
  taxelas=0


  Efix=1.0d0*Eeq

  bbase1=6125.0d0 ! borrowing limit for the first period
  bbase2=bbase ! borrowing limit for the second period

  if (nodropout==1) then
    xinit13(1)= 3.20158357683795
    xinit13(2)=5.303477224411635E-002
    ! common subsidies
    !xinit13(1)=  2.93145000562072
    !xinit13(2)= 5.195750244311040E-002
  else
    xinit13(1)=  2.14408859540708
    xinit13(2)=9.085449906342538E-002

    ! common subsidies
    !xinit13(1)=  2.16424168235972
    !xinit13(2)= 8.682526745433274E-002
  endif

  call fminsearch(welfare,xinit13,fmin5(1),0.00001d0)
  stop

  grantsopt(ja,:,1)=grants0(ja,1,1)
  grantsopt(ja,:,2)=grants0(ja,1,2)
  grantsopt(ja,:,3)=grants0(ja,1,3)
  grantsopt(ja+1,:,1)=grants0(ja,1,1)
  grantsopt(ja+1,:,2)=grants0(ja,1,2)
  grantsopt(ja+1,:,3)=grants0(ja,1,3)
  Efix=exp(xinit13(1))*Eeq
  params(9)=xinit13(2)


  ! print*,'----------------------------------'
  ! write(*,*) 'optimal need-based grants w/ dependent subsidies'
  ! print*,'----------------------------------'
  ! calibflag=0
  ! wel=1
  ! weltest=17
  ! taxelas=0

  ! Efix=1.0d0*Eeq
  ! bbase1=6125.0d0 ! borrowing limit for the first period
  ! bbase2=bbase ! borrowing limit for the second period

  ! xinit10(1) = -0.344544878270891
  ! xinit10(2) = -5.57419008678860
  ! xinit10(3) = 0.259259259259259

  ! ! call fminsearch(welfare,xinit10,fmin5(1),0.00001d0)
  ! ! stop

  ! grantsopt(ja,:,1)=grants0(ja,13,1)
  ! grantsopt(ja,:,2)=grants0(ja,13,1)*exp(xinit10(1))
  ! grantsopt(ja,:,3)=grants0(ja,13,1)*exp(xinit10(2))
  ! grantsopt(ja+1,:,1)=exp(xinit10(3))*grants0(ja+1,13,1)
  ! grantsopt(ja+1,:,2)=exp(xinit10(3))*grants0(ja+1,13,1)*exp(xinit10(1))
  ! grantsopt(ja+1,:,3)=exp(xinit10(3))*grants0(ja+1,13,1)*exp(xinit10(2))


  !   print*,'----------------------------------'
  !   write(*,*) 'optimal need- and merit-based grants w/ fixed budget'
  !   print*,'----------------------------------'
  !   calibflag=0
  !   wel=1
  !   weltest=8
  ! taxelas=0


  !   Efix=1.0d0*Eeq
  ! bbase1=6125.0d0 ! borrowing limit for the first period
  ! bbase2=bbase ! borrowing limit for the second period

  ! xinit8(1) =  -0.980481289095938
  !   xinit8(2) = 7.54190205733465
  ! xinit8(3) = -6.93990372013514

  !   call fminsearch(welfare,xinit8,fmin5(1),0.00001d0)
  !   stop

  !   grantsopt(ja,:,1)=grants0(ja,13,1)*exp(xinit8(1)*(hgrid2(:)-hgrid2(13)))
  !   grantsopt(ja,:,2)=grants0(ja,13,1)*exp(xinit8(2))*exp(xinit8(1)*(hgrid2(:)-hgrid2(13)))
  !   grantsopt(ja,:,3)=grants0(ja,13,1)*exp(xinit8(3))*exp(xinit8(1)*(hgrid2(:)-hgrid2(13)))
  !   grantsopt(ja+1,:,1)=grants0(ja+1,13,1)*exp(xinit8(1)*(hgrid3(:)-hgrid3(13)))
  !   grantsopt(ja+1,:,2)=grants0(ja+1,13,1)*exp(xinit8(2))*exp(xinit8(1)*(hgrid3(:)-hgrid3(13)))
  !   grantsopt(ja+1,:,3)=grants0(ja+1,13,1)*exp(xinit8(3))*exp(xinit8(1)*(hgrid3(:)-hgrid3(13)))



  ! print*,'----------------------------------'
  ! write(*,*) 'optimal need- and merit-based year-dependent grants w/ fixed budget'
  ! print*,'----------------------------------'
  ! calibflag=0
  ! wel=1
  ! weltest=9
  ! taxelas=0


  ! Efix=1.0d0*Eeq
  ! bbase1=6125.0d0 ! borrowing limit for the first period
  ! bbase2=bbase ! borrowing limit for the second period

  ! xinit9(1) = -0.790812098536638
  ! xinit9(2) =11.0163232849956
  ! xinit9(3) = -9.50564655055181
  ! xinit9(4) = 6.164498898433551E-002

  ! call fminsearch(welfare,xinit9,fmin5(1),0.00001d0)
  ! stop

  ! grantsopt(ja,:,1)=grants0(ja,13,1)*exp(xinit9(1)*(hgrid2(:)-hgrid2(13)))
  ! grantsopt(ja,:,2)=grants0(ja,13,1)*exp(xinit9(2))*exp(xinit9(1)*(hgrid2(:)-hgrid2(13)))
  ! grantsopt(ja,:,3)=grants0(ja,13,1)*exp(xinit9(3))*exp(xinit9(1)*(hgrid2(:)-hgrid2(13)))
  ! grantsopt(ja+1,:,1)=exp(xinit9(4))*grants0(ja+1,13,1)*exp(xinit9(1)*(hgrid3(:)-hgrid3(13)))
  ! grantsopt(ja+1,:,2)=exp(xinit9(4))*grants0(ja+1,13,1)*exp(xinit9(2))*exp(xinit9(1)*(hgrid3(:)-hgrid3(13)))
  ! grantsopt(ja+1,:,3)=exp(xinit9(4))*grants0(ja+1,13,1)*exp(xinit9(3))*exp(xinit9(1)*(hgrid3(:)-hgrid3(13)))

  ! print*,'----------------------------------'
  ! write(*,*) 'taul elasticity: transfers'
  ! print*,'----------------------------------'
  !
  ! calibflag=0
  ! wel=1
  ! taxelas=1
  ! delas=1
  ! grantsopt=grants0

  ! print*,'----------------------------------'
  ! write(*,*) 'taul elasticity: college subsidies'
  ! print*,'----------------------------------'
  !
  ! calibflag=0
  ! wel=1
  ! taxelas=1
  ! delas=0
  ! grantsopt=grants0

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Results
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  call modeloutput(nparam,params,grantsopt(ja,:,:),grantsopt(ja+1,:,:))

  ! write(*,*) 'E/E0', E0/Eeq
  ! write(*,*) 'E0 per capita',E0/sum(Nvec(ja:jend))/YNeq*ybase


  write(*,*) 'grantsja', grants(ja,13,:)/YNeq*ybase
  write(*,*) 'grantsja+1', grants(ja+1,13,:)/YNeq*ybase

  write(*,*) 'grantsja abil', grants(ja,:,2)/YNeq*ybase
  write(*,*) 'grantsja+1 abil', grants(ja+1,:,2)/YNeq*ybase

  ! write(*,*) 'tuition', w(1)*kappa/YNeq*ybase

  write(*,*) 'enrollgrad', P1+P2,P1
  write(*,*) 'skill prem', mskillp1, mskillp2

  SWFopt = SWF2
  SWFpa2opt=SWFpa2
  qfracm44opt=qfracm44_3
  V00opt=sum(pppp0(:,:,:,:,:)*V00aux3(:,:,:,:,:))
  disopt=dsumaggdis
  aggdis4opt=aggdis4
  aggdis2opt=sum(pppp0(:,:,:,:,:)*dis(:,:,:,:,:))

  V00optall=V00aux3all
  aggdis2optall=disall

  pfrac43opt=pfrac43
  qfrac43opt=qfrac43


  write(*,*) SWFopt!, SWFpaopt

  CEV=((V00opt+aggdis2opt-aggdis2eq)/V00eq)**(1.0d0/(mmu*(1.0d0-ssigma)))-1.0d0
  ! CEVall=((SWF2all-aggdis2eqall)/V00eqall)**(1.0d0/(mmu*(1.0d0-ssigma)))-1.0d0
  CEVall=((V00optall+aggdis2optall-aggdis2eqall)/V00eqall)**(1.0d0/(mmu*(1.0d0-ssigma)))-1.0d0


  write(*,*) 'CEV', CEV, 'CEVall', CEVall

  do hh=1,4
    do qq=1,qnum
      CEVpa2(hh,qq)=((SWFpa2opt(hh,qq)+aggdis4opt(hh,qq)-aggdis4eq(hh,qq))/SWFpa2sq(hh,qq))**(1.0d0/(mmu*(1.0d0-ssigma)))-1.0d0
    enddo
  enddo

  open(fo, file='output/output-welfare.d')
  do iii=1,4
    write(fo,*) CEVpa2(iii,1:qnum)
  enddo
  close(fo)

  Copt=sum(C)
  Lopt=agleis
  puncopt=punc
  pineopt=pine

  Vlevopt=Vlev

  write(*,*) 'C', Ceq, Copt
  write(*,*) 'L', Leq, Lopt

  ! write(*,*) 'omlevpart', Vlevopt,Vleveq,diseq,disopt

  omlev=((Vlevopt+disopt-diseq)/Vleveq)**(1.0d0/mmu/(1.0d0-ssigma))-1.0d0
  omunc=(1.0d0-puncopt)/(1.0d0-punceq)-1.0d0
  omine=(1.0d0-pineopt)/(1.0d0-pineeq)-1.0d0

  omU = (1.0d0+omlev)*(1.0d0+omunc)*(1.0d0+omine)-1.0d0
  ominemec = (1.0d0+CEV)/(1.0d0+omlev)/(1.0d0+omunc)-1.0d0 ! inequality gain as the residual

  write(*,*) 'welfare', omlev, omunc, omine

  hh=13
  qq=1
  eetai=1
  ke=15

  if (sum(ppws(:,hh,qq,ja,2,eetai,ke))<m) then
    write(*,*) 'the population of targets of experiment is zero'
  else

    consjaopt=sum(ppws(:,hh,qq,ja,2,eetai,ke)*csmatinterp(:,hh,qq,ja,eetai,ke))/sum(ppws(:,hh,qq,ja,2,eetai,ke))
    transferjaopt=sum(ppws(:,hh,qq,ja,2,eetai,ke)*agrid2(ja,:,2))/sum(ppws(:,hh,qq,ja,2,eetai,ke))
    tuitionjaopt=-tuition
    grantsjaopt=grants(ja,hh,qq)
    lumpsumjaopt=Z
    savingsjaopt=-sum(ppws(:,hh,qq,ja,2,eetai,ke)*asmatinterp(:,hh,qq,ja,eetai,ke))/sum(ppws(:,hh,qq,ja,2,eetai,ke))
    laborincomejaopt=sum(ppws(:,hh,qq,ja,2,eetai,ke)*(1.0d0-taul)*w(3)*eeta(3,eetai)*aap(3,ja)*ghgridinterp(3,hh)*(1.0d0-stime-lsmatinterp(:,hh,qq,ja,eetai,ke)))/sum(ppws(:,hh,qq,ja,2,eetai,ke))
    mpjaopt=(1.0d0-taul)*w(3)*eeta(3,eetai)*aap(3,ja)*ghgridinterp(3,hh)*(1.0d0-stime)
    leisurejaopt=sum(ppws(:,hh,qq,ja,2,eetai,ke)*lsmatinterp(:,hh,qq,ja,eetai,ke))/sum(ppws(:,hh,qq,ja,2,eetai,ke))

    write(*,*) 'subsidies', grantsjaopt-grantsjaeq
    write(*,*) 'laborincome', laborincomejaopt-laborincomejaeq, -(laborincomejaopt-laborincomejaeq)/(grantsjaopt-grantsjaeq)
    write(*,*) 'mp', mpjaopt-mpjaeq, -(mpjaopt-mpjaeq)/(grantsjaopt-grantsjaeq)
    write(*,*) 'leisure', leisurejaopt-leisurejaeq, -(leisurejaopt-leisurejaeq)/(grantsjaopt-grantsjaeq)
    write(*,*) 'transfer', transferjaopt-transferjaeq, -(transferjaopt-transferjaeq)/(grantsjaopt-grantsjaeq)
    write(*,*) 'savings', savingsjaopt-savingsjaeq, -(savingsjaopt-savingsjaeq)/(grantsjaopt-grantsjaeq)
    write(*,*) 'tuition', tuitionjaopt-tuitionjaeq, -(tuitionjaopt-tuitionjaeq)/(grantsjaopt-grantsjaeq)
    write(*,*) 'cons', consjaopt-consjaeq, -(consjaopt-consjaeq)/(grantsjaopt-grantsjaeq)
    write(*,*) 'lumsum', lumpsumjaopt-lumpsumjaeq, -(lumpsumjaopt-lumpsumjaeq)/(grantsjaopt-grantsjaeq)

  endif


  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Output
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  pfrac1(:)=pfracm(:)
  qfrac1(:)=qfracm(:)

  open(fo, file='output/output-enroll-grad-opt.d')
  write(fo,*) 'enroll', sum(pfrac0(:))/4.0d0,sum(pfrac1(:))/4.0d0
  write(fo,*) 'grad', sum(qfrac0)/sum(pfrac0(:)),sum(qfrac1)/sum(pfrac1(:))
  close(fo)

  if(weltest==19)then

    open(fo, file='output/output-enroll-merit.d')
    write(fo,*) 'status-quo','optimal'
    do iii=1,4
      write(fo,*) iii,pfrac0(iii),pfrac1(iii)
    enddo
    close(fo)

    open(fo, file='output/output-grad-merit.d')
    write(fo,*) 'status-quo','optimal'
    do iii=1,4
      write(fo,*) iii,(qfrac0(iii))/pfrac0(iii),(qfrac1(iii))/pfrac1(iii)
    enddo
    close(fo)

    open(fo, file='output/output-enroll-income-merit.d')
    iii=1
    write(fo,*) 'q=1' ,pfracincome02eq(iii),pfracincome02(iii)
    iii=2
    write(fo,*) 'q=2',pfracincome02eq(iii),pfracincome02(iii)
    iii=3
    write(fo,*) 'q=3',pfracincome02eq(iii),pfracincome02(iii)
    iii=4
    write(fo,*) 'q=4',pfracincome02eq(iii),pfracincome02(iii)
    close(fo)

    open(fo, file='output/output-grad-income-merit.d')
    iii=1
    write(fo,*) 'q=1',(qfracincome02eq(iii))/pfracincome02eq(iii),(qfracincome02(iii))/pfracincome02(iii)
    iii=2
    write(fo,*) 'q=2',(qfracincome02eq(iii))/pfracincome02eq(iii),(qfracincome02(iii))/pfracincome02(iii)
    iii=3
    write(fo,*) 'q=3',(qfracincome02eq(iii))/pfracincome02eq(iii),(qfracincome02(iii))/pfracincome02(iii)
    iii=4
    write(fo,*) 'q=4',(qfracincome02eq(iii))/pfracincome02eq(iii),(qfracincome02(iii))/pfracincome02(iii)
    close(fo)

    open(fo, file='output/output-merit-1.d')
    do iii=1,hnum2
      write(fo,'(f10.2, f10.2)') hgrid2(iii), grants(ja,iii,2)/YNeq*ybase
    enddo
    close(fo)

    open(fo, file='output/output-merit-2.d')
    do iii=1,hnum2
      write(fo,'(f10.2, f10.2)') hgrid3(iii), grants(ja+1,iii,2)/YNeq*ybase
    enddo
    close(fo)

  elseif(weltest==20)then
    open(fo, file='output/output-enroll-need.d')
    write(fo,*) 'status-quo','optimal'
    do iii=1,4
      write(fo,*) iii,pfrac0(iii),pfrac1(iii)
    enddo
    close(fo)

    open(fo, file='output/output-grad-need.d')
    write(fo,*) 'status-quo','optimal'
    do iii=1,4
      write(fo,*) iii,(qfrac0(iii))/pfrac0(iii),(qfrac1(iii))/pfrac1(iii)
    enddo
    close(fo)

    open(fo, file='output/output-enroll-income-need.d')
    iii=1
    write(fo,*) 'q=1' ,pfracincome02eq(iii),pfracincome02(iii)
    iii=2
    write(fo,*) 'q=2',pfracincome02eq(iii),pfracincome02(iii)
    iii=3
    write(fo,*) 'q=3',pfracincome02eq(iii),pfracincome02(iii)
    iii=4
    write(fo,*) 'q=4',pfracincome02eq(iii),pfracincome02(iii)
    close(fo)

    open(fo, file='output/output-grad-income-need.d')
    iii=1
    write(fo,*) 'q=1',(qfracincome02eq(iii))/pfracincome02eq(iii),(qfracincome02(iii))/pfracincome02(iii)
    iii=2
    write(fo,*) 'q=2',(qfracincome02eq(iii))/pfracincome02eq(iii),(qfracincome02(iii))/pfracincome02(iii)
    iii=3
    write(fo,*) 'q=3',(qfracincome02eq(iii))/pfracincome02eq(iii),(qfracincome02(iii))/pfracincome02(iii)
    iii=4
    write(fo,*) 'q=4',(qfracincome02eq(iii))/pfracincome02eq(iii),(qfracincome02(iii))/pfracincome02(iii)
    close(fo)

  else

    open(fo, file='output/output-enroll-opt.d')
    write(fo,*) 'status-quo','optimal'
    do iii=1,4
      write(fo,*) iii,pfrac0(iii),pfrac1(iii)
    enddo
    close(fo)

    open(fo, file='output/output-grad-opt.d')
    write(fo,*) 'status-quo','optimal'
    do iii=1,4
      write(fo,*) iii,(qfrac0(iii))/pfrac0(iii),(qfrac1(iii))/pfrac1(iii)
    enddo
    close(fo)

    open(fo, file='output/output-enroll-income-opt.d')
    iii=1
    write(fo,*) 'q=1' ,pfracincome02eq(iii),pfracincome02(iii)
    iii=2
    write(fo,*) 'q=2',pfracincome02eq(iii),pfracincome02(iii)
    iii=3
    write(fo,*) 'q=3',pfracincome02eq(iii),pfracincome02(iii)
    iii=4
    write(fo,*) 'q=4',pfracincome02eq(iii),pfracincome02(iii)
    close(fo)

    open(fo, file='output/output-grad-income-opt.d')
    iii=1
    write(fo,*) 'q=1',(qfracincome02eq(iii))/pfracincome02eq(iii),(qfracincome02(iii))/pfracincome02(iii)
    iii=2
    write(fo,*) 'q=2',(qfracincome02eq(iii))/pfracincome02eq(iii),(qfracincome02(iii))/pfracincome02(iii)
    iii=3
    write(fo,*) 'q=3',(qfracincome02eq(iii))/pfracincome02eq(iii),(qfracincome02(iii))/pfracincome02(iii)
    iii=4
    write(fo,*) 'q=4',(qfracincome02eq(iii))/pfracincome02eq(iii),(qfracincome02(iii))/pfracincome02(iii)
    close(fo)
  endif

  outputtableopt(1)=Y/NN
  outputtableopt(2)= K/NN
  outputtableopt(3)=sum(C)/NN
  outputtableopt(4)= w(1)
  outputtableopt(5)=w(2)
  outputtableopt(6)=w(3)
  outputtableopt(7)=H(1)/P1
  outputtableopt(8)=H(3)/(1d0-P1)

  open(fo, file='output/output-table-opt.d')
  do iii=1,size(outputtableopt)
    write(fo,*) outputtableopt(iii)
  enddo
  close(fo)

  open(fo, file='output/grad-diff.d')
  write(fo,*) 'status-quo','optimal'
  do hh=1,4
    write(fo,*) qfracm44opt(hh,:)-qfracm44eq(hh,:)
  enddo
  close(fo)



  stop

end program main
