subroutine modelmoments

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !!!!  Kazushige MATSUDA
  !!!!  "Progressive Taxation vs College Subsidies with College Dropout"
  !!!!
  !!!!
  !!!!  Generating moments and aggregates from a solved equilibrium
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  use globals
  use nrtype
  use nr, only : polint, locate, sort2
  use nrutil, only : iminloc
  use interface, only : normcdf, valuev, linspace

  implicit none

  integer :: iii, ind, fo=16, aa2, ij
  real(DP) :: ccost, rv

  agleis= sum(lpw(:,:,:,:,:)) + sum(lpr(:,:,:,:))


  write(*,*) 'r,w=', r,w
  write(*,*) 'rho', 1.0d0/sqrt((stddc/stddh)**2+1.0d0)
  write(*,*) 'school cost', -lambda0/sum(pppp0(:,:,:,:,:)*V00interp(:,:,:,:,:))
  ! write(*,*) 'school cost', lambda(ja,hhm(3),15)=betav*(c**mmu*sum(L)**(1.0_dp-mmu))**(1.0_dp-ssigma)/(1.0_dp-ssigma)/(1.0d0-bbeta**jb*vv)
  ! ccost=((lambda(ja,hhm(3),15)*(1.0d0-bbeta**jb*vv)*(1.0_dp-ssigma)/betav)**(1.0_dp/(1.0_dp-ssigma))/(sum(L)**(1.0_dp-mmu)))**(1.0_dp/mmu)
  ccost=sum(C) - (((-lambda0-bbeta*lambda0+betav*(sum(C)**mmu*agleis**(1.0_dp-mmu))**(1.0_dp-ssigma)/(1.0_dp-ssigma)/(1.0d0)   )*(1.0d0)*(1.0_dp-ssigma)/betav)**(1.0_dp/(1.0_dp-ssigma))/(agleis**(1.0_dp-mmu)))**(1.0_dp/mmu)

  rv=0.0d0
  do jj=ja,jend
    rv=rv+(1.0_dp/RR)**(jj-ja)
  enddo

  write(*,*) 'school cost in dollars per year', ybase/ybar*ccost
  write(*,*) 'school cost in dollars', ybase/ybar*ccost*rv

  write(*,*) 'P1=', P1
  write(*,*) 'P2=', P2
  write(*,*) 'P3=', P3
  write(*,*) 'demand=',(cchi+ddelta)*K/Y+sum(C)/Y+gy!+kappa*w(1)*Nvec(ja)*P1/Ynew
  write(*,*) 'taul=',taul

  if (taxelas==1 .and. delas==1) then
    write(*,*) 'd=',d
  elseif (taxelas==1 .and. delas==0) then
    write(*,*) 'grantprop=',grantprop
  endif





  write(*,*) 'prop', sum(pp0(:,:,1)),sum(pp0(:,:,2)),sum(pp0(:,:,3))
  do jj=ja,jr-1
    popw(:,:,jj,:,:) = Nvec(jj)*ppw(:,:,jj,:,:)
  enddo
  do jj=jr,jend
    popr(:,:,jj,:)=Nvec(jj)*ppr(:,:,jj,:)
  enddo

  write(*,*) 'hours', L(1)/sum(popw(:,:,ja+2:jr-1,1,:)), L(2)/(sum(popw(:,:,ja+1:jr-1,2,:))+Nvec(ja+1)*sum(ppw(:,:,ja+1,1,:))), L(3)/(sum(popw(:,:,ja:jr-1,3,:))+Nvec(ja)*sum(ppw(:,:,ja,2,:)))
  write(*,*) 'mean hour', sum(L)/sum(Nvec(ja:jr-1))


  mskillp1 = (sum(wwpw(:,:,ja+2:jr-1,1,:))/sum(popw(:,:,ja+2:jr-1,1,:)))/(sum(wwpw(:,:,ja+2:jr-1,3,:))/sum(popw(:,:,ja+2:jr-1,3,:)))!LH(1)/LH(3)
  mskillp2 = (sum(wwpw(:,:,ja+2:jr-1,2,:))/sum(popw(:,:,ja+2:jr-1,2,:)))/(sum(wwpw(:,:,ja+2:jr-1,3,:))/sum(popw(:,:,ja+2:jr-1,3,:)))!LH(2)/LH(3)

  write(*,*) 'skill prem', mskillp1, mskillp2

  meanc=sum(popw(:,:,ja:jr-1,:,:)*cmatinterp(:,:,ja:jr-1,:,:))+Nvec(ja)*sum(ppws(:,:,:,ja,2,:,:)*csmatinterp(:,:,:,ja,:,:))&
  +Nvec(ja+1)*sum(ppws(:,:,:,ja+1,1,:,:)*csmatinterp(:,:,:,ja+1,:,:))+ sum(popr(:,:,jr:jend,:)*crmatinterp(:,:,jr:jend,:))
  stdc=sqrt(sum(popw(:,:,ja:jr-1,:,:)*(cmatinterp(:,:,ja:jr-1,:,:)-meanc)**2)+Nvec(ja)*sum(ppws(:,:,:,ja,2,:,:)*(csmatinterp(:,:,:,ja,:,:)-meanc)**2)&
    +Nvec(ja+1)*sum(ppws(:,:,:,ja+1,1,:,:)*(csmatinterp(:,:,:,ja+1,:,:)-meanc)**2)+sum(popr(:,:,jr:jend,:)*(crmatinterp(:,:,jr:jend,:)-meanc)**2)    )
  meana=sum(popw(:,:,ja:jr-1,:,:)*amatinterp(:,:,ja:jr-1,:,:))+Nvec(ja)*sum(ppws(:,:,:,ja,2,:,:)*asmatinterp(:,:,:,ja,:,:))&
  +Nvec(ja+1)*sum(ppws(:,:,:,ja+1,1,:,:)*asmatinterp(:,:,:,ja+1,:,:))+ sum(popr(:,:,jr:jend,:)*armatinterp(:,:,jr:jend,:))
  stda=sqrt(sum(popw(:,:,ja:jr-1,:,:)*(amatinterp(:,:,ja:jr-1,:,:)-meana)**2)+Nvec(ja)*sum(ppws(:,:,:,ja,2,:,:)*(asmatinterp(:,:,:,ja,:,:)-meana)**2)&
    +Nvec(ja+1)*sum(ppws(:,:,:,ja+1,1,:,:)*(asmatinterp(:,:,:,ja+1,:,:)-meana)**2)+sum(popr(:,:,jr:jend,:)*(armatinterp(:,:,jr:jend,:)-meana)**2)    )


  meancw=sum(popw(:,:,ja+2:jr-1,:,:)*cmatinterp(:,:,ja+2:jr-1,:,:))/sum(popw(:,:,ja+2:jr-1,:,:))
  stdcw=sqrt(sum(popw(:,:,ja+2:jr-1,:,:)*(cmatinterp(:,:,ja+2:jr-1,:,:)-meancw)**2)/sum(popw(:,:,ja+2:jr-1,:,:)))
  meanaw=sum(popw(:,:,ja+2:jr-1,:,:)*amatinterp(:,:,ja+2:jr-1,:,:))/sum(popw(:,:,ja+2:jr-1,:,:))
  stdaw=sqrt(sum(popw(:,:,ja+2:jr-1,:,:)*(amatinterp(:,:,ja+2:jr-1,:,:)-meanaw)**2)/sum(popw(:,:,ja+2:jr-1,:,:)))
  meanhhw=sum(popw(:,:,ja+2:jr-1,:,:)*hmatinterp(:,:,ja+2:jr-1,:,:))/sum(popw(:,:,ja+2:jr-1,:,:))
  stdhhw=sqrt(sum(popw(:,:,ja+2:jr-1,:,:)*(hmatinterp(:,:,ja+2:jr-1,:,:)-meanhhw)**2)/sum(popw(:,:,ja+2:jr-1,:,:)))
  do eetai=1,2
    do s=1,snum
      do jj=jy(s),jr-1
        do hh=1,hnum2
          do aa=1,anum2
            wmatinterp(aa,hh,jj,s,eetai)=w(s)*eeta(s,eetai)*aap(s,jj)*ghgridinterp(s,hh)
          enddo
        enddo
      enddo
    enddo
  enddo
  meanww=sum(popw(:,:,ja+2:jr-1,:,:)*wmatinterp(:,:,ja+2:jr-1,:,:))/sum(popw(:,:,ja+2:jr-1,:,:))
  stdww=sqrt(sum(popw(:,:,ja+2:jr-1,:,:)*(wmatinterp(:,:,ja+2:jr-1,:,:)-meanww)**2)/sum(popw(:,:,ja+2:jr-1,:,:)))

  write(*,*) 'stdd consumption, stdd asset, stdd hours, stdd wage', stdc, stda, stdhhw, stdww

meancw_age = 0d0
stdcw_age = 0d0
meanaw_age = 0d0
stdaw_age = 0d0
meanww_age = 0d0
stdww_age = 0d0

! write(*, *) 'test', log(max(ymatinterp(:,:,5,3,:), 1d-4))
!
! stop

  do jj = 3, jend
    do s=1,snum
    if(jj<jr)then
      meancw_age(jj, s)=sum(popw(:,:,jj,s,:)*log(cmatinterp(:,:,jj,s,:)))/sum(popw(:,:,jj,s,:))
      stdcw_age(jj, s)=(sum(popw(:,:,jj,s,:)*(log(cmatinterp(:,:,jj,s,:))-meancw_age(jj, s))**2)/sum(popw(:,:,jj,s,:)))
      meanaw_age(jj, s)=sum(popw(:,:,jj,s,:)*amatinterp(:,:,jj,s,:))/sum(popw(:,:,jj,s,:))
      stdaw_age(jj, s)=(sum(popw(:,:,jj,s,:)*(amatinterp(:,:,jj,s,:)-meanaw_age(jj, s))**2)/sum(popw(:,:,jj,s,:)))
      meanww_age(jj, s)=sum(popw(:,:,jj,s,:)*log(max(ymatinterp(:,:,jj,s,:), 1d-4)))/sum(popw(:,:,jj,s,:))
      stdww_age(jj, s)=(sum(popw(:,:,jj,s,:)*(log(max(ymatinterp(:,:,jj,s,:), 1d-4))-meanww_age(jj, s))**2)/sum(popw(:,:,jj,s,:)))
    else
      meancw_age(jj, s)=sum(popr(:,:,jj,s)*log(crmatinterp(:,:,jj,s)))/sum(popr(:,:,jj,s))
      stdcw_age(jj, s)=(sum(popr(:,:,jj,s)*(log(crmatinterp(:,:,jj,s))-meancw_age(jj, s))**2)/sum(popr(:,:,jj,s)))
      meanaw_age(jj, s)=sum(popr(:,:,jj,s)*armatinterp(:,:,jj,s))/sum(popr(:,:,jj,s))
      stdaw_age(jj, s)=(sum(popr(:,:,jj,s)*(armatinterp(:,:,jj,s)-meanaw_age(jj, s))**2)/sum(popr(:,:,jj,s)))
      meanww_age(jj, s)=0d0
      stdww_age(jj, s)=0d0
    endif
  enddo
  enddo

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! log variance of pre-tax and post-tax income
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  ! log income for workers
  do eetai=1,2
    do s=1,snum
      do jj=jy(s),jr-1
        do hh=1,hnum2
          do aa=1,anum2
            if (agrid2(jj,aa,s) >= 0.0d0) then
              preincome(aa,hh,jj,s,eetai) = log(max(ymatinterp(aa,hh,jj,s,eetai)+r*(agrid2(jj,aa,s)),m))
              postincome(aa,hh,jj,s,eetai) = log(max(ymatinterp(aa,hh,jj,s,eetai)-taul*ymatinterp(aa,hh,jj,s,eetai)&
                +(RR-1.0d0)*(agrid2(jj,aa,s))+Z,m))
            else
              preincome(aa,hh,jj,s,eetai) = log(max(ymatinterp(aa,hh,jj,s,eetai)+rminus*(agrid2(jj,aa,s)),m))
              postincome(aa,hh,jj,s,eetai) = log(max(ymatinterp(aa,hh,jj,s,eetai)-taul*ymatinterp(aa,hh,jj,s,eetai)&
                +(RRdebt-1.0d0)*(agrid2(jj,aa,s))+Z,m))
            endif
          enddo
        enddo
      enddo
    enddo
  enddo

  ! log income for enrollees
  do s=1,2
    jj=jy(s)-1
    do ke=1,kenum
      do eetai=1,2
        do qq=1,qnum
          do hh=1,hnum2
            do aa=1,anum2
              if (agrid2(jj,aa,s) >= 0.0d0) then
                preincomes(aa,hh,qq,jj,eetai,ke) = log(max(ysmatinterp(aa,hh,qq,jj,eetai,ke)+r*(agrid2(jj,aa,s)),m))
                postincomes(aa,hh,qq,jj,eetai,ke) = log(max(ysmatinterp(aa,hh,qq,jj,eetai,ke)-taul*ysmatinterp(aa,hh,qq,jj,eetai,ke)&
                  +(RR-1.0d0)*(agrid2(jj,aa,s))+Z,m))
              else
                preincomes(aa,hh,qq,jj,eetai,ke) = log(max(ysmatinterp(aa,hh,qq,jj,eetai,ke)+rs*(agrid2(jj,aa,s)),m))
                postincomes(aa,hh,qq,jj,eetai,ke) = log(max(ysmatinterp(aa,hh,qq,jj,eetai,ke)-taul*ysmatinterp(aa,hh,qq,jj,eetai,ke)&
                  +(RRdebts-1.0d0)*(agrid2(jj,aa,s))+Z,m))
              endif
            enddo
          enddo
        enddo
      enddo
    enddo
  enddo

  do s=1,snum
    do jj=jy(s),jr-1
      meanpreincome(jj,s)=Nvec(jj)*sum(ppw(:,:,jj,s,:)*preincome(:,:,jj,s,:))
      meanpostincome(jj,s)=Nvec(jj)*sum(ppw(:,:,jj,s,:)*postincome(:,:,jj,s,:))
    enddo
  enddo

  do s=1,2
    jj=jy(s)-1
    meanpreincome(jj,s)=Nvec(jj)*sum(ppws(:,:,:,jj,s,:,:)*preincomes(:,:,:,jj,:,:))
    meanpostincome(jj,s)=Nvec(jj)*sum(ppws(:,:,:,jj,s,:,:)*postincomes(:,:,:,jj,:,:))
  enddo

  ! meanincome
  mpreincome=sum(meanpreincome(:,:))/sum(Nvec(ja:jr-1))
  mpostincome=sum(meanpostincome(:,:))/sum(Nvec(ja:jr-1))

  do s=1,snum
    do jj=jy(s),jr-1
      varpreincome(jj,s)=Nvec(jj)*sum(ppw(:,:,jj,s,:)*(preincome(:,:,jj,s,:)-mpreincome)**2)
      varpostincome(jj,s)=Nvec(jj)*sum(ppw(:,:,jj,s,:)*(postincome(:,:,jj,s,:)-mpostincome)**2)
    enddo
  enddo

  do s=1,2
    jj=jy(s)-1
    varpreincome(jj,s)=Nvec(jj)*sum(ppws(:,:,:,jj,s,:,:)*(preincomes(:,:,:,jj,:,:)-mpreincome)**2)
    varpostincome(jj,s)=Nvec(jj)*sum(ppws(:,:,:,jj,s,:,:)*(postincomes(:,:,:,jj,:,:)-mpostincome)**2)
  enddo

  vpreincome=sum(varpreincome(ja:jr-1,:))/sum(Nvec(ja:jr-1))
  vpostincome=sum(varpostincome(ja:jr-1,:))/sum(Nvec(ja:jr-1))
  if (debug==1) then
    write(*,*) 'v', vpreincome,vpostincome,mpreincome,mpostincome,Z
  endif

  if (vpreincome==0.0d0) then
    stop "vpreincome=0"
  endif

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Ability distribution of newborns
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  sumpp0(:)=sum(sum(pp0(:,:,:),3),1)


  do iii=1,hnum2
    hgridmat(iii,:)=hgrid2(:)
    sumpp0mat(iii,:)=sumpp0(iii)*pepmat(iii,:)
  enddo

  meanpp0=sum(sumpp0(:)*hgrid2(:))
  varpp0 =sum(sumpp0(:)*(hgrid2(:)-meanpp0)**2)

  do s=1,snum
    meanafqtm(s)=sum(sum(sum(ppw(:,:,ja+1,s,:),3),1)*afqtcoeff(s)*(hgrid3(:)-meanh))/sum(ppw(:,:,ja+1,s,:))
    varafqtm(s)=sum(sum(sum(ppw(:,:,ja+1,s,:),3),1)*(afqtcoeff(s)*(hgrid3(:)-meanh)-meanafqtm(s))**2)/(sum(ppw(:,:,ja+1,s,:)))
  enddo

  ! write(*,*) 'var of fixed effect', varafqtm(1), sigmaalpha(1)**2

  meanbias_enrollees=sum(sum(sum(ppw(:,:,ja,2,:),3),1)*(bopt0+bopt1*(hgrid2(:)-meanh)))/sum(ppw(:,:,ja,2,:))
  meanthetac_enrollees=sum(sum(sum(sum(sum(sum(ppws0(:,:,:,ja+1,:,:,:),6),5),4),3),1)*(hgrid3(:)))/sum(ppws0(:,:,:,ja+1,:,:,:))
  stdthetac_enrollees=sqrt(sum(sum(sum(sum(sum(sum(ppws0(:,:,:,ja+1,:,:,:),6),5),4),3),1)*(hgrid3(:)-meanthetac_enrollees)**2)/sum(ppws0(:,:,:,ja+1,:,:,:)))

  ! write(*,*) 'average bias of enrollees',meanbias_enrollees
  ! write(*,*) 'mean of thetac of enrollees',meanthetac_enrollees
  ! write(*,*) 'std of thetac of enrollees',stdthetac_enrollees
  ! write(*,*) 'bias/std thetac of enrollees', meanbias_enrollees/stdthetac_enrollees

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Ability quartiles and aggregates
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  dsumpp0(1)=sumpp0(1)
  do ind=2,hnum2
    dsumpp0(ind) = dsumpp0(ind-1)+sumpp0(ind)
  enddo

  ! pick the closer one to .25, .50, .75
  ! i50 = locate(dsumpp0,.50d0)
  ! if (abs(dsumpp0(i50+1)-.50d0)<abs(dsumpp0(i50)-.50d0)) then
  !   i50=i50+1
  ! endif
  ! i25 = locate(dsumpp0,.25d0)
  ! if (abs(dsumpp0(i25+1)-.25d0)<abs(dsumpp0(i25)-.25d0)) then
  !   i25=i25+1
  ! endif
  ! i75 = locate(dsumpp0,.75d0)
  ! if (abs(dsumpp0(i75+1)-.75d0)<abs(dsumpp0(i75)-.75d0)) then
  !   i75=i75+1
  ! endif
  ! write(*,*) 'abil', i25,i50,i75, sum(sumpp0(1:i25)),sum(sumpp0(i25+1:i50)),sum(sumpp0(i50+1:i75)),sum(sumpp0(i75+1:hnum2))


  i50 = locate(dsumpp0,.50d0)
  i50=i50+1
  i25 = locate(dsumpp0,.25d0)
  i25=i25+1
  i75 = locate(dsumpp0,.75d0)
  i75=i75+1

  if (debug==1) then
    write(*,*) 'abil', i25,i50,i75, sum(sumpp0(1:i25)),sum(sumpp0(i25:i50)),sum(sumpp0(i50:i75)),sum(sumpp0(i75:hnum2))
  endif


  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Family income quartiles and aggregates
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  do s=1,snum
    do hh=1,hnum2
      do eetai=1,2
        income(s,hh,eetai)=w(s)*eeta(s,eetai)*aap(s,jb)*ghgridinterp(s,hh)
        ppincome(s,hh,eetai)=sum(ppw(:,hh,jb,s,eetai))
      enddo
    enddo
  enddo

  incomevec=reshape(income,(/size(income)/))
  pincomevec=reshape(ppincome,(/size(ppincome)/))

  ! incomesort=incomevec
  pincomesort=pincomevec

  call sort2(incomevec,pincomesort)

  pincomesort=pincomesort/sum(pincomesort)

  dpincomesort(1) = pincomesort(1)
  do ind=2,size(income)
    dpincomesort(ind) = dpincomesort(ind-1)+pincomesort(ind)
  enddo

  i50mincome = locate(dpincomesort,.50d0)
  i50mincome=i50mincome+1
  p50_mincome = incomevec(i50mincome)

  i25mincome = locate(dpincomesort,.25d0)
  i25mincome=i25mincome+1
  p25_mincome = incomevec(i25mincome)

  i75mincome = locate(dpincomesort,.75d0)
  i75mincome=i75mincome+1
  p75_mincome = incomevec(i75mincome)

  if (debug==1) then

    write(*,*) 'fincome', i25mincome,i50mincome,i75mincome,size(pincomesort), sum(pincomesort(1:i25mincome)),sum(pincomesort(i25mincome:i50mincome)),&
    sum(pincomesort(i50mincome:i75mincome)),sum(pincomesort(i75mincome:size(pincomesort)))
  endif

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Family income quartiles and aggregates
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  pp02(:,:,:,:)=0.0d0

  do s=1,snum
    do eetai=1,2
      do hc=1,hnum2
        do hh=1,hnum2
          do aa=1,anum2
            do qq=1,qnum

              if (income(s,hh,eetai)<=p25_mincome) then
                pp02(aa,hc,qq,1) = pp02(aa,hc,qq,1)+ppbjf(aa,hh,hc,s,eetai,qq)
              elseif (income(s,hh,eetai)<=p50_mincome) then
                pp02(aa,hc,qq,2) = pp02(aa,hc,qq,2)+ppbjf(aa,hh,hc,s,eetai,qq)
              elseif (income(s,hh,eetai)<=p75_mincome) then
                pp02(aa,hc,qq,3) = pp02(aa,hc,qq,3)+ppbjf(aa,hh,hc,s,eetai,qq)
              else
                pp02(aa,hc,qq,4) = pp02(aa,hc,qq,4)+ppbjf(aa,hh,hc,s,eetai,qq)
              endif

            enddo
          enddo
        enddo
      enddo
    enddo
  enddo



  do eetai=1,2
    do qq=1,qnum
      do qq2=1,qnum2
        do ke=1,kenum
          do hh=1,hnum2
            do aa=1,anum2
             ppws21(aa,hh,qq,2,eetai,ke,qq2) = pike(ke)*pis(3,eetai)*(I12pinterp(aa,hh,qq,eetai,ke)*pp02(aa,hh,qq,qq2))
             ppws21(aa,hh,qq,3,eetai,ke,qq2) = pike(ke)*pis(3,eetai)*(1.0d0-I12pinterp(aa,hh,qq,eetai,ke))*pp02(aa,hh,qq,qq2)
           enddo
         enddo
       enddo
     enddo
   enddo
 enddo

 do qq2=1,qnum2
  do s=2,3
    ppw2(1,s,qq2)=sum(ppws21(:,1:i25,:,s,:,:,qq2))
    ppw2(2,s,qq2)=sum(ppws21(:,i25:i50,:,s,:,:,qq2))
    ppw2(3,s,qq2)=sum(ppws21(:,i50:i75,:,s,:,:,qq2))
    ppw2(4,s,qq2)=sum(ppws21(:,i75:hnum2,:,s,:,:,qq2))
    ! ppw2(1,3,qq2)=sum(ppws21(:,1:i25,:,3,:,:,qq2))
    ! ppw2(2,3,qq2)=sum(ppws21(:,i25:i50,:,3,:,:,qq2))
    ! ppw2(3,3,qq2)=sum(ppws21(:,i50:i75,:,3,:,:,qq2))
    ! ppw2(4,3,qq2)=sum(ppws21(:,i75:hnum2,:,3,:,:,qq2))
  enddo
enddo

do qq=1,3
  do s=2,3
    ppw2_3(1,s,qq)=sum(ppws21(:,1:i25,qq,s,:,:,:))
    ppw2_3(2,s,qq)=sum(ppws21(:,i25:i50,qq,s,:,:,:))
    ppw2_3(3,s,qq)=sum(ppws21(:,i50:i75,qq,s,:,:,:))
    ppw2_3(4,s,qq)=sum(ppws21(:,i75:hnum2,qq,s,:,:,:))
    ! ppw2_3(1,3,qq)=sum(ppws21(:,1:i25,qq,3,:,:,:))
    ! ppw2_3(2,3,qq)=sum(ppws21(:,i25:i50,qq,3,:,:,:))
    ! ppw2_3(3,3,qq)=sum(ppws21(:,i50:i75,qq,3,:,:,:))
    ! ppw2_3(4,3,qq)=sum(ppws21(:,i75:hnum2,qq,3,:,:,:))
  enddo
enddo

do eetai=1,2
  do aa=1,anum2
    do hh=1,hnum2
      do qq=1,qnum
        do qq2=1,qnum2
          do ke=1,kenum
            do thetah=1,hnum2
              ppws02(aa,hh,thetah,qq,eetai,ke,qq2) = pepmat(thetah,hh)*dot_product(IIws(:,aa,thetah,qq,2,eetai,ke),ppws21(:,thetah,qq,2,eetai,ke,qq2))
            enddo
          enddo
        enddo
      enddo
    enddo
  enddo
enddo

jj=ja
s=1

do qq=1,qnum
  do qq2=1,qnum2
    do ke=1,kenum
      do hh=1,hnum2
        do thetah=1,hnum2
          do eetai=1,2
            do aa=1,anum2
              ppws22(aa,hh,thetah,qq,eetai,ke,qq2) = &
              Ipinterp(aa,hh,qq,ja+1,eetai,ke,hh)*pis(2,eetai)*(ppws02(aa,hh,thetah,qq,1,ke,qq2)+ppws02(aa,hh,thetah,qq,2,ke,qq2))
            enddo
          enddo
        enddo
      enddo
    enddo
  enddo
enddo





do ke=1,kenum
  do eetai=1,2
    do qq=1,qnum
      do hh=1,hnum2
        do aa=1,anum2
          do thetah = 1, hnum2
            sumppw22(aa,hh,thetah, qq,eetai,ke) = 0d0
            do qq2 = 1, qnum2
            sumppw22(aa,hh,thetah, qq,eetai,ke)= sumppw22(aa,hh,thetah, qq,eetai,ke)+pis(1,eetai)*dot_product(IIws(:,aa,hh,qq,1,1,ke),ppws22(:,hh,thetah,qq,1,ke,qq2))&
            +pis(1,eetai)*dot_product(IIws(:,aa,hh,qq,1,2,ke),ppws22(:,hh,thetah,qq,2,ke,qq2))
          enddo
          enddo
        enddo
      enddo
    enddo
  enddo
enddo

ppw22(:,:,:,ja+2,1,:) = sum(sum(sumppw22(:,:,:,:,:,:),6),4)



do jj=ja+2,jb-1
  do eetai=1,2
    s=1
    ! do s=1,snum
    do hh=1,hnum2
      do aa=1,anum2
        do thetah = 1, hnum2
          ppw22(aa,hh,thetah,jj+1,s,eetai) = pii(s,1,eetai)*dot_product(IIw(:,aa,hh,jj,s,1),ppw22(:,hh,thetah,jj,s,1))&
          + pii(s,2,eetai)*dot_product(IIw(:,aa,hh,jj,s,2),ppw22(:,hh,thetah,jj,s,2))
        enddo
      enddo
    enddo
    ! enddo
  enddo
enddo



jj=jb

do eetai=1,2
  s=1
  ! do s=1,snum
  do hc=1,hnum2
    do hh=1,hnum2
      do aa2=1,anum2
        do thetah = 1, hnum2

          ppwjf22(aa2,hh,hc,thetah,s,eetai)=sum(IIwjf(:,aa2,hh,hc,s,eetai)*ppw22(:,hh,thetah,jj,s,eetai))*psiem(hc,s,hh)
        enddo
      enddo
    enddo
  enddo
  ! enddo
enddo

do eetai=1,2
  ! do s=1,snum
  s=1
  do hh=1,hnum2
    do aa=1,anum2
      do thetah = 1, hnum2

        ppw22(aa,hh,thetah,jj+1,s,eetai) = pii(s,1,eetai)*sum(ppwjf22(aa,hh,:,thetah,s,1))+pii(s,2,eetai)*sum(ppwjf22(aa,hh,:,thetah,s,2))
      enddo
    enddo
  enddo
  ! enddo
enddo

! do s=1,snum
s=1
do jj=jb+1,jr-2
  do eetai=1,2
    do hh=1,hnum2
      do aa=1,anum2
        do thetah = 1, hnum2

          ppw22(aa,hh,thetah,jj+1,s,eetai) = pii(s,1,eetai)*dot_product(IIw(:,aa,hh,jj,s,1),ppw22(:,hh,thetah,jj,s,1))&
          + pii(s,2,eetai)*dot_product(IIw(:,aa,hh,jj,s,2),ppw22(:,hh,thetah,jj,s,2))
        enddo
      enddo
    enddo
  enddo
enddo
! enddo



! ppw22(aa,hh,thetah,jj+1,s,eetai)*(w(s)*eeta(s,eetai)*aap(s,jj)*ghgridinterp(s,hh))

s=1
do thetah = 1, hnum2
  wageabil(1, thetah) = 0d0
  masabil(1, thetah) = 0d0
  do ij = 3, jr-1
  do hh = 1, hnum2
    do eetai =1 ,2
      wageabil(1, thetah) = wageabil(1, thetah) + Nvec(ij)*sum(ppw22(:,hh,thetah,ij,s,eetai))*(log(eeta(s,eetai)) + log(ghgridinterp(s,hh)))
      masabil(1, thetah) = masabil(1, thetah) + Nvec(ij)*sum(ppw22(:,hh,thetah,ij,s,eetai))
    enddo
  enddo
enddo
enddo

do s = 2,3
do hh = 1, hnum2
  wageabil(s, hh) = 0d0
  masabil(s, hh) = 0d0
  do ij = 3, jr-1
  ! do hh = 1, hnum2
    do eetai =1 ,2
      wageabil(s, hh) = wageabil(s, hh) + Nvec(ij)*sum(ppw(:,hh,ij,s,eetai))*(log(eeta(s,eetai)) + log(ghgridinterp(s,hh)))
      masabil(s, hh) = masabil(s, hh) + Nvec(ij)*sum(ppw(:,hh,ij,s,eetai))
    enddo
  ! enddo
enddo
enddo
enddo

do s=1,snum
wageabil_3(s,1) = sum(wageabil(s,1:i25))/max(sum(masabil(s,1:i25)),1d-4)
wageabil_3(s,2) = sum(wageabil(s,i25:i50))/max(sum(masabil(s,i25:i50)),1d-4)
wageabil_3(s,3) = sum(wageabil(s,i50:i75))/max(sum(masabil(s,i50:i75)),1d-4)
wageabil_3(s,4) = sum(wageabil(s,i75:hnum2))/max(sum(masabil(s,i75:hnum2)),1d-4)
enddo

do s=1,snum
wageabil_3_2(s,1) = sum(wageabil(s,1:i50))/max(sum(masabil(s,1:i50)),1d-4)
wageabil_3_2(s,2) = sum(wageabil(s,i50:hnum2))/max(sum(masabil(s,i50:hnum2)),1d-4)
enddo

if(debug==1)then
write(*,*) 'wages test', wageabil_3(1,4) - wageabil_3(1,1) ! 0.4105199
write(*,*) 'wages test', wageabil_3(2,4) - wageabil_3(2,1) ! 0.17667
write(*,*) 'wages test', wageabil_3(3,4) - wageabil_3(3,1) ! 0.201692

write(*,*) 'wages test', wageabil_3_2(1,2) - wageabil_3_2(1,1) ! 0.4105199
write(*,*) 'wages test', wageabil_3_2(2,2) - wageabil_3_2(2,1) ! 0.17667
write(*,*) 'wages test', wageabil_3_2(3,2) - wageabil_3_2(3,1) ! 0.201692
endif

do qq2=1,qnum2
  ppw2(1,1,qq2)=sum(ppws22(:,:,1:i25,:,:,:,qq2))
  ppw2(2,1,qq2)=sum(ppws22(:,:,i25:i50,:,:,:,qq2))
  ppw2(3,1,qq2)=sum(ppws22(:,:,i50:i75,:,:,:,qq2))
  ppw2(4,1,qq2)=sum(ppws22(:,:,i75:hnum2,:,:,:,qq2))
enddo

do qq=1,3
  ppw2_3(1,1,qq)=sum(ppws22(:,:,1:i25,qq,:,:,:))
  ppw2_3(2,1,qq)=sum(ppws22(:,:,i25:i50,qq,:,:,:))
  ppw2_3(3,1,qq)=sum(ppws22(:,:,i50:i75,qq,:,:,:))
  ppw2_3(4,1,qq)=sum(ppws22(:,:,i75:hnum2,qq,:,:,:))
enddo

do hh=1,4
  do qq=1,qnum
    ppw2_3(hh,2,qq)=ppw2_3(hh,2,qq)-ppw2_3(hh,1,qq)
  enddo
enddo

do hh=1,4
  do qq2=1,qnum2
    ppw2(hh,2,qq2)=ppw2(hh,2,qq2)-ppw2(hh,1,qq2)
  enddo
enddo

do qq2=1,qnum2
  do s=1,snum
    ppw2_fi(qq2,s)=sum(ppw2(:,s,qq2))
  enddo
enddo

do s=1,snum
  do hh=1,4
    ppw2_abil(hh,s)=sum(ppw2(hh,s,:))
  enddo
enddo

do qq2=1,qnum2
  pfracincome02(qq2) = sum(ppw2_fi(qq2,1:2),1)/max(sum(ppw2_fi(qq2,:),1),m)
  qfracincome02(qq2) = ppw2_fi(qq2,1)/max(sum(ppw2_fi(qq2,:),1),m)
enddo

do hh=1,4
  pfracm(hh) = sum(ppw2_abil(hh,1:2))/max(sum(ppw2_abil(hh,:)),m)
  qfracm(hh) = ppw2_abil(hh,1)/max(sum(ppw2_abil(hh,:)),m)
enddo

do hh=1,4
  do qq2=1,qnum2
    pfracm44(hh,qq2) = sum(ppw2(hh,1:2,qq2))/max(sum(ppw2(hh,:,qq2)),m)
    qfracm44(hh,qq2) = ppw2(hh,1,qq2)/max(sum(ppw2(hh,:,qq2)),m)

  enddo
  do qq=1,3
    qfracm44_3(hh,qq) = ppw2_3(hh,1,qq)/max(sum(ppw2_3(hh,:,qq)),m)
  enddo
enddo

do qq=1,3
  do hh=1,4
    pfrac43(hh,qq)=ppw2_3(hh,2,qq)
    qfrac43(hh,qq)=ppw2_3(hh,1,qq)
  enddo
enddo


do qq=1,3
  qfracthetac43(1,qq)=sum(ppws22(:,1:i25,:,qq,:,:,:))
  qfracthetac43(2,qq)=sum(ppws22(:,i25:i50,:,qq,:,:,:))
  qfracthetac43(3,qq)=sum(ppws22(:,i50:i75,:,qq,:,:,:))
  qfracthetac43(4,qq)=sum(ppws22(:,i75:hnum2,:,qq,:,:,:))
enddo



write(*,*) 'pfracm', pfracm(:)
write(*,*) 'qfracm', qfracm(:)/pfracm(:)

write(*,*) 'pfracincome', pfracincome02
write(*,*) 'qfracincome', qfracincome02/pfracincome02


if (calibflag==1) then
  grants00(:,:,:)=grants(:,:,:)
endif

end subroutine modelmoments
