subroutine modeloutput(ndim,params,tthetal0, tthetal1)

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !!!!  Kazushige MATSUDA
  !!!!  "Progressive Taxation vs College Subsidies with College Dropout"
  !!!!
  !!!!
  !!!!  Routine to decompose welfare
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  use nrtype
  use globals
  use interface, only :  modelsolution, linspace,normcdf,param,modelmoments,util
  use nr, only : polint, golden, locate

  implicit none

  integer, intent(in) :: ndim
  real(DP),intent(in) :: params(ndim)
  real(DP),intent(in) :: tthetal0(hnum2,qnum), tthetal1(hnum2,qnum)
  integer :: iii,ITT, fo=16, jp,i
  real(DP) :: distpp0,distV0
  integer, parameter :: Nw_reshape = (jr-1)*anum2*hnum2*snum*2, N_reshape = (jr-1)*anum2*hnum2*snum*2 + (jend-jr+1)*anum2*hnum2*snum
  real(DP) :: cmat_reshape(Nw_reshape), amat_reshape(Nw_reshape), wmat_reshape(Nw_reshape), pop_reshape(Nw_reshape)
  integer :: i_reshape

  if (calibflag==1) then
    ttheta(ja,:,:)= tthetal0(:,:)
    ttheta(ja+1,:,:)= tthetal1(:,:)
  else
    grantsopt(ja,:,:)= tthetal0(:,:)
    grantsopt(ja+1,:,:)= tthetal1(:,:)
  endif

  if (nodropout==1) then

    bopt0 =0.0d0
    bopt1 =0.0d0
    lambda0 = params(1)
    lambda1=params(2)
    kappa =paramsbench(5)
    mmu =paramsbench(6)
    bbetarate =paramsbench(7)
    vv =paramsbench(8)
    d =paramsbench(9)
    iota =paramsbench(10)
    mupbar =paramsbench(11)
    ssigmae =paramsbench(12)
    elast=params(3)
    stddc =0.0001d0
    elast2=elast
    a1 = params(4)
    a2 =paramsbench(17)

    afqtcoeff(1) = paramsbench(18)
    afqtcoeff(2) = paramsbench(19)
    afqtcoeff(3) = paramsbench(20)

  else

    if (heterostddc==1) then
      bopt0 = 0.0d0
      bopt1 = 0.0d0
      lambda0 = params(1)
      lambda1=params(2)
      kappa = params(3)
      mmu = params(4)
      bbetarate = params(5)
      vv = max(min(params(6),1.0d0-m),0.00d0)
      d = params(7)
      iota = params(8)
      mupbar = params(9)
      ssigmae = params(10)
      elast=params(11)
      stddc=params(12)
      elast2=params(13)
      a1 = params(14)
      a2=params(15)
      stddc1=params(16)
      afqtcoeff(1) = params(17)
      afqtcoeff(2) = params(18)
      afqtcoeff(3) = params(19)
    else
      bopt0 = params(1)
      bopt1 = params(2)
      lambda0 = params(3)
      lambda1=params(4)
      kappa = params(5)
      mmu = params(6)
      bbetarate = params(7)
      vv = max(min(params(8),1.0d0-m),0.00d0)
      d = params(9)
      iota = params(10)
      mupbar = params(11)
      ssigmae = params(12)
      elast=params(13)
      stddc=params(14)
      elast2=params(15)
      a1 = params(16)
      a2=params(17)
      afqtcoeff(1) = params(18)
      afqtcoeff(2) = params(19)
      afqtcoeff(3) = params(20)

    endif

  endif

  bbeta=1.0d0/(1.0d0+bbetarate)
  if (bbeta>1.0d0) write(*,*) 'bbeta>1'
  if (debug==1) write(*,*) 'params',params

  call param

  if (taxelas==1) then

    if (delas==1) then

      K_LL= 1.47918399807113
      H_LL1=0.972458011893421
      LL_N=0.277719462226457
      taul=tauleq+0.01d0  !plus 1% labor income tax
      d=0.131504236942374
      grantprop=1.0d0
    else

      K_LL= 1.49099882809329
      H_LL1= 1.01494086694522
      LL_N=0.280972157257357
      taul=tauleq+0.01d0  !plus 1% labor income tax
      grantprop= 2.12712642575987
    endif

    dddddd=100.0d0
    V00(:,:,:) = 0.0d0
    V(:,:,:,:,:)=0.0d0
    Vr(:,:,:,:)=0.0d0
    Vs(:,:,:,:,:,:)=0.0d0

    write(*,*) 'iteration  ', 'distance'

    do itt=1,40
      call modelsolution
      write(*,*) ITT, dddddd

      if (pe==1) then
      endif
      if (dddddd<tol) then
        exit
      endif
    enddo

  else

    if (wel==0) then

      K_LL= 1.50077632125939
      LL_N=0.304149525386994
      H_LL1=1.07139196476410
      taul=  0.371032053386774
      ybar = 0.274095921569425

      dddddd=100.0d0
      V00(:,:,:) = 0.0d0
      V(:,:,:,:,:)=0.0d0
      Vr(:,:,:,:)=0.0d0
      Vs(:,:,:,:,:,:)=0.0d0

      write(*,*) 'iteration  ', 'distance'

      do itt=1,40
        call modelsolution
        write(*,*) ITT, dddddd
        if (dddddd<tol) then
          exit
        endif
      enddo

      moments(1)=K_LL
      moments(2)=H_LL1
      moments(3)=LL_N
      moments(4)=taul
      moments(5) = ybar

    else

      K_LL=1.50032287074454!moments2(1)
      H_LL1=1.08238956749349 !moments2(2)
      LL_N=0.303579291938575!moments2(3)
      taul=0.371163776627360
      grantprop = 0.792159559901044


      dddddd=100.0d0
      V00(:,:,:) = 0.0d0
      V(:,:,:,:,:)=0.0d0
      Vr(:,:,:,:)=0.0d0
      Vs(:,:,:,:,:,:)=0.0d0
      write(*,*) 'iteration  ', 'distance'

      do itt=1,40
        call modelsolution
        write(*,*) ITT, dddddd
        if (dddddd<tol) then
          exit
        endif
      enddo

    endif

  endif


  call modelmoments

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Gini
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  i_reshape = 1

  do jj = 1, jr-1!jend
    do s=1, snum
      do hh=1,hnum2
        do aa=1,anum2
          if(jj<jr)then
            do eetai=1,2
              cmat_reshape(i_reshape) = cmatinterp(aa,hh,jj,s,eetai)
              amat_reshape(i_reshape) = amatinterp(aa,hh,jj,s,eetai)
              wmat_reshape(i_reshape) = wmatinterp(aa,hh,jj,s,eetai)
              pop_reshape(i_reshape) = popw(aa,hh,jj,s,eetai)
              i_reshape = i_reshape + 1
            enddo
          else
            cmat_reshape(i_reshape) = crmatinterp(aa,hh,jj,s)
            amat_reshape(i_reshape) = armatinterp(aa,hh,jj,s)
            wmat_reshape(i_reshape) = 0d0
            pop_reshape(i_reshape) = popr(aa,hh,jj,s)
            i_reshape = i_reshape + 1
          endif
        enddo
      enddo
    enddo
  enddo

  ! write(*, *) 'test', i_reshape, size(cmat_reshape)

  write(*, *) 'gini c, a, earnings', gini(cmat_reshape, pop_reshape), gini(amat_reshape, pop_reshape), gini(wmat_reshape(1:Nw_reshape), pop_reshape(1:Nw_reshape)/sum(pop_reshape(1:Nw_reshape)))
  ! write(*, *) 'test', gini(cmat_reshape(1:Nw_reshape), pop_reshape(1:Nw_reshape)/sum(pop_reshape(1:Nw_reshape))), gini(amat_reshape(1:Nw_reshape), pop_reshape(1:Nw_reshape)/sum(pop_reshape(1:Nw_reshape))), gini(wmat_reshape(1:Nw_reshape), pop_reshape(1:Nw_reshape)/sum(pop_reshape(1:Nw_reshape)))

  ! stop

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !model output original
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  ! if (paternalistic==1) then

  popw(:,:,:,:,:) = 0.0d0
  popr(:,:,:,:)=0.0d0
  V00leis(:,:,:) = 0.0d0

  Vleis(:,:,jb+1:jr-1,:,:)=Vinterp(:,:,jb+1:jr-1,:,:)


  V00leis(:,:,:) = 0.0d0
  distV0 = 2000.0d0
  do iii=1,30
    if (distV0 < tol) exit
    do jj=jb,ja,-1
      do s=snum,1,-1
        if (jj==jb) then
          do eetai=1,2
            do hh=1,hnum2
              do aa=1,anum2
                do hc=1,hnum2
                  wwinterp(hh)=w(s)*eeta(s,eetai)*aap(s,jj)*ghgridinterp(s,hh)

                  call polint(agrid2(jj+1,:,s),Vinterp(:,hh,jj+1,s,1),amatjfinterp(aa,hh,hc,s,eetai),Vprime(1),dy)
                  call polint(agrid2(jj+1,:,s),Vinterp(:,hh,jj+1,s,2),amatjfinterp(aa,hh,hc,s,eetai),Vprime(2),dy)
                  if (wwinterp(hh)*hbase < q1) then
                    qq3=1
                  elseif (wwinterp(hh)*hbase < q2) then
                    qq3=2
                  else
                    qq3=3
                  endif
                  call polint(agrid2(ja,:,2),V00leis(:,hc,qq3),bmatjfinterp(aa,hh,hc,s,eetai),V00prime,dy)
                  Vauxinterp(aa,hh,hc)= util(cmatjfinterp(aa,hh,hc,s,eetai),lmatjfinterp(aa,hh,hc,s,eetai))&
                  + bbeta*varphi(jj)*sum(pii(s,eetai,:)*Vprime(:))+vv*V00prime
                enddo
                Vleis(aa,hh,jj,s,eetai) = sum(psiem(:,s,hh)*Vauxinterp(aa,hh,:))
              enddo
            enddo
          enddo
        elseif (jy(s)<=jj .and. jj<jb) then
          do eetai=1,2
            do hh=1,hnum2
              do aa=1,anum2
                call polint(agrid2(jj+1,:,s),Vleis(:,hh,jj+1,s,1),amatinterp(aa,hh,jj,s,eetai),Vprime(1),dy)
                call polint(agrid2(jj+1,:,s),Vleis(:,hh,jj+1,s,2),amatinterp(aa,hh,jj,s,eetai),Vprime(2),dy)
                Vleis(aa,hh,jj,s,eetai)= util(cmatinterp(aa,hh,jj,s,eetai)/(1.0d0+ind_fb(jj)*zzeta*f),lmatinterp(aa,hh,jj,s,eetai))&
                + bbeta*varphi(jj)*sum(pii(s,eetai,:)*Vprime(:))
              enddo
            enddo
          enddo
        elseif (s==1 .and. jj==ja+1) then
          do eetai=1,2
            do ke=1,kenum
              do qq=1,qnum
                do hh=1,hnum2
                  do aa=1,anum2
                    call polint(agrid2(jj+1,:,s),Vleis(:,hh,jj+1,s,1),asmatinterp(aa,hh,qq,jj,eetai,ke),Vprime(1),dy)
                    call polint(agrid2(jj+1,:,s),Vleis(:,hh,jj+1,s,2),asmatinterp(aa,hh,qq,jj,eetai,ke),Vprime(2),dy)

                    Vleise(aa,hh,qq,jj,eetai,ke)= util(csmatinterp(aa,hh,qq,jj,eetai,ke),lsmatinterp(aa,hh,qq,jj,eetai,ke))&
                    + bbeta*varphi(jj)*sum(pis(s,:)*Vprime(:))

                    do thetah=1,hnum2
                      ! if (agrid2(jj,aa,s) < 0.0d0) then
                      !   call polint(agrid2(jj,:,s),Vleis(:,thetah,jj,2,eetai),agrid2(jj,aa,s)*factor,Vwork,dy)
                      ! else
                      Vwork=Vleis(aa,thetah,jj,2,eetai)
                      ! endif
                      Veduc2=Vleise(aa,hh,qq,jj,eetai,ke)
                      Vleis2(aa,hh,qq,jj,eetai,ke)=Vleise(aa,hh,qq,jj,eetai,ke)
                      Vleispe(aa,hh,qq,jj,eetai,ke,thetah)=(1.0d0-Ipinterp(aa,hh,qq,jj,eetai,ke,thetah))*Vwork+Ipinterp(aa,hh,qq,jj,eetai,ke,thetah)*Veduc2
                    enddo
                  enddo
                enddo
              enddo
            enddo
            do ke=1,kenum
              do qq=1,qnum
                do thetah=1,hnum2
                  do aa=1,anum2
                    EVleispe(aa,thetah,qq,jj,eetai,ke)=sum(pepmat(thetah,:)*Vleispe(aa,:,qq,jj,eetai,ke,thetah))
                  enddo
                enddo
              enddo
            enddo
          enddo
        elseif (s==2 .and. jj==ja) then
          do ke=1,kenum
            do eetai=1,2
              do qq=1,qnum
                do hh=1,hnum2
                  do aa=1,anum2
                    call polint(agrid2(jj+1,:,s),EVleispe(:,hh,qq,jj+1,1,ke),asmatinterp(aa,hh,qq,jj,eetai,ke),Vsprime(1),dy)
                    call polint(agrid2(jj+1,:,s),EVleispe(:,hh,qq,jj+1,2,ke),asmatinterp(aa,hh,qq,jj,eetai,ke),Vsprime(2),dy)
                    Vleise(aa,hh,qq,jj,eetai,ke) = util(csmatinterp(aa,hh,qq,jj,eetai,ke),lsmatinterp(aa,hh,qq,jj,eetai,ke))+bbeta*sum(pis(s,:)*Vsprime(:))
                  enddo
                enddo
              enddo
            enddo
          enddo
          do qq=1,qnum
            do hh=1,hnum2
              do aa=1,anum2
                do ke=1,kenum
                  do eetai=1,2
                    Veduc1=Vleise(aa,hh,qq,jj,eetai,ke)
                    Vleis2(aa,hh,qq,jj,eetai,ke)=Vleise(aa,hh,qq,jj,eetai,ke)
                    V00leisnews(aa,hh,qq,eetai,ke)=(1.0d0-I12pinterp(aa,hh,qq,eetai,ke))*Vleis(aa,hh,ja,3,eetai)+I12pinterp(aa,hh,qq,eetai,ke)*Veduc1
                  enddo
                enddo
                V00leisnew(aa,hh,qq)=pis(3,1)*sum(pike(:)*V00leisnews(aa,hh,qq,1,:))+pis(3,2)*sum(pike(:)*V00leisnews(aa,hh,qq,2,:))
              enddo
            enddo
          enddo
        endif
      enddo
    enddo

    distV0 = abs(maxval(maxval(maxval(abs(V00leisnew-V00leis),1),1),1))
    V00leis = V00leisnew

    if (iii>=30  .and. distV0>0.1d0) then
      write(*,*) 'V00aux3 maxit'
      stop
    endif

  enddo


  V00aux3(:,:,:,:,:)=V00leisnews(:,:,:,:,:)
  ! V00aux3all=Nvec(ja)*sum(ppwseq(:,:,:,ja,2,:,:)*Vleis2(:,:,:,ja,:,:))+Nvec(ja+1)*sum(ppwseq(:,:,:,ja+1,1,:,:)*Vleis2(:,:,:,ja+1,:,:))&
  ! +sum(popweq(:,:,ja:jr-1,3,:)*Vleis(:,:,ja:jr-1,3,:))+sum(popweq(:,:,ja+1:jr-1,2,:)*Vleis(:,:,ja+1:jr-1,2,:))&
  ! +sum(popweq(:,:,ja+2:jr-1,1,:)*Vleis(:,:,ja+2:jr-1,1,:))+sum(popreq(:,:,jr:jend,:)*Vrinterp(:,:,jr:jend,:))

  if (ppwfixed==1) then

    if (calibflag==1) then
      pppp0eq=pppp0
      ppwseq=ppws
      ppweq=ppw
      ppreq=ppr
    endif

    do jj=ja,jr-1
      popweq(:,:,jj,:,:) = Nvec(jj)*ppweq(:,:,jj,:,:)
    enddo
    do jj=jr,jend
      popreq(:,:,jj,:)=Nvec(jj)*ppreq(:,:,jj,:)
    enddo

    V00aux3all=Nvec(ja)*sum(ppwseq(:,:,:,ja,2,:,:)*Vleis2(:,:,:,ja,:,:))+Nvec(ja+1)*sum(ppwseq(:,:,:,ja+1,1,:,:)*Vleis2(:,:,:,ja+1,:,:))&
    +sum(popweq(:,:,ja:jr-1,3,:)*Vleis(:,:,ja:jr-1,3,:))+sum(popweq(:,:,ja+1:jr-1,2,:)*Vleis(:,:,ja+1:jr-1,2,:))&
    +sum(popweq(:,:,ja+2:jr-1,1,:)*Vleis(:,:,ja+2:jr-1,1,:))+sum(popreq(:,:,jr:jend,:)*Vrinterp(:,:,jr:jend,:))
  else

    do jj=ja,jr-1
      popw(:,:,jj,:,:) = Nvec(jj)*ppw(:,:,jj,:,:)
    enddo
    do jj=jr,jend
      popr(:,:,jj,:)=Nvec(jj)*ppr(:,:,jj,:)
    enddo

    if (omitj2==1) then
      ! V00aux3all=Nvec(ja)*sum(ppws(:,:,:,ja,2,:,:)*Vleis2(:,:,:,ja,:,:))&
      ! +sum(popw(:,:,ja,3,:)*Vleis(:,:,ja,3,:))+sum(popw(:,:,ja+2:jr-1,3,:)*Vleis(:,:,ja+2:jr-1,3,:))+sum(popw(:,:,ja+2:jr-1,2,:)*Vleis(:,:,ja+2:jr-1,2,:))&
      ! +sum(popw(:,:,ja+2:jr-1,1,:)*Vleis(:,:,ja+2:jr-1,1,:))+sum(popr(:,:,jr:jend,:)*Vrinterp(:,:,jr:jend,:))
      V00aux3all=sum(popw(:,:,ja+2:jr-1,3,:)*Vleis(:,:,ja+2:jr-1,3,:))+sum(popw(:,:,ja+2:jr-1,2,:)*Vleis(:,:,ja+2:jr-1,2,:))&
      +sum(popw(:,:,ja+2:jr-1,1,:)*Vleis(:,:,ja+2:jr-1,1,:))+sum(popr(:,:,jr:jend,:)*Vrinterp(:,:,jr:jend,:))
    else
      V00aux3all=Nvec(ja)*sum(ppws(:,:,:,ja,2,:,:)*Vleis2(:,:,:,ja,:,:))+Nvec(ja+1)*sum(ppws(:,:,:,ja+1,1,:,:)*Vleis2(:,:,:,ja+1,:,:))&
      +sum(popw(:,:,ja:jr-1,3,:)*Vleis(:,:,ja:jr-1,3,:))+sum(popw(:,:,ja+1:jr-1,2,:)*Vleis(:,:,ja+1:jr-1,2,:))&
      +sum(popw(:,:,ja+2:jr-1,1,:)*Vleis(:,:,ja+2:jr-1,1,:))+sum(popr(:,:,jr:jend,:)*Vrinterp(:,:,jr:jend,:))
    endif

  endif

  ! write(*,*) 'total welfare', sum(pppp0(:,:,:,:,:)*V00aux3(:,:,:,:,:)),sum(sum(sum(pppp0(:,:,:,:,:),5),3)*Vleis(:,:,ja,3,:)),sum(pppp0(:,:,:,:,:)*Vleise(:,:,:,ja,:,:))

  if (calibflag==1) then
    i25eq=i25
    i50eq=i50
    i75eq=i75
  endif

  do qq=1,qnum
    SWFpa2(1,qq) = (sum(pppp0(:,1:i25eq,qq,:,:)*V00aux3(:,1:i25eq,qq,:,:)))/sum(pppp0(:,1:i25eq,qq,:,:))
    SWFpa2(2,qq) = (sum(pppp0(:,i25eq:i50eq,qq,:,:)*V00aux3(:,i25eq:i50eq,qq,:,:)))/sum(pppp0(:,i25eq:i50eq,qq,:,:))
    SWFpa2(3,qq) = (sum(pppp0(:,i50eq:i75eq,qq,:,:)*V00aux3(:,i50eq:i75eq,qq,:,:)))/sum(pppp0(:,i50eq:i75eq,qq,:,:))
    SWFpa2(4,qq) = (sum(pppp0(:,i75eq:hnum2,qq,:,:)*V00aux3(:,i75eq:hnum2,qq,:,:)))/sum(pppp0(:,i75eq:hnum2,qq,:,:))
  enddo


  V00leis(:,:,:) = 0.0d0
  distV0 = 2000.0d0
  do iii=1,30
    if (distV0 < tol) exit
    do jj=jb,ja,-1
      do s=snum,1,-1
        if (jj==jb) then
          do eetai=1,2
            do aa=1,anum2
              do hh=1,hnum2
                do hc=1,hnum2

                  wwinterp(hh)=w(s)*eeta(s,eetai)*aap(s,jj)*ghgridinterp(s,hh)

                  ! mp= max(wwinterp(hh),m)
                  if (wwinterp(hh)*hbase < q1) then
                    qq3=1
                  elseif (wwinterp(hh)*hbase < q2) then
                    qq3=2
                  else
                    qq3=3
                  endif
                  call polint(agrid2(ja,:,2),V00leis(:,hc,qq3),bmatjfinterp(aa,hh,hc,s,eetai),V00prime,dy)
                  Vauxinterp(aa,hh,hc)=  vv*V00prime
                enddo
                Vleis(aa,hh,jj,s,eetai) = sum(psiem(:,s,hh)*Vauxinterp(aa,hh,:))
              enddo
            enddo
          enddo
        elseif (jy(s)<=jj .and. jj<jb) then
          do eetai=1,2
            do hh=1,hnum2
              do aa=1,anum2
                call polint(agrid2(jj+1,:,s),Vleis(:,hh,jj+1,s,1),amatinterp(aa,hh,jj,s,eetai),Vprime(1),dy)
                call polint(agrid2(jj+1,:,s),Vleis(:,hh,jj+1,s,2),amatinterp(aa,hh,jj,s,eetai),Vprime(2),dy)
                Vleis(aa,hh,jj,s,eetai)=  bbeta*varphi(jj)*sum(pii(s,eetai,:)*Vprime(:))
              enddo
            enddo
          enddo
        elseif (s==1 .and. jj==ja+1) then
          do eetai=1,2

            do aa=1,anum2
              do hh=1,hnum2
                do qq=1,qnum
                  do ke=1,kenum
                    call polint(agrid2(jj+1,:,s),Vleis(:,hh,jj+1,s,1),asmatinterp(aa,hh,qq,jj,eetai,ke),Vprime(1),dy)
                    call polint(agrid2(jj+1,:,s),Vleis(:,hh,jj+1,s,2),asmatinterp(aa,hh,qq,jj,eetai,ke),Vprime(2),dy)

                    Vleise(aa,hh,qq,jj,eetai,ke)=  bbeta*varphi(jj)*sum(pis(s,:)*Vprime(:))

                    do thetah=1,hnum2

                      ! if (agrid2(jj,aa,s) < 0.0d0) then
                      !   call polint(agrid2(jj,:,s),Vleis(:,thetah,jj,2,eetai),agrid2(jj,aa,s)*factor,Vwork,dy)
                      ! else
                      Vwork=Vleis(aa,thetah,jj,2,eetai)
                      ! endif
                      Veduc2=Vleise(aa,hh,qq,jj,eetai,ke)+lambda(jj,hh,ke)
                      Vleis2(aa,hh,qq,jj,eetai,ke)=Vleise(aa,hh,qq,jj,eetai,ke)+lambda(jj,hh,ke)
                      Vleispe(aa,hh,qq,jj,eetai,ke,thetah)=(1.0d0-Ipinterp(aa,hh,qq,jj,eetai,ke,thetah))*Vwork+Ipinterp(aa,hh,qq,jj,eetai,ke,thetah)*Veduc2
                    enddo
                  enddo
                enddo
              enddo
            enddo
            do qq=1,qnum
              do ke=1,kenum
                do aa=1,anum2
                  do thetah=1,hnum2
                    EVleispe(aa,thetah,qq,jj,eetai,ke)=sum(pepmat(thetah,:)*Vleispe(aa,:,qq,jj,eetai,ke,thetah))
                  enddo
                enddo
              enddo
            enddo
          enddo
        elseif (s==2 .and. jj==ja) then
          do eetai=1,2

            do ke=1,kenum
              do aa=1,anum2
                do hh=1,hnum2
                  do qq=1,qnum
                    call polint(agrid2(jj+1,:,s),EVleispe(:,hh,qq,jj+1,1,ke),asmatinterp(aa,hh,qq,jj,eetai,ke),Vsprime(1),dy)
                    call polint(agrid2(jj+1,:,s),EVleispe(:,hh,qq,jj+1,2,ke),asmatinterp(aa,hh,qq,jj,eetai,ke),Vsprime(2),dy)
                    Vleise(aa,hh,qq,jj,eetai,ke) = bbeta*sum(pis(s,:)*Vsprime(:))
                  enddo
                enddo
              enddo
            enddo
          enddo
          do aa=1,anum2
            do hh=1,hnum2
              do qq=1,qnum
                do eetai=1,2
                  do ke=1,kenum
                    Veduc1=Vleise(aa,hh,qq,jj,eetai,ke)+lambda(jj,hh,ke)
                    Vleis2(aa,hh,qq,jj,eetai,ke)=Vleise(aa,hh,qq,jj,eetai,ke)+lambda(jj,hh,ke)
                    V00leisnews(aa,hh,qq,eetai,ke)=(1.0d0-I12pinterp(aa,hh,qq,eetai,ke))*Vleis(aa,hh,ja,3,eetai)+I12pinterp(aa,hh,qq,eetai,ke)*Veduc1
                  enddo
                enddo
                V00leisnew(aa,hh,qq)=pis(3,1)*sum(pike(:)*V00leisnews(aa,hh,qq,1,:))+pis(3,2)*sum(pike(:)*V00leisnews(aa,hh,qq,2,:))
              enddo
            enddo
          enddo
        endif
      enddo
    enddo

    distV0 = abs(maxval(maxval(maxval(abs(V00leisnew-V00leis),1),1),1))
    V00leis = V00leisnew

    if (iii>=30 .and. distV0>0.1d0) then
      write(*,*) 'aggdis maxit'
      stop
    endif

  enddo

  dis(:,:,:,:,:)=V00leisnews(:,:,:,:,:)
  ! disall=Nvec(ja)*sum(ppwseq(:,:,:,ja,2,:,:)*Vleis2(:,:,:,ja,:,:))+Nvec(ja+1)*sum(ppwseq(:,:,:,ja+1,1,:,:)*Vleis2(:,:,:,ja+1,:,:))&
  ! +sum(popweq(:,:,ja:jb,3,:)*Vleis(:,:,ja:jb,3,:))+sum(popweq(:,:,ja+1:jb,2,:)*Vleis(:,:,ja+1:jb,2,:))&
  ! +sum(popweq(:,:,ja+2:jb,1,:)*Vleis(:,:,ja+2:jb,1,:))

  if (ppwfixed==1) then
    disall=Nvec(ja)*sum(ppwseq(:,:,:,ja,2,:,:)*Vleis2(:,:,:,ja,:,:))+Nvec(ja+1)*sum(ppwseq(:,:,:,ja+1,1,:,:)*Vleis2(:,:,:,ja+1,:,:))&
    +sum(popweq(:,:,ja:jb,3,:)*Vleis(:,:,ja:jb,3,:))+sum(popweq(:,:,ja+1:jb,2,:)*Vleis(:,:,ja+1:jb,2,:))&
    +sum(popweq(:,:,ja+2:jb,1,:)*Vleis(:,:,ja+2:jb,1,:))
  else
    if (omitj2==1) then
      ! disall=Nvec(ja)*sum(ppws(:,:,:,ja,2,:,:)*Vleis2(:,:,:,ja,:,:))&
      ! +sum(popw(:,:,ja,3,:)*Vleis(:,:,ja,3,:))+sum(popw(:,:,ja+2:jb,3,:)*Vleis(:,:,ja+2:jb,3,:))+sum(popw(:,:,ja+2:jb,2,:)*Vleis(:,:,ja+2:jb,2,:))&
      ! +sum(popw(:,:,ja+2:jb,1,:)*Vleis(:,:,ja+2:jb,1,:))
      disall=sum(popw(:,:,ja+2:jb,3,:)*Vleis(:,:,ja+2:jb,3,:))+sum(popw(:,:,ja+2:jb,2,:)*Vleis(:,:,ja+2:jb,2,:))&
      +sum(popw(:,:,ja+2:jb,1,:)*Vleis(:,:,ja+2:jb,1,:))
    else
      disall=Nvec(ja)*sum(ppws(:,:,:,ja,2,:,:)*Vleis2(:,:,:,ja,:,:))+Nvec(ja+1)*sum(ppws(:,:,:,ja+1,1,:,:)*Vleis2(:,:,:,ja+1,:,:))&
      +sum(popw(:,:,ja:jb,3,:)*Vleis(:,:,ja:jb,3,:))+sum(popw(:,:,ja+1:jb,2,:)*Vleis(:,:,ja+1:jb,2,:))&
      +sum(popw(:,:,ja+2:jb,1,:)*Vleis(:,:,ja+2:jb,1,:))
    endif
  endif

  SWF2=sum(pppp0(:,:,:,:,:)*(V00aux3(:,:,:,:,:)+dis(:,:,:,:,:)))


  write(*,*) 'SWF2', SWF2

  ! write(*,*) 'abil', i25eq, i50eq, i75eq

  do qq=1,qnum
    aggdis4(1,qq)=sum(pppp0(:,1:i25eq,qq,:,:)*dis(:,1:i25eq,qq,:,:))/sum(pppp0(:,1:i25eq,qq,:,:))
    aggdis4(2,qq)=sum(pppp0(:,i25eq:i50eq,qq,:,:)*dis(:,i25eq:i50eq,qq,:,:))/sum(pppp0(:,i25eq:i50eq,qq,:,:))
    aggdis4(3,qq)=sum(pppp0(:,i50eq:i75eq,qq,:,:)*dis(:,i50eq:i75eq,qq,:,:))/sum(pppp0(:,i50eq:i75eq,qq,:,:))
    aggdis4(4,qq)=sum(pppp0(:,i75eq:hnum2,qq,:,:)*dis(:,i75eq:hnum2,qq,:,:))/sum(pppp0(:,i75eq:hnum2,qq,:,:))
  enddo


  Vleisr(:,:,jend,:)=1.0d0/(1.0d0-ssigma)
  ! Vleisr(:,:,jend,:)=agleis**((1.0d0-ssigma)*(1.0d0-mmu))/(1.0d0-ssigma)

  do jj=jend-1,jr,-1
    do s=snum,1,-1
      do hh=1,hnum2
        do aa=1,anum2
          call polint(agrid2(jj+1,:,s),Vleisr(:,hh,jj+1,s),armatinterp(aa,hh,jj,s),Vprimer,dy)
          Vleisr(aa,hh,jj,s) = 1.0d0/(1.0d0-ssigma)+bbeta*varphi(jj)*Vprimer
          ! Vleisr(aa,hh,jj,s) = agleis**((1.0d0-ssigma)*(1.0d0-mmu))/(1.0d0-ssigma)+bbeta*varphi(jj)*Vprimer
        enddo
      enddo
    enddo
  enddo
  jj=jr-1
  do eetai=1,2
    do s=snum,1,-1
      do hh=1,hnum2
        do aa=1,anum2
          call polint(agrid2(jj+1,:,s),Vleisr(:,hh,jj+1,s),amatinterp(aa,hh,jj,s,eetai),Vprimer,dy)
          Vleis(aa,hh,jj,s,eetai) = ((lmatinterp(aa,hh,jj,s,eetai))**(1.0d0-mmu))**(1.0d0-ssigma)/(1.0d0-ssigma)+bbeta*Vprimer
          !  Vleis(aa,hh,jj,s,eetai) = ((agleis)**(1.0d0-mmu))**(1.0d0-ssigma)/(1.0d0-ssigma)+bbeta*Vprimer
        enddo
      enddo
    enddo
  enddo
  do jj=jr-2,jb+1,-1
    do eetai=1,2
      do s=snum,1,-1
        do hh=1,hnum2
          do aa=1,anum2
            call polint(agrid2(jj+1,:,s),Vleis(:,hh,jj+1,s,1),amatinterp(aa,hh,jj,s,eetai),Vprime(1),dy)
            call polint(agrid2(jj+1,:,s),Vleis(:,hh,jj+1,s,2),amatinterp(aa,hh,jj,s,eetai),Vprime(2),dy)
            Vleis(aa,hh,jj,s,eetai) = ((lmatinterp(aa,hh,jj,s,eetai))**(1.0d0-mmu))**(1.0d0-ssigma)/(1.0d0-ssigma)&
            +bbeta*sum(pii(s,eetai,:)*Vprime(:))
            ! Vleis(aa,hh,jj,s,eetai) = ((agleis)**(1.0d0-mmu))**(1.0d0-ssigma)/(1.0d0-ssigma)&
            ! +bbeta*sum(pii(s,eetai,:)*Vprime(:))
          enddo
        enddo
      enddo
    enddo
  enddo

  V00leis(:,:,:) = 0.0d0
  distV0 = 2000.0d0
  do iii=1,30
    if (distV0 < tol) exit
    do jj=jb,ja,-1
      do s=snum,1,-1
        if (jj==jb) then
          do eetai=1,2
            do hh=1,hnum2
              do aa=1,anum2
                do hc=1,hnum2

                  wwinterp(hh)=w(s)*eeta(s,eetai)*aap(s,jj)*ghgridinterp(s,hh)

                  call polint(agrid2(jj+1,:,s),Vleis(:,hh,jj+1,s,1),amatjfinterp(aa,hh,hc,s,eetai),Vprime(1),dy)
                  call polint(agrid2(jj+1,:,s),Vleis(:,hh,jj+1,s,2),amatjfinterp(aa,hh,hc,s,eetai),Vprime(2),dy)
                  if (wwinterp(hh)*hbase < q1) then
                    qq3=1
                  elseif (wwinterp(hh)*hbase < q2) then
                    qq3=2
                  else
                    qq3=3
                  endif
                  call polint(agrid2(ja,:,2),V00leis(:,hc,qq3),bmatjfinterp(aa,hh,hc,s,eetai),V00prime,dy)
                  Vauxinterp(aa,hh,hc)= (lmatjfinterp(aa,hh,hc,s,eetai)**(1.0d0-mmu))**(1.0d0-ssigma)/(1.0d0-ssigma)&
                  + bbeta*varphi(jj)*sum(pii(s,eetai,:)*Vprime(:))+vv*V00prime
                  ! Vauxinterp(aa,hh,hc)= (agleis**(1.0d0-mmu))**(1.0d0-ssigma)/(1.0d0-ssigma)&
                  ! + bbeta*varphi(jj)*sum(pii(s,eetai,:)*Vprime(:))+vv*V00prime
                enddo
                Vleis(aa,hh,jj,s,eetai) = sum(psiem(:,s,hh)*Vauxinterp(aa,hh,:))
              enddo
            enddo
          enddo
        elseif (jy(s)<=jj .and. jj<jb) then
          do eetai=1,2
            do hh=1,hnum2
              do aa=1,anum2
                call polint(agrid2(jj+1,:,s),Vleis(:,hh,jj+1,s,1),amatinterp(aa,hh,jj,s,eetai),Vprime(1),dy)
                call polint(agrid2(jj+1,:,s),Vleis(:,hh,jj+1,s,2),amatinterp(aa,hh,jj,s,eetai),Vprime(2),dy)
                Vleis(aa,hh,jj,s,eetai)= ((1.0d0/(1.0d0+ind_fb(jj)*zzeta*f))**mmu*lmatinterp(aa,hh,jj,s,eetai)**(1.0d0-mmu))**(1.0d0-ssigma)/(1.0d0-ssigma)&
                + bbeta*varphi(jj)*sum(pii(s,eetai,:)*Vprime(:))
                ! Vleis(aa,hh,jj,s,eetai)= ((1.0d0/(1.0d0+zzeta*f))**mmu*agleis**(1.0d0-mmu))**(1.0d0-ssigma)/(1.0d0-ssigma)&
                ! + bbeta*varphi(jj)*sum(pii(s,eetai,:)*Vprime(:))
              enddo
            enddo
          enddo
        elseif (s==1 .and. jj==ja+1) then
          do eetai=1,2
            do ke=1,kenum
              do qq=1,qnum
                do hh=1,hnum2
                  do aa=1,anum2
                    call polint(agrid2(jj+1,:,s),Vleis(:,hh,jj+1,s,1),asmatinterp(aa,hh,qq,jj,eetai,ke),Vprime(1),dy)
                    call polint(agrid2(jj+1,:,s),Vleis(:,hh,jj+1,s,2),asmatinterp(aa,hh,qq,jj,eetai,ke),Vprime(2),dy)

                    Vleise(aa,hh,qq,jj,eetai,ke)= (lsmatinterp(aa,hh,qq,jj,eetai,ke)**(1.0d0-mmu))**(1.0d0-ssigma)/(1.0d0-ssigma)&
                    + bbeta*varphi(jj)*sum(pis(s,:)*Vprime(:))
                    ! Vleise(aa,hh,qq,jj,eetai,ke)= (agleis**(1.0d0-mmu))**(1.0d0-ssigma)/(1.0d0-ssigma)&
                    ! + bbeta*varphi(jj)*sum(pis(s,:)*Vprime(:))

                    do thetah=1,hnum2

                      ! if (agrid2(jj,aa,s) < 0.0d0) then
                      !   call polint(agrid2(jj,:,s),Vleis(:,thetah,jj,2,eetai),agrid2(jj,aa,s)*factor,Vwork,dy)
                      ! else
                      Vwork=Vleis(aa,thetah,jj,2,eetai)
                      ! endif
                      Veduc2=Vleise(aa,hh,qq,jj,eetai,ke)
                      Vleis2(aa,hh,qq,jj,eetai,ke)=Vleise(aa,hh,qq,jj,eetai,ke)

                      Vleispe(aa,hh,qq,jj,eetai,ke,thetah)=(1.0d0-Ipinterp(aa,hh,qq,jj,eetai,ke,thetah))*Vwork+Ipinterp(aa,hh,qq,jj,eetai,ke,thetah)*Veduc2
                    enddo
                  enddo
                enddo
              enddo
            enddo
            do ke=1,kenum
              do qq=1,qnum
                do thetah=1,hnum2
                  do aa=1,anum2
                    EVleispe(aa,thetah,qq,jj,eetai,ke)=sum(pepmat(thetah,:)*Vleispe(aa,:,qq,jj,eetai,ke,thetah))
                  enddo
                enddo
              enddo
            enddo
          enddo
        elseif (s==2 .and. jj==ja) then
          do ke=1,kenum
            do eetai=1,2
              do qq=1,qnum
                do hh=1,hnum2
                  do aa=1,anum2
                    call polint(agrid2(jj+1,:,s),EVleispe(:,hh,qq,jj+1,1,ke),asmatinterp(aa,hh,qq,jj,eetai,ke),Vsprime(1),dy)
                    call polint(agrid2(jj+1,:,s),EVleispe(:,hh,qq,jj+1,2,ke),asmatinterp(aa,hh,qq,jj,eetai,ke),Vsprime(2),dy)
                    Vleise(aa,hh,qq,jj,eetai,ke) = (lsmatinterp(aa,hh,qq,jj,eetai,ke)**(1.0d0-mmu))**(1.0d0-ssigma)/(1.0d0-ssigma)+bbeta*sum(pis(s,:)*Vsprime(:))
                    ! Vleise(aa,hh,qq,jj,eetai,ke) = (agleis**(1.0d0-mmu))**(1.0d0-ssigma)/(1.0d0-ssigma)+bbeta*sum(pis(s,:)*Vsprime(:))
                  enddo
                enddo
              enddo
            enddo
          enddo
          do qq=1,qnum
            do hh=1,hnum2
              do aa=1,anum2
                do ke=1,kenum
                  do eetai=1,2
                    Veduc1=Vleise(aa,hh,qq,jj,eetai,ke)
                    Vleis2(aa,hh,qq,jj,eetai,ke)=Vleise(aa,hh,qq,jj,eetai,ke)

                    V00leisnews(aa,hh,qq,eetai,ke)=(1.0d0-I12pinterp(aa,hh,qq,eetai,ke))*Vleis(aa,hh,ja,3,eetai)+I12pinterp(aa,hh,qq,eetai,ke)*Veduc1
                  enddo
                enddo
                V00leisnew(aa,hh,qq)=pis(3,1)*sum(pike(:)*V00leisnews(aa,hh,qq,1,:))+pis(3,2)*sum(pike(:)*V00leisnews(aa,hh,qq,2,:))
              enddo
            enddo
          enddo
        endif
      enddo
    enddo


    distV0 = abs(maxval(maxval(maxval(abs(V00leisnew-V00leis),1),1),1))
    V00leis = V00leisnew

    if (iii>=30  .and. distV0>0.1d0) then
      write(*,*) 'V00aux3 maxit'
      stop
    endif

  enddo

  aggdis = (Nvec(ja)*sum(sum(sum(sum(ppws(:,:,:,ja,2,:,:),4),3),1)*lambda(ja,:,:))+Nvec(ja+1)*sum(sum(sum(sum(ppws(:,:,:,ja+1,1,:,:),4),3),1)*lambda(ja+1,:,:)))/sum(Nvec(ja:jend))!&
  ! write(*,*) 'aggdis', Nvec(ja)*sum(sum(sum(sum(ppws(:,:,:,ja,2,:,:),4),3),1)*lambda(ja,:,:)),Nvec(ja+1)*sum(sum(sum(sum(ppws(:,:,:,ja+1,1,:,:),4),3),1)*lambda(ja+1,:,:))!&

  dsumaggdis=betav*aggdis/(1.0d0-bbeta**jb*vv)

  c00(:,:,:,:,:)=((V00aux3(:,:,:,:,:))/V00leisnews(:,:,:,:,:))**(1.0d0/mmu/(1.0d0-ssigma))
  CCbar=sum(pppp0(:,:,:,:,:)*c00(:,:,:,:,:))

  punc=1.0d0-CCbar/sum(C)*sum(Nvec(ja:jend))
  write(*,*) 'punc', punc

  pine=1.0d0-(sum(pppp0(:,:,:,:,:)*c00(:,:,:,:,:)**(mmu*(1.0d0-ssigma))))**(1.0d0/mmu/(1.0d0-ssigma))/CCbar
  write(*,*) 'pine', pine

  Vlev= betav*(sum(C)**mmu*(agleis)**(1.0d0-mmu)/sum(Nvec(ja:jend)))**(1.0d0-ssigma)/(1.0d0-ssigma)/(1.0d0-bbeta**jb*vv)
  write(*,*) 'CandL', sum(C), agleis

end subroutine modeloutput
