
  function normcdf(x,mu,sd)
    use nrtype

    implicit none
    real(DP), INTENT(IN) :: x, mu, sd
    real(DP) :: normcdf
    real(DP), parameter :: ppi=2.0d0*acos(0.0d0)
    real(DP), parameter :: acons=8.0d0*(ppi-3.0d0)/3.0d0/ppi/(4.0d0-ppi)
    real(DP) :: xnormal

    xnormal=(x-mu)/sd/sqrt(2.0d0)
    

    ! approximation based on Bell(2015) "A Simple and Pragmatic Approximation to the Normal Cumulative Probability Distribution"
    if (x-mu==0) then
      normcdf = 0.5d0
    else
      ! normcdf = 0.5d0*(1.0d0+(x-mu)/abs(x-mu)*(1.0d0-exp(-2.0d0*(((x-mu)/sd)**2.0d0)/ppi))**0.5d0)
      normcdf = 0.5d0*(1.0d0+(x-mu)/abs(x-mu)*(1.0d0-exp(-xnormal**2*(4.0d0/ppi+acons*xnormal**2)/(1.0d0+acons*xnormal**2)))**0.5d0)

    end if

  end function normcdf
