subroutine valuev

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  
  !!!!  Kazushige MATSUDA
  !!!!  "Optimal Timing of College Subsidies"
  !!!!  
  !!!!
  !!!!  Routine to solve the individuals problem
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  use nrtype
  use nr, only : polint, golden
  use globals
  use interface, only : util

  implicit none

  real(DP) :: factortilde
  real(DP) :: lcons, cmatf(xnum),amatf(xnum),lmatf(xnum),bmatf(xnum),smatf(xnum)

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! second period of college
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  if (s==1 .and. jj==jy(s)-1) then

    ww(:)=w(s+1)*eeta(s+1,eetai)*aap(s+1,jj)*ghgrid(s+1,:)

    do thetac=1,hnum
      mp= max((1.0d0-taul)*ww(thetac),m) ! marginal benefit of labor to agents
      lcons = (1.0d0-mmu)/mmu*(1.0d0+tauc)/mp

      do qq=1,qnum
        do xx=1,xnum
          smatf(xx)=agrid(jj+1,xx,s)
          if (agrid(jj+1,xx,s)<0.0d0) then
            RRtilde=RRdebts*factor
            factortilde=factor
          else
            RRtilde=RR
            factortilde=1.0d0
          endif
          cmatf(xx)=(bbeta*RRtilde*sum(pii(s,eetai,:)*Vx(xx,thetac,jj+1,s,:))/mmu/(1.0d0-stime)**((1.0d0-mmu)*(1.0d0-ssigma)))**(-1.0d0/(1.0d0-mmu*(1.0d0-ssigma)))
          mul = (1.0d0-mmu)*cmatf(xx)/mmu/(1.0d0-stime)-mp/(1.0d0+tauc)

          if (mul > 0.0d0) then
            amatf(xx)=(smatf(xx)/factortilde+cmatf(xx)*(1.0d0+tauc)+tuition-grants(jj,hhm(thetac),qq)-Z)
          else
            cmatf(xx)=(bbeta*RRtilde*sum(pii(s,eetai,:)*Vx(xx,thetac,jj+1,s,:))/mmu/lcons**((1.0d0-mmu)*(1.0d0-ssigma)))**(-1.0d0/ssigma)
            amatf(xx)=(smatf(xx)/factortilde+cmatf(xx)*(1.0d0+tauc)+mp*min(lcons*cmatf(xx),1.0d0-stime)+tuition-grants(jj,hhm(thetac),qq)&
              -mp*(1.0d0-stime)-Z)  
          endif
          if (amatf(xx) < 0.0d0) then
            amatf(xx)=amatf(xx)/RRdebts
          else
            amatf(xx)=amatf(xx)/RR
          endif
        enddo

        do aa=1,anum

          if (agrid(jj,aa,s)<amatf(1)) then
            if (agrid(jj,aa,s)<0.0d0) then
              RRtilde=RRdebts
            else
              RRtilde=RR
            endif

            csmat(aa,thetac,qq,jj,eetai,ke)=max((RRtilde*agrid(jj,aa,s)+Z+mp*(1.0d0-stime)-tuition+grants(jj,hhm(thetac),qq)-agrid(jj+1,1,s)/factor)/(1.0d0+tauc+lcons*mp),m)
            lsmat(aa,thetac,qq,jj,eetai,ke) = lcons*csmat(aa,thetac,qq,jj,eetai,ke)

            if (lcons*csmat(aa,thetac,qq,jj,eetai,ke) > 1.0d0-stime) then
              csmat(aa,thetac,qq,jj,eetai,ke)=max((RRtilde*agrid(jj,aa,s)+Z-tuition+grants(jj,hhm(thetac),qq)-agrid(jj+1,1,s)/factor)/(1.0d0+tauc),m)
              lsmat(aa,thetac,qq,jj,eetai,ke) = 1.0d0-stime
            endif
            asmat(aa,thetac,qq,jj,eetai,ke)=agrid(jj+1,1,s)
          else

            call polint(amatf(:),cmatf(:),agrid(jj,aa,s),csmat(aa,thetac,qq,jj,eetai,ke),dy)
            call polint(amatf(:),smatf(:),agrid(jj,aa,s),asmat(aa,thetac,qq,jj,eetai,ke),dy)

            csmat(aa,thetac,qq,jj,eetai,ke)=max(csmat(aa,thetac,qq,jj,eetai,ke),m)
            lsmat(aa,thetac,qq,jj,eetai,ke) = min(lcons*csmat(aa,thetac,qq,jj,eetai,ke),1.0d0-stime)

          endif

          Vsx(aa,thetac,qq,jj,eetai,ke) = vprimefunc(csmat(aa,thetac,qq,jj,eetai,ke),lsmat(aa,thetac,qq,jj,eetai,ke))

          call polint(agrid(jj+1,:,s),V(:,thetac,jj+1,s,1),asmat(aa,thetac,qq,jj,eetai,ke),Vprime(1),dy)
          call polint(agrid(jj+1,:,s),V(:,thetac,jj+1,s,2),asmat(aa,thetac,qq,jj,eetai,ke),Vprime(2),dy)

          Vs(aa,thetac,qq,jj,eetai,ke)= util(csmat(aa,thetac,qq,jj,eetai,ke),lsmat(aa,thetac,qq,jj,eetai,ke))+ bbeta*sum(pis(s,:)*Vprime(:))

          do thetah=1,hnum
            ! if (agrid(jj,aa,s) < 0.0d0) then
            !   call polint(agrid(jj,:,s),V(:,thetah,jj,2,eetai),agrid(jj,aa,s)/factor,Vwork,dy)
            ! else
            Vwork=V(aa,thetah,jj,2,eetai)
            ! endif

            do ke2=1,kenum
              Veduc2=Vs(aa,thetac,qq,jj,eetai,1)+lambdaopt(jj,hhm(thetac),ke2)

              if (Vwork>Veduc2) then
                Ip(aa,thetac,qq,jj,eetai,ke2,thetah)=0.0d0
                Vp(aa,thetac,qq,jj,eetai,ke2,thetah)=Vwork
              else
                Ip(aa,thetac,qq,jj,eetai,ke2,thetah)=1.0d0
                Vp(aa,thetac,qq,jj,eetai,ke2,thetah)=Veduc2
              endif
            enddo
          enddo
        enddo
      enddo
    enddo

    do qq=1,qnum
      do ke=1,kenum
        do aa=1,anum
          do thetah=1,hnum
            do thetac=1,hnum2
              call polint(hgrid(:),Vp(aa,:,qq,jj,eetai,ke,thetah),hgrid2(thetac),Vsprimeh(thetac),dy)
            enddo
            EVp(aa,thetah,qq,jj,eetai,ke)=sum(pepmatopt(hhm(thetah),:)*Vsprimeh(:))
          enddo
        enddo
      enddo
    enddo

    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! first period of college
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  elseif (s==2 .and. jj==jy(s)-1) then

    do qq=1,qnum
      ww(:)=w(s+1)*eeta(s+1,eetai)*aap(s+1,jj)*ghgrid(s+1,:)
      do thetah=1,hnum
        mp= max((1.0d0-taul)*ww(thetah),m)
        lcons = (1.0d0-mmu)/mmu*(1.0d0+tauc)/mp
        do aa=1,anum
          ! Voutput= golden(agrid(jj+1,1,s),0.5d0*agrid(jj+1,1,s)+0.5d0*agrid(jj+1,anum,s),agrid(jj+1,anum,s),ssolve,tol,asmat(aa,thetah,qq,jj,eetai,ke))
          Voutput= golden(agrid(jj+1,1,s),agrid(jj+1,1,s)+m,agrid(jj+1,anum,s),ssolve,tol,asmat(aa,thetah,qq,jj,eetai,ke))
        enddo
      enddo
    enddo

    do qq=1,qnum
      do thetah=1,hnum
        do aa=1,anum
          Veduc1=Vs(aa,thetah,qq,jj,eetai,ke)+lambdaopt(jj,hhm(thetah),ke)
          if (V(aa,thetah,ja,3,eetai)>Veduc1) then
            I12p(aa,thetah,qq,eetai,ke) =0.0d0
          else
            I12p(aa,thetah,qq,eetai,ke) =1.0d0
          endif
        enddo
      enddo
    enddo

    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! transfer period jb
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  elseif (jy(s)<=jj .and. jj<=jr-1) then

    if (jj==jb) then

      ww(:)=w(s)*eeta(s,eetai)*aap(s,jj)*ghgrid(s,:)

      do hh=1,hnum
        mp= max(((1.0d0)-taul)*ww(hh),m)
        lcons = (1.0d0-mmu)/mmu*(1.0d0+tauc)/mp

        do hc=1,hnum
          do xx=1,xnum

            Voutput= golden(0.0d0,max(agridjf(xx,s)/f,0.0d0)*0.5d0,max(agridjf(xx,s)/f,0.0d0),bsolve,tol,bmatf(xx))

            call polint(agrid(jj+1,:,s),Vx(:,hh,jj+1,s,1),agridjf(xx,s)-bmatf(xx)*f,Vprime(1),dy)
            call polint(agrid(jj+1,:,s),Vx(:,hh,jj+1,s,2),agridjf(xx,s)-bmatf(xx)*f,Vprime(2),dy)

            if (agridjf(xx,s)-bmatf(xx)*f<0.0d0) then
              RRtilde=RRdebt
            else
              RRtilde=RR
            endif

            smatf(xx)=agridjf(xx,s)-bmatf(xx)*f
            cmatf(xx)=(bbeta*RRtilde*sum(pii(s,eetai,:)*Vprime(:))/mmu)**(-1.0d0/(1.0d0-mmu*(1.0d0-ssigma)))
            mul = (1.0d0-mmu)*cmatf(xx)/mmu-mp/(1.0d0+tauc)

            if (mul > 0.0d0) then
              amatf(xx)=(agridjf(xx,s)+cmatf(xx)*(1.0d0+tauc)-Z)
            else
              cmatf(xx)=(bbeta*RRtilde*sum(pii(s,eetai,:)*Vprime(:))/mmu/lcons**((1.0d0-mmu)*(1.0d0-ssigma)))**(-1.0d0/ssigma)
              amatf(xx)=(agridjf(xx,s)+cmatf(xx)*(1.0d0+tauc)+ mp*min(cmatf(xx)*lcons,1.0d0)-mp-Z)
            endif

            if (amatf(xx) < 0.0d0) then
              amatf(xx)=amatf(xx)/RRdebt
            else
              amatf(xx)=amatf(xx)/RR
            endif

          enddo


          do aa=1,anum

            if (agrid(jj,aa,s)<amatf(1)) then
              if (agrid(jj,aa,s)<0.0d0) then
                RRtilde=RRdebt
              else
                RRtilde=RR
              endif
              cmatjf(aa,hh,hc,s,eetai)=max((RRtilde*agrid(jj,aa,s)+Z+mp-agridjf(1,s))/(1.0d0+tauc+lcons*mp),m)
              lmatjf(aa,hh,hc,s,eetai) = lcons*cmatjf(aa,hh,hc,s,eetai)
              if (lcons*cmatjf(aa,hh,hc,s,eetai) >1.0d0) then
                cmatjf(aa,hh,hc,s,eetai)=max((RRtilde*agrid(jj,aa,s)+Z-agridjf(1,s))/(1.0d0+tauc),m)
                lmatjf(aa,hh,hc,s,eetai) = 1.0d0
              endif
              amatjf(aa,hh,hc,s,eetai)=agridjf(1,s)
              bmatjf(aa,hh,hc,s,eetai)=0.0d0
            else
              call polint(amatf(:),cmatf(:),agrid(jj,aa,s),cmatjf(aa,hh,hc,s,eetai),dy)
              call polint(amatf(:),smatf(:),agrid(jj,aa,s),amatjf(aa,hh,hc,s,eetai),dy)
              call polint(amatf(:),bmatf(:),agrid(jj,aa,s),bmatjf(aa,hh,hc,s,eetai),dy)
              cmatjf(aa,hh,hc,s,eetai)=max(cmatjf(aa,hh,hc,s,eetai),m)
              lmatjf(aa,hh,hc,s,eetai) = min(lcons*cmatjf(aa,hh,hc,s,eetai),1.0d0)
            endif


            call polint(agrid(jj+1,:,s),V(:,hh,jj+1,s,1),amatjf(aa,hh,hc,s,eetai),Vprime(1),dy)
            call polint(agrid(jj+1,:,s),V(:,hh,jj+1,s,2),amatjf(aa,hh,hc,s,eetai),Vprime(2),dy)

            Vauxx(aa,hh,hc)= vprimefunc(cmatjf(aa,hh,hc,s,eetai),lmatjf(aa,hh,hc,s,eetai))

            if (ww(hh)*hbase < q1) then
              qq3=1
            elseif (ww(hh)*hbase < q2) then
              qq3=2
            else
              qq3=3
            endif

            call polint(agrid(ja,:,2),V00(:,hc,qq3),bmatjf(aa,hh,hc,s,eetai),V00prime,dy)

            Vaux(aa,hh,hc)= util(cmatjf(aa,hh,hc,s,eetai),lmatjf(aa,hh,hc,s,eetai))&
            + bbeta*varphi(jj)*sum(pii(s,eetai,:)*Vprime(:))+vv*V00prime

          enddo

        enddo
      enddo

      do hh=1,hnum
        do aa=1,anum
          do hh2=1,hnum2
            call polint(hgrid(:),Vaux(aa,hh,:),hgrid2(hh2),Vauxinterph(aa,hh,hh2),dy)
            call polint(hgrid(:),Vauxx(aa,hh,:),hgrid2(hh2),Vauxxinterph(aa,hh,hh2),dy)
          enddo
          V(aa,hh,jj,s,eetai) = sum(psiem(:,s,hhm(hh))*Vauxinterph(aa,hh,:))
          Vx(aa,hh,jj,s,eetai) = sum(psiem(:,s,hhm(hh))*Vauxxinterph(aa,hh,:))
        enddo
      enddo

      !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      ! working stage
      !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    else

      ww(:)=w(s)*eeta(s,eetai)*aap(s,jj)*ghgrid(s,:)

      do hh=1,hnum

        mp= max((1.0d0-taul)*ww(hh),m)
        lcons = (1.0d0-mmu)/mmu*(1.0d0+tauc)/mp

        do xx=1,xnum
          if (agrid(jj+1,xx,s)<0.0d0) then
            RRtilde=RRdebt
          else
            RRtilde=RR
          endif
          smatf(xx)=agrid(jj+1,xx,s)

          if (jj==jr-1) then     

            cmatf(xx)=(bbeta*RRtilde*Vrx(xx,hh,jj+1,s)/mmu)**(-1.0d0/(1.0d0-mmu*(1.0d0-ssigma)))
            mul = (1.0d0-mmu)*cmatf(xx)/mmu-mp/(1.0d0+tauc)
            if (mul > 0.0d0) then
              amatf(xx)=(smatf(xx)+cmatf(xx)*(1.0d0+tauc)-Z)
            else
              cmatf(xx)=(bbeta*RRtilde*Vrx(xx,hh,jj+1,s)/mmu/lcons**((1.0d0-mmu)*(1.0d0-ssigma)))**(-1.0d0/ssigma)
              amatf(xx)=(smatf(xx)+cmatf(xx)*(1.0d0+tauc)+min(cmatf(xx)*lcons,1.0d0)*mp-mp-Z)
            endif

          else

            cmatf(xx)=(bbeta*RRtilde*sum(pii(s,eetai,:)*Vx(xx,hh,jj+1,s,:))/mmu*(1.0d0+ind_fb(jj)*zzeta*f)**(mmu*(1.0d0-ssigma)))**(-1.0d0/(1.0d0-mmu*(1.0d0-ssigma)))
            mul = (1.0d0-mmu)*cmatf(xx)/mmu-mp/(1.0d0+tauc)
            if (mul > 0.0d0) then
              amatf(xx)=(smatf(xx)+cmatf(xx)*(1.0d0+tauc)-Z)
            else
              cmatf(xx)=(bbeta*RRtilde*sum(pii(s,eetai,:)*Vx(xx,hh,jj+1,s,:))/mmu/lcons**((1.0d0-mmu)*(1.0d0-ssigma))*(1.0d0+ind_fb(jj)*zzeta*f)**(mmu*(1.0d0-ssigma)))**(-1.0d0/ssigma)
              if (jj==ja) then
                amatf(xx)=(smatf(xx)+cmatf(xx)*(1.0d0+tauc)+min(cmatf(xx)*lcons,1.0d0)*mp-mp-Z-trans0)
              else
                amatf(xx)=(smatf(xx)+cmatf(xx)*(1.0d0+tauc)+min(cmatf(xx)*lcons,1.0d0)*mp-mp-Z)
              endif
            endif

          endif

          if (jj>ja) then
            if (amatf(xx) < 0.0d0) then
              if(jj==ja+1 .and. s==2)then
                amatf(xx)=amatf(xx)/RRdebt/factor
              else
                amatf(xx)=amatf(xx)/RRdebt
              endif
            else
              amatf(xx)=amatf(xx)/RR
            endif
          endif
        enddo


        do aa=1,anum
          if (agrid(jj,aa,s)<amatf(1)) then
            if (agrid(jj,aa,s)<0.0d0) then
              if(jj==ja+1 .and. s==2)then
                RRtilde=RRdebt*factor
              else
                RRtilde=RRdebt
              endif
              ! RRtilde=RRdebt
            else
              RRtilde=RR
            endif
            if (jj==ja) then
              cmat(aa,hh,jj,s,eetai)=max((RRtilde*agrid(jj,aa,s)+Z+mp-agrid(jj+1,1,s)+trans0)/(1.0d0+tauc+lcons*mp),m)
            else
              cmat(aa,hh,jj,s,eetai)=max((RRtilde*agrid(jj,aa,s)+Z+mp-agrid(jj+1,1,s))/(1.0d0+tauc+lcons*mp),m)
            endif
            lmat(aa,hh,jj,s,eetai) = lcons*cmat(aa,hh,jj,s,eetai)
            if (lcons*cmat(aa,hh,jj,s,eetai)>1.0d0) then
              if (jj==ja) then
                cmat(aa,hh,jj,s,eetai)=max((RRtilde*agrid(jj,aa,s)+Z-agrid(jj+1,1,s)+trans0)/(1.0d0+tauc),m)
              else
                cmat(aa,hh,jj,s,eetai)=max((RRtilde*agrid(jj,aa,s)+Z-agrid(jj+1,1,s))/(1.0d0+tauc),m)
              endif
              lmat(aa,hh,jj,s,eetai) = 1.0d0
            endif
            amat(aa,hh,jj,s,eetai)=agrid(jj+1,1,s)
          else
            call polint(amatf(:),cmatf(:),agrid(jj,aa,s),cmat(aa,hh,jj,s,eetai),dy)
            call polint(amatf(:),smatf(:),agrid(jj,aa,s),amat(aa,hh,jj,s,eetai),dy)

            cmat(aa,hh,jj,s,eetai)=max(cmat(aa,hh,jj,s,eetai),m)
            lmat(aa,hh,jj,s,eetai)=min(lcons*cmat(aa,hh,jj,s,eetai),1.0d0)

          endif
        enddo


        do aa=1,anum
          if (jj==jr-1) then
            Vx(aa,hh,jj,s,eetai) = vprimefunc(cmat(aa,hh,jj,s,eetai),lmat(aa,hh,jj,s,eetai))
            call polint(agrid(jj+1,:,s),Vr(:,hh,jj+1,s),amat(aa,hh,jj,s,eetai),Vrprime,dy)
            V(aa,hh,jj,s,eetai) = util(cmat(aa,hh,jj,s,eetai),lmat(aa,hh,jj,s,eetai)) + bbeta*varphi(jj)*Vrprime
          else
            Vx(aa,hh,jj,s,eetai) = vprimefunc(cmat(aa,hh,jj,s,eetai),lmat(aa,hh,jj,s,eetai))/(1.0d0+ind_fb(jj)*zzeta*f)**(mmu*(1.0d0-ssigma))
            call polint(agrid(jj+1,:,s),V(:,hh,jj+1,s,1),amat(aa,hh,jj,s,eetai),Vprime(1),dy)
            call polint(agrid(jj+1,:,s),V(:,hh,jj+1,s,2),amat(aa,hh,jj,s,eetai),Vprime(2),dy)
            V(aa,hh,jj,s,eetai)= util(cmat(aa,hh,jj,s,eetai)/(1.0d0+ind_fb(jj)*zzeta*f),lmat(aa,hh,jj,s,eetai))&
            +bbeta*varphi(jj)*sum(pii(s,eetai,:)*Vprime(:))
          endif
        enddo

      enddo

    endif

    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! retirement stage
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  elseif (jr<=jj .and. jj<jend) then

    do hh=1,hnum

      cmatf(:)=(bbeta*RR*Vrx(:,hh,jj+1,s)/mmu)**(1.0d0/(mmu*(1.0d0-ssigma)-1.0d0))
      smatf(:)=agrid(jj+1,:,s)
      amatf(:)=(smatf(:)+(1.0d0+tauc)*cmatf(:)-pinterp(s,hhm(hh))-Z)/RR*varphi(jj-1)

      do aa=1,anum
        if (agrid(jj,aa,s)<amatf(1)) then
          crmat(aa,hh,jj,s)=max((RR*agrid(jj,aa,s)/varphi(jj-1)+Z+pinterp(s,hhm(hh))-agrid(jj+1,1,s))/(1.0d0+tauc),m)
          armat(aa,hh,jj,s)=agrid(jj+1,1,s)
        else
          call polint(amatf(:),cmatf(:),agrid(jj,aa,s),crmat(aa,hh,jj,s),dy)
          call polint(amatf(:),smatf(:),agrid(jj,aa,s),armat(aa,hh,jj,s),dy)
          crmat(aa,hh,jj,s)=max(crmat(aa,hh,jj,s),m)
        endif
      enddo

      do aa=1,anum
        Vrx(aa,hh,jj,s) = vprimefunc(crmat(aa,hh,jj,s),1.0_dp)
        call polint(agrid(jj+1,:,s),Vr(:,hh,jj+1,s),armat(aa,hh,jj,s),Vrprime,dy)
        Vr(aa,hh,jj,s) = util(crmat(aa,hh,jj,s),1.0_dp)+bbeta*varphi(jj)*Vrprime
      enddo

    enddo

    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  elseif (jj==jend) then

    do hh=1,hnum
      crmat(:,hh,jj,s) = max(agrid(jj,:,s)*RR/varphi(jj-1)+pinterp(s,hhm(hh))+Z,m)
      do aa=1,anum
        Vr(aa,hh,jj,s) = util(crmat(aa,hh,jj,s),1.0_dp)
        Vrx(aa,hh,jj,s) = vprimefunc(crmat(aa,hh,jj,s),1.0_dp)
      enddo
      armat(:,hh,jj,s) = 0.0d0
    enddo

  endif


  contains

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! transfer
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  function bsolve(x)

    use globals
    use nr, only : polint
    USE nrtype
    use interface, only : util

    implicit none

    REAL(DP), INTENT(IN) :: x
    REAL(DP) :: bsolve

    smatf(xx)=agridjf(xx,s)-x*f

    call polint(agrid(jj+1,:,s),V(:,hh,jj+1,s,1),smatf(xx),Vprime(1),dy)
    call polint(agrid(jj+1,:,s),V(:,hh,jj+1,s,2),smatf(xx),Vprime(2),dy)

    if (ww(hh)*hbase < q1) then
      call polint(agrid(ja,:,2),V00(:,hc,1),x,V00prime,dy)
    elseif (ww(hh)*hbase < q2) then
      call polint(agrid(ja,:,2),V00(:,hc,2),x,V00prime,dy)
    else
      call polint(agrid(ja,:,2),V00(:,hc,3),x,V00prime,dy)
    endif
    bsolve=-(bbeta*varphi(jj)*sum(pii(s,eetai,:)*Vprime(:))+vv*V00prime)

  end function bsolve

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! savings of first period
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  function ssolve(x)

    use globals
    use nr, only : polint
    USE nrtype
    use interface, only : util

    implicit none

    REAL(DP), INTENT(IN) :: x
    REAL(DP) :: ssolve

    csmat(aa,thetah,qq,jj,eetai,ke) = max((agrid(jj,aa,s)-tuition+grants(jj,hhm(thetah),qq)&
      +Z+mp*(1.0d0-stime)-x)/(1.0d0+tauc+mp*lcons),m**3)
    lsmat(aa,thetah,qq,jj,eetai,ke)=lcons*csmat(aa,thetah,qq,jj,eetai,ke)

    if (csmat(aa,thetah,qq,jj,eetai,ke)*lcons>1.0d0-stime) then
      csmat(aa,thetah,qq,jj,eetai,ke) = max((agrid(jj,aa,s)-tuition+grants(jj,hhm(thetah),qq)+Z-x+trans0)/(1.0d0+tauc),m**3)
      lsmat(aa,thetah,qq,jj,eetai,ke)=1.0d0-stime
    endif

    call polint(agrid(jj+1,:,s),EVp(:,thetah,qq,jj+1,1,ke),x,Vsprime(1),dy)
    call polint(agrid(jj+1,:,s),EVp(:,thetah,qq,jj+1,2,ke),x,Vsprime(2),dy)

    Vs(aa,thetah,qq,jj,eetai,ke) = util(csmat(aa,thetah,qq,jj,eetai,ke),lsmat(aa,thetah,qq,jj,eetai,ke))&
    +bbeta*sum(pis(s,:)*Vsprime(:))

    ssolve=-Vs(aa,thetah,qq,jj,eetai,ke)

  end function ssolve

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! derivative of value function (without (1+r))
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  function vprimefunc(cv,lv)

    use globals
    use nr, only : polint
    USE nrtype

    implicit none

    real(dp), intent(in) :: cv, lv
    real(dp) :: vprimefunc

    vprimefunc=mmu*cv**(mmu*(1.0d0-ssigma)-1.0d0)*lv**((1.0d0-mmu)*(1.0d0-ssigma))

  end function vprimefunc

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

end subroutine valuev
