function welfare(xs)

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !!!!  Kazushige MATSUDA
  !!!!  "Optimal Timing of College Subsidies"
  !!!!
  !!!!
  !!!!  Routine to solve for equilibrium to maximize the number of colelge graduates/welfare
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  use nrtype
  use globals
  use interface, only :  modelsolution, util,param
  use nr, only : polint

  implicit none

  REAL(DP), DIMENSION(:), INTENT(IN) :: xs
  REAL(DP) :: welfare
  REAL(DP) :: distV0
  integer :: itt, fo=16, iii

  call param


  write(*,*) 'xs=', xs

  if (weltest==1) then
    if (size(xs)>8) then
      write(*,*) 'welfare size error'
      stop
    endif
    grants(ja,:,1)=exp(xs(8)+xs(2)+xs(6)*(hgrid2(:)-meanh))*grants0(ja,1,1)
    grants(ja,:,2)=exp(xs(8)+xs(6)*(hgrid2(:)-meanh))*grants0(ja,1,1)
    grants(ja,:,3)=exp(xs(8)+xs(3)+xs(6)*(hgrid2(:)-meanh))*grants0(ja,1,1)
    grants(ja+1,:,1)=exp(xs(8)+xs(1)+xs(4)+xs(7)*(hgrid3(:)-meanh))*grants0(ja,1,1)
    grants(ja+1,:,2)=exp(xs(8)+xs(1)+xs(7)*(hgrid3(:)-meanh))*grants0(ja,1,1)
    grants(ja+1,:,3)=exp(xs(8)+xs(1)+xs(5)+xs(7)*(hgrid3(:)-meanh))*grants0(ja,1,1)
  elseif (weltest==2) then
    if (size(xs)>7) then
      write(*,*) 'welfare size error'
      stop
    endif
    grantsopt(ja,:,1)=exp(xs(2)+xs(6)*(hgrid2(:)-meanh))*grants0(ja,1,1)
    grantsopt(ja,:,2)=exp(xs(6)*(hgrid2(:)-meanh))*grants0(ja,1,1)
    grantsopt(ja,:,3)=exp(xs(3)+xs(6)*(hgrid2(:)-meanh))*grants0(ja,1,1)
    grantsopt(ja+1,:,1)=exp(xs(1)+xs(4)+xs(7)*(hgrid3(:)-meanh))*grants0(ja,1,1)
    grantsopt(ja+1,:,2)=exp(xs(1)+xs(7)*(hgrid3(:)-meanh))*grants0(ja,1,1)
    grantsopt(ja+1,:,3)=exp(xs(1)+xs(5)+xs(7)*(hgrid3(:)-meanh))*grants0(ja,1,1)
  elseif (weltest==3) then
    if (size(xs)>9) then
      write(*,*) 'welfare size error'
      stop
    endif
    grants(ja,:,1)=exp(xs(8)+xs(2)+xs(6)*(hgrid2(:)-meanh))*grants0(ja,1,1)
    grants(ja,:,2)=exp(xs(8)+xs(6)*(hgrid2(:)-meanh))*grants0(ja,1,1)
    grants(ja,:,3)=exp(xs(8)+xs(3)+xs(6)*(hgrid2(:)-meanh))*grants0(ja,1,1)
    grants(ja+1,:,1)=exp(xs(8)+xs(1)+xs(4)+xs(7)*(hgrid3(:)-meanh))*grants0(ja,1,1)
    grants(ja+1,:,2)=exp(xs(8)+xs(1)+xs(7)*(hgrid3(:)-meanh))*grants0(ja,1,1)
    grants(ja+1,:,3)=exp(xs(8)+xs(1)+xs(5)+xs(7)*(hgrid3(:)-meanh))*grants0(ja,1,1)
    d = xs(9)
  elseif (weltest==5) then
    if (size(xs)>1) then
      write(*,*) 'welfare size error'
      stop
    endif
    grantsopt(ja,:,1)=grants0(ja,1,1)
    grantsopt(ja,:,2)=grants0(ja,1,2)
    grantsopt(ja,:,3)=grants0(ja,1,3)
    grantsopt(ja+1,:,1)=exp(xs(1))*grants0(ja,1,1)
    grantsopt(ja+1,:,2)=exp(xs(1))*grants0(ja,1,2)
    grantsopt(ja+1,:,3)=exp(xs(1))*grants0(ja,1,3)
  elseif (weltest==6) then
    if (size(xs)>7) then
      write(*,*) 'welfare size error'
      stop
    endif
    grants(ja,:,1)=exp(xs(6)+xs(2))*grants0(ja,1,1)
    grants(ja,:,2)=exp(xs(6))*grants0(ja,1,1)
    grants(ja,:,3)=exp(xs(6)+xs(3))*grants0(ja,1,1)
    grants(ja+1,:,1)=exp(xs(6)+xs(1)+xs(4))*grants0(ja,1,1)
    grants(ja+1,:,2)=exp(xs(6)+xs(1))*grants0(ja,1,1)
    grants(ja+1,:,3)=exp(xs(6)+xs(1)+xs(5))*grants0(ja,1,1)
    d = xs(7)
  elseif (weltest==7) then
    if (size(xs)>3) then
      write(*,*) 'welfare size error'
      stop
    endif
    grantsopt(ja,:,1)=grants0(ja,1,1)
    grantsopt(ja,:,2)=grants0(ja,1,2)
    grantsopt(ja,:,3)=grants0(ja,1,3)
    grantsopt(ja+1,:,1)=exp(xs(1))*grants0(ja,1,1)
    grantsopt(ja+1,:,2)=exp(xs(1))*grants0(ja,1,2)
    grantsopt(ja+1,:,3)=exp(xs(1))*grants0(ja,1,3)
    Efix=xs(2)
    d=xs(3)
  elseif (weltest==8) then
    if (size(xs)>3) then
      write(*,*) 'welfare size error'
      stop
    endif
    grantsopt(ja,:,1)=grants0(ja,13,1)*exp(xs(1)*(hgrid2(:)-hgrid2(13)))
    grantsopt(ja,:,2)=grants0(ja,13,1)*exp(xs(2))*exp(xs(1)*(hgrid2(:)-hgrid2(13)))
    grantsopt(ja,:,3)=grants0(ja,13,1)*exp(xs(3))*exp(xs(1)*(hgrid2(:)-hgrid2(13)))
    grantsopt(ja+1,:,1)=grants0(ja+1,13,1)*exp(xs(1)*(hgrid3(:)-hgrid3(13)))
    grantsopt(ja+1,:,2)=grants0(ja+1,13,1)*exp(xs(2))*exp(xs(1)*(hgrid3(:)-hgrid3(13)))
    grantsopt(ja+1,:,3)=grants0(ja+1,13,1)*exp(xs(3))*exp(xs(1)*(hgrid3(:)-hgrid3(13)))
  elseif (weltest==16) then
    if (size(xs)>2) then
      write(*,*) 'welfare size error'
      stop
    endif
    grantsopt(ja,:,1)=grants0(ja,13,1)
    grantsopt(ja,:,2)=grants0(ja,13,1)*exp(xs(1))
    grantsopt(ja,:,3)=grants0(ja,13,1)*exp(xs(2))
    grantsopt(ja+1,:,1)=grants0(ja+1,13,1)
    grantsopt(ja+1,:,2)=grants0(ja+1,13,1)*exp(xs(1))
    grantsopt(ja+1,:,3)=grants0(ja+1,13,1)*exp(xs(2))

  elseif (weltest==17) then
    if (size(xs)>3) then
      write(*,*) 'welfare size error'
      stop
    endif
    grantsopt(ja,:,1)=grants0(ja,13,1)
    grantsopt(ja,:,2)=grants0(ja,13,1)*exp(xs(1))
    grantsopt(ja,:,3)=grants0(ja,13,1)*exp(xs(2))
    grantsopt(ja+1,:,1)=exp(xs(3))*grants0(ja+1,13,1)
    grantsopt(ja+1,:,2)=exp(xs(3))*grants0(ja+1,13,1)*exp(xs(1))
    grantsopt(ja+1,:,3)=exp(xs(3))*grants0(ja+1,13,1)*exp(xs(2))

  elseif (weltest==9) then
    if (size(xs)>4) then
      write(*,*) 'welfare size error'
      stop
    endif
    grantsopt(ja,:,1)=grants0(ja,13,1)*exp(xs(1)*(hgrid2(:)-hgrid2(13)))
    grantsopt(ja,:,2)=grants0(ja,13,1)*exp(xs(2))*exp(xs(1)*(hgrid2(:)-hgrid2(13)))
    grantsopt(ja,:,3)=grants0(ja,13,1)*exp(xs(3))*exp(xs(1)*(hgrid2(:)-hgrid2(13)))
    grantsopt(ja+1,:,1)=exp(xs(4))*grants0(ja+1,13,1)*exp(xs(1)*(hgrid3(:)-hgrid3(13)))
    grantsopt(ja+1,:,2)=exp(xs(4))*grants0(ja+1,13,1)*exp(xs(2))*exp(xs(1)*(hgrid3(:)-hgrid3(13)))
    grantsopt(ja+1,:,3)=exp(xs(4))*grants0(ja+1,13,1)*exp(xs(3))*exp(xs(1)*(hgrid3(:)-hgrid3(13)))

  elseif (weltest==10) then
    if (size(xs)>3) then
      write(*,*) 'welfare size error'
      stop
    endif
    grantsopt(ja,:,1)=grants0(ja,1,1)
    grantsopt(ja,:,2)=grants0(ja,1,2)
    grantsopt(ja,:,3)=grants0(ja,1,3)
    grantsopt(ja+1,:,1)=exp(xs(1))*grants0(ja,1,1)
    grantsopt(ja+1,:,2)=exp(xs(1))*grants0(ja,1,2)
    grantsopt(ja+1,:,3)=exp(xs(1))*grants0(ja,1,3)
    bbase1=6125.0d0*exp(xs(2))
    bbase2=bbase*exp(xs(3))

  elseif (weltest==11) then
    if (size(xs)>1) then
      write(*,*) 'welfare size error'
      stop
    endif
    grantsopt(ja,:,1)=grants0(ja,1,1)
    grantsopt(ja,:,2)=grants0(ja,1,2)
    grantsopt(ja,:,3)=grants0(ja,1,3)
    grantsopt(ja+1,:,1)=grants0(ja,1,1)
    grantsopt(ja+1,:,2)=grants0(ja,1,2)
    grantsopt(ja+1,:,3)=grants0(ja,1,3)
    d=xs(1)
  elseif (weltest==12) then
    if (size(xs)>3) then
      write(*,*) 'welfare size error'
      stop
    endif
    grantsopt(ja,:,1)=grants0(ja,1,1)
    grantsopt(ja,:,2)=grants0(ja,1,2)
    grantsopt(ja,:,3)=grants0(ja,1,3)
    grantsopt(ja+1,:,1)=exp(xs(1))*grants0(ja,1,1)
    grantsopt(ja+1,:,2)=exp(xs(1))*grants0(ja,1,2)
    grantsopt(ja+1,:,3)=exp(xs(1))*grants0(ja,1,3)
    Efix=exp(xs(2))*Eeq
    d=xs(3)
  elseif (weltest==13) then
    if (size(xs)>2) then
      write(*,*) 'welfare size error'
      stop
    endif
    grantsopt(ja,:,1)=grants0(ja,1,1)
    grantsopt(ja,:,2)=grants0(ja,1,2)
    grantsopt(ja,:,3)=grants0(ja,1,3)
    grantsopt(ja+1,:,1)=grants0(ja,1,1)
    grantsopt(ja+1,:,2)=grants0(ja,1,2)
    grantsopt(ja+1,:,3)=grants0(ja,1,3)
    Efix=exp(xs(1))*Eeq
    d=xs(2)
  elseif (weltest==14) then
    if (size(xs)>4) then
      write(*,*) 'welfare size error'
      stop
    endif
    grantsopt(ja,:,1)=grants0(ja,1,1)
    grantsopt(ja,:,2)=grants0(ja,1,2)
    grantsopt(ja,:,3)=grants0(ja,1,3)
    grantsopt(ja+1,:,1)=exp(xs(1))*grants0(ja,1,1)
    grantsopt(ja+1,:,2)=exp(xs(1))*grants0(ja,1,2)
    grantsopt(ja+1,:,3)=exp(xs(1))*grants0(ja,1,3)
    Efix=exp(xs(2))*Eeq
    d=xs(3)
    trans0=xs(4)

  elseif (weltest==15) then
    if (size(xs)>1) then
      write(*,*) 'welfare size error'
      stop
    endif
    grantsopt(ja,:,1)=grants0(ja,1,1)
    grantsopt(ja,:,2)=grants0(ja,1,2)
    grantsopt(ja,:,3)=grants0(ja,1,3)
    grantsopt(ja+1,:,1)=grants0(ja,1,1)
    grantsopt(ja+1,:,2)=grants0(ja,1,2)
    grantsopt(ja+1,:,3)=grants0(ja,1,3)
    Efix=exp(xs(1))*Eeq

  elseif (weltest==18) then
    if (size(xs)>1) then
      write(*,*) 'welfare size error'
      stop
    endif
    grantsopt(ja,:,1)=grants0(ja,1,1)*exp(xs(1)*(hgrid2(:)-hgrid2(13)))
    grantsopt(ja,:,2)=grants0(ja,1,2)*exp(xs(1)*(hgrid2(:)-hgrid2(13)))
    grantsopt(ja,:,3)=grants0(ja,1,3)*exp(xs(1)*(hgrid2(:)-hgrid2(13)))
    grantsopt(ja+1,:,1)=grants0(ja,1,1)*exp(xs(1)*(hgrid3(:)-hgrid3(13)))
    grantsopt(ja+1,:,2)=grants0(ja,1,2)*exp(xs(1)*(hgrid3(:)-hgrid3(13)))
    grantsopt(ja+1,:,3)=grants0(ja,1,3)*exp(xs(1)*(hgrid3(:)-hgrid3(13)))

  elseif (weltest==19) then
    if (size(xs)>3) then
      write(*,*) 'welfare size error'
      stop
    endif
    grantsopt(ja,:,1)=grants0(ja,1,1)*exp(xs(1)*(hgrid2(:)-hgrid2(13)))
    grantsopt(ja,:,2)=grants0(ja,1,2)*exp(xs(1)*(hgrid2(:)-hgrid2(13)))
    grantsopt(ja,:,3)=grants0(ja,1,3)*exp(xs(1)*(hgrid2(:)-hgrid2(13)))
    grantsopt(ja+1,:,1)=grants0(ja,1,1)*exp(xs(3)+xs(2)*(hgrid3(:)-hgrid3(13)))
    grantsopt(ja+1,:,2)=grants0(ja,1,2)*exp(xs(3)+xs(2)*(hgrid3(:)-hgrid3(13)))
    grantsopt(ja+1,:,3)=grants0(ja,1,3)*exp(xs(3)+xs(2)*(hgrid3(:)-hgrid3(13)))

  elseif (weltest==21) then
    if (size(xs)>2) then
      write(*,*) 'welfare size error'
      stop
    endif
    grantsopt(ja,:,1)=grants0(ja,1,1)*exp(xs(1)/stddh*(hgrid2(:)-hgrid2(13)))
    grantsopt(ja,:,2)=grants0(ja,1,2)*exp(xs(1)/stddh*(hgrid2(:)-hgrid2(13)))
    grantsopt(ja,:,3)=grants0(ja,1,3)*exp(xs(1)/stddh*(hgrid2(:)-hgrid2(13)))
    grantsopt(ja+1,:,1)=exp(xs(2))*grants0(ja,1,1)*exp(xs(1)/sqrt(stddh**2+stddc**2)*(hgrid3(:)-hgrid3(13)))
    grantsopt(ja+1,:,2)=exp(xs(2))*grants0(ja,1,2)*exp(xs(1)/sqrt(stddh**2+stddc**2)*(hgrid3(:)-hgrid3(13)))
    grantsopt(ja+1,:,3)=exp(xs(2))*grants0(ja,1,3)*exp(xs(1)/sqrt(stddh**2+stddc**2)*(hgrid3(:)-hgrid3(13)))

  elseif (weltest==20) then
    if (size(xs)>5) then
      write(*,*) 'welfare size error'
      stop
    endif
    grantsopt(ja,:,1)=grants0(ja,13,1)
    grantsopt(ja,:,2)=grants0(ja,13,1)*exp(xs(1))
    grantsopt(ja,:,3)=grants0(ja,13,1)*exp(xs(2))
    grantsopt(ja+1,:,1)=exp(xs(3))*grants0(ja+1,13,1)
    grantsopt(ja+1,:,2)=exp(xs(4))*grants0(ja+1,13,1)*exp(xs(1))
    grantsopt(ja+1,:,3)=exp(xs(5))*grants0(ja+1,13,1)*exp(xs(2))
  elseif (weltest==22) then
    if (size(xs)>1) then
      write(*,*) 'welfare size error'
      stop
    endif
    grantsopt(ja,:,1)=grants0(ja,1,1)*exp(xs(1)/stddh*(hgrid2(:)-hgrid2(13)))
    grantsopt(ja,:,2)=grants0(ja,1,2)*exp(xs(1)/stddh*(hgrid2(:)-hgrid2(13)))
    grantsopt(ja,:,3)=grants0(ja,1,3)*exp(xs(1)/stddh*(hgrid2(:)-hgrid2(13)))
    grantsopt(ja+1,:,1)=grants0(ja,1,1)*exp(xs(1)/sqrt(stddh**2+stddc**2)*(hgrid3(:)-hgrid3(13)))
    grantsopt(ja+1,:,2)=grants0(ja,1,2)*exp(xs(1)/sqrt(stddh**2+stddc**2)*(hgrid3(:)-hgrid3(13)))
    grantsopt(ja+1,:,3)=grants0(ja,1,3)*exp(xs(1)/sqrt(stddh**2+stddc**2)*(hgrid3(:)-hgrid3(13)))
  endif


  calibflag=0

  dddddd=100.0d0
  V00(:,:,:) = 0.0d0
  V(:,:,:,:,:)=0.0d0
  Vr(:,:,:,:)=0.0d0
  Vs(:,:,:,:,:,:)=0.0d0

  if (wel==0) then

    K_LL=1.50079173836983
    H_LL1= 1.07139539710291
    LL_N=0.304150113493220
    taul=0.371030162822558
    ybar=0.274094708942250

    write(*,*) 'iteration  ', 'distance'

    do itt=1,40
      call modelsolution
      write(*,*) ITT, dddddd
      if (dddddd<tol) then
        exit
      endif
    enddo

  else


    K_LL=1.50031956688438
    H_LL1= 1.08238571840425
    LL_N=0.303577339609194
    taul=0.371164365544792
    grantprop = 0.792153797438533

    calibflag=0
    ! wel = 1
    write(*,*) 'iteration  ', 'distance'

    do itt=1,40
      call modelsolution
      write(*,*) ITT, dddddd
      if (dddddd<tol) then
        exit
      endif
    enddo

  endif

  write(*,*) 'r,w=', r,w
  write(*,*) 'rho', 1.0d0/sqrt((stddc/stddh)**2+1.0d0)
  write(*,*) 'school cost', lambda(ja,hhm(3),15)/sum(pppp0(:,:,:,:,:)*V00interp(:,:,:,:,:))
  write(*,*) 'P1=', P1
  write(*,*) 'P2=', P2
  write(*,*) 'P3=', P3
  write(*,*) 'demand=',(cchi+ddelta)*K/Y+sum(C)/Y+gy!+kappa*w(1)*Nvec(ja)*P1/Ynew
  write(*,*) 'taul=',taul

  write(*,*) 'topincome',w(1)*eeta(1,1)*aap(1,jb)*ghgrid(1,hnum)*hbase/YNeq*ybase
  write(*,*) 'bottomincome',w(3)*eeta(3,2)*aap(3,jb)*ghgrid(3,1)*hbase/YNeq*ybase
  write(*,*) 'population', sum(pp0(:,:,1)),sum(pp0(:,:,2)),sum(pp0(:,:,3))


  Vleis(:,:,jb+1:jr-1,:,:)=Vinterp(:,:,jb+1:jr-1,:,:)

  ! if (paternalistic==1 .and. heterostddc==0) then
  popw(:,:,:,:,:) = 0.0d0
  popr(:,:,:,:)=0.0d0
  V00leis(:,:,:) = 0.0d0
  distV0 = 2000.0d0
  do iii=1,30
    if (distV0 < tol) exit
    do jj=jb,ja,-1
      do s=snum,1,-1
        if (jj==jb) then
          do eetai=1,2
            do hh=1,hnum2
              do aa=1,anum2
                do hc=1,hnum2
                  wwinterp(hh)=w(s)*eeta(s,eetai)*aap(s,jj)*ghgridinterp(s,hh)

                  call polint(agrid2(jj+1,:,s),Vinterp(:,hh,jj+1,s,1),amatjfinterp(aa,hh,hc,s,eetai),Vprime(1),dy)
                  call polint(agrid2(jj+1,:,s),Vinterp(:,hh,jj+1,s,2),amatjfinterp(aa,hh,hc,s,eetai),Vprime(2),dy)
                  if (wwinterp(hh)*hbase < q1) then
                    qq3=1
                  elseif (wwinterp(hh)*hbase < q2) then
                    qq3=2
                  else
                    qq3=3
                  endif
                  call polint(agrid2(ja,:,2),V00leis(:,hc,qq3),bmatjfinterp(aa,hh,hc,s,eetai),V00prime,dy)
                  Vauxinterp(aa,hh,hc)= util(cmatjfinterp(aa,hh,hc,s,eetai),lmatjfinterp(aa,hh,hc,s,eetai))&
                  + bbeta*varphi(jj)*sum(pii(s,eetai,:)*Vprime(:))+vv*V00prime
                enddo
                Vleis(aa,hh,jj,s,eetai) = sum(psiem(:,s,hh)*Vauxinterp(aa,hh,:))
              enddo
            enddo
          enddo
        elseif (jy(s)<=jj .and. jj<jb) then
          do eetai=1,2
            do hh=1,hnum2
              do aa=1,anum2
                call polint(agrid2(jj+1,:,s),Vleis(:,hh,jj+1,s,1),amatinterp(aa,hh,jj,s,eetai),Vprime(1),dy)
                call polint(agrid2(jj+1,:,s),Vleis(:,hh,jj+1,s,2),amatinterp(aa,hh,jj,s,eetai),Vprime(2),dy)
                Vleis(aa,hh,jj,s,eetai)= util(cmatinterp(aa,hh,jj,s,eetai)/(1.0d0+ind_fb(jj)*zzeta*f),lmatinterp(aa,hh,jj,s,eetai))&
                + bbeta*varphi(jj)*sum(pii(s,eetai,:)*Vprime(:))
              enddo
            enddo
          enddo
        elseif (s==1 .and. jj==ja+1) then
          do eetai=1,2
            do ke=1,kenum
              do qq=1,qnum
                do hh=1,hnum2
                  do aa=1,anum2
                    call polint(agrid2(jj+1,:,s),Vleis(:,hh,jj+1,s,1),asmatinterp(aa,hh,qq,jj,eetai,ke),Vprime(1),dy)
                    call polint(agrid2(jj+1,:,s),Vleis(:,hh,jj+1,s,2),asmatinterp(aa,hh,qq,jj,eetai,ke),Vprime(2),dy)

                    Vleise(aa,hh,qq,jj,eetai,ke)= util(csmatinterp(aa,hh,qq,jj,eetai,ke),lsmatinterp(aa,hh,qq,jj,eetai,ke))&
                    + bbeta*varphi(jj)*sum(pis(s,:)*Vprime(:))

                    do thetah=1,hnum2
                      ! if (agrid2(jj,aa,s) < 0.0d0) then
                      !   call polint(agrid2(jj,:,s),Vleis(:,thetah,jj,2,eetai),agrid2(jj,aa,s)*factor,Vwork,dy)
                      ! else
                      Vwork=Vleis(aa,thetah,jj,2,eetai)
                      ! endif
                      Veduc2=Vleise(aa,hh,qq,jj,eetai,ke)+lambda(jj,hh,ke)
                      Vleis2(aa,hh,qq,jj,eetai,ke)=Vleise(aa,hh,qq,jj,eetai,ke)+lambda(jj,hh,ke)
                      Vleispe(aa,hh,qq,jj,eetai,ke,thetah)=(1.0d0-Ipinterp(aa,hh,qq,jj,eetai,ke,thetah))*Vwork+Ipinterp(aa,hh,qq,jj,eetai,ke,thetah)*Veduc2
                    enddo
                  enddo
                enddo
              enddo
            enddo
            do ke=1,kenum
              do qq=1,qnum
                do thetah=1,hnum2
                  do aa=1,anum2
                    EVleispe(aa,thetah,qq,jj,eetai,ke)=sum(pepmat(thetah,:)*Vleispe(aa,:,qq,jj,eetai,ke,thetah))
                  enddo
                enddo
              enddo
            enddo
          enddo
        elseif (s==2 .and. jj==ja) then
          do ke=1,kenum
            do eetai=1,2
              do qq=1,qnum
                do hh=1,hnum2
                  do aa=1,anum2
                    call polint(agrid2(jj+1,:,s),EVleispe(:,hh,qq,jj+1,1,ke),asmatinterp(aa,hh,qq,jj,eetai,ke),Vsprime(1),dy)
                    call polint(agrid2(jj+1,:,s),EVleispe(:,hh,qq,jj+1,2,ke),asmatinterp(aa,hh,qq,jj,eetai,ke),Vsprime(2),dy)
                    Vleise(aa,hh,qq,jj,eetai,ke) = util(csmatinterp(aa,hh,qq,jj,eetai,ke),lsmatinterp(aa,hh,qq,jj,eetai,ke))+bbeta*sum(pis(s,:)*Vsprime(:))
                  enddo
                enddo
              enddo
            enddo
          enddo
          do qq=1,qnum
            do hh=1,hnum2
              do aa=1,anum2
                do ke=1,kenum
                  do eetai=1,2
                    Veduc1=Vleise(aa,hh,qq,jj,eetai,ke)+lambda(jj,hh,ke)
                    Vleis2(aa,hh,qq,jj,eetai,ke)=Vleise(aa,hh,qq,jj,eetai,ke)+lambda(jj,hh,ke)
                    V00leisnews(aa,hh,qq,eetai,ke)=(1.0d0-I12pinterp(aa,hh,qq,eetai,ke))*Vleis(aa,hh,ja,3,eetai)+I12pinterp(aa,hh,qq,eetai,ke)*Veduc1
                  enddo
                enddo
                V00leisnew(aa,hh,qq)=pis(3,1)*sum(pike(:)*V00leisnews(aa,hh,qq,1,:))+pis(3,2)*sum(pike(:)*V00leisnews(aa,hh,qq,2,:))
              enddo
            enddo
          enddo
        endif
      enddo
    enddo

    distV0 = abs(maxval(maxval(maxval(abs(V00leisnew-V00leis),1),1),1))
    V00leis = V00leisnew

    if (iii>=30  .and. distV0>0.1d0) then
      write(*,*) 'V00aux3 maxit'
      stop
    endif

  enddo
  SWF2=sum(pppp0(:,:,:,:,:)*V00leisnews(:,:,:,:,:))


  if (CEVallind==1) then
    if (ppwfixed==1) then
      do jj=ja,jr-1
        popweq(:,:,jj,:,:) = Nvec(jj)*ppweq(:,:,jj,:,:)
      enddo
      do jj=jr,jend
        popreq(:,:,jj,:)=Nvec(jj)*ppreq(:,:,jj,:)
      enddo
      SWF2=Nvec(ja)*sum(ppwseq(:,:,:,ja,2,:,:)*Vleis2(:,:,:,ja,:,:))+Nvec(ja+1)*sum(ppwseq(:,:,:,ja+1,1,:,:)*Vleis2(:,:,:,ja+1,:,:))&
      +sum(popweq(:,:,ja:jr-1,3,:)*Vleis(:,:,ja:jr-1,3,:))+sum(popweq(:,:,ja+1:jr-1,2,:)*Vleis(:,:,ja+1:jr-1,2,:))&
      +sum(popweq(:,:,ja+2:jr-1,1,:)*Vleis(:,:,ja+2:jr-1,1,:))+sum(popreq(:,:,jr:jend,:)*Vrinterp(:,:,jr:jend,:))
    else
      do jj=ja,jr-1
        popw(:,:,jj,:,:) = Nvec(jj)*ppw(:,:,jj,:,:)
      enddo
      do jj=jr,jend
        popr(:,:,jj,:)=Nvec(jj)*ppr(:,:,jj,:)
      enddo
      if (omitj2==1) then
        ! SWF2=Nvec(ja)*sum(ppws(:,:,:,ja,2,:,:)*Vleis2(:,:,:,ja,:,:))&
        ! +sum(popw(:,:,ja,3,:)*Vleis(:,:,ja,3,:))+sum(popw(:,:,ja+2:jr-1,3,:)*Vleis(:,:,ja+2:jr-1,3,:))+sum(popw(:,:,ja+2:jr-1,2,:)*Vleis(:,:,ja+2:jr-1,2,:))&
        ! +sum(popw(:,:,ja+2:jr-1,1,:)*Vleis(:,:,ja+2:jr-1,1,:))+sum(popr(:,:,jr:jend,:)*Vrinterp(:,:,jr:jend,:))
        SWF2=sum(popw(:,:,ja+2:jr-1,3,:)*Vleis(:,:,ja+2:jr-1,3,:))+sum(popw(:,:,ja+2:jr-1,2,:)*Vleis(:,:,ja+2:jr-1,2,:))&
        +sum(popw(:,:,ja+2:jr-1,1,:)*Vleis(:,:,ja+2:jr-1,1,:))+sum(popr(:,:,jr:jend,:)*Vrinterp(:,:,jr:jend,:))
      else
        SWF2=Nvec(ja)*sum(ppws(:,:,:,ja,2,:,:)*Vleis2(:,:,:,ja,:,:))+Nvec(ja+1)*sum(ppws(:,:,:,ja+1,1,:,:)*Vleis2(:,:,:,ja+1,:,:))&
        +sum(popw(:,:,ja:jr-1,3,:)*Vleis(:,:,ja:jr-1,3,:))+sum(popw(:,:,ja+1:jr-1,2,:)*Vleis(:,:,ja+1:jr-1,2,:))&
        +sum(popw(:,:,ja+2:jr-1,1,:)*Vleis(:,:,ja+2:jr-1,1,:))+sum(popr(:,:,jr:jend,:)*Vrinterp(:,:,jr:jend,:))
      endif
    endif
  endif

  welfare = -SWF2

  if (dddddd > 0.03d0) then
    welfare=1000000000
  endif

end function welfare
